package edu.wpi.cs.dsrg.demo.raindropdemo;


import edu.wpi.cs.dsrg.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import java.util.Hashtable;
import javax.swing.*;

import edu.wpi.cs.dsrg.xmldb.xat.testfiles.TestSXE;
import edu.wpi.cs.dsrg.xmldb.xat.testing.*;

import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AutoDistiller;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RaindropPhysicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RaindropLogicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.testing.TestCases;

import edu.wpi.cs.dsrg.xmldb.xat.component.xatdaggeneration.DagParserTraverse;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatdaggeneration.DagQueryDecorrelation;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.*;
import xacute.quilt.*;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;






import java.util.HashSet;
import java.util.Set;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDagImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.ColumnNameNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.ColumnNameNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.RootNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.RootNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.TagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.TagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.TerminalExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnNameImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.SourceImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Select;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.SelectImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnestImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Tagger;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.TaggerImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NavigationStep;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NodeStepImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.VarStepImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression.BinCOMPExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.DOMPatternImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.Pattern;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.GrappaCreator;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.NodeContainer;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.NodeListener;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.ProcessStep;









/**
 * Insert the type's description here.
 * @Createdate: 2004 by Underdog
 */
public class RDPhyPlanGenStep extends ProcessRDStep {
	protected java.lang.String userQuery;
	protected java.lang.String viewQuery;
	protected java.lang.String queryToUse;
	protected int mappingSet;
	protected int paraSet;
	protected int paraSet2;
/**
 * GenerationStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public RDPhyPlanGenStep(XATTree userXAT, XATTree viewXAT, String userQ, String viewQ, int mappingWay, int paraNum, int paraNum2) {
	super(userXAT, viewXAT);
	userQuery = userQ;
	viewQuery = viewQ;
	setTabName("Physical Plan!");
	setTabTip("Generate the Raindrop Physical Plan");
	setContentPane(new JSplitPane(JSplitPane.VERTICAL_SPLIT));
	JSplitPane thisPane = (JSplitPane)getContentPane();
	thisPane.setOneTouchExpandable(true);
	thisPane.setDoubleBuffered(true);
	mappingSet = mappingWay;
	paraSet = paraNum;
	paraSet2 = paraNum2;
}
/**
 * GenerationStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public RDPhyPlanGenStep(XATTree userXAT, String userQ, int mappingWay, int paraNum, int paraNum2) {
	super(userXAT);
	userQuery = userQ;
	setTabName("Physical Plan");
	setTabTip("Generate the Raindrop Physical Plan");
	setContentPane(new JScrollPane());
	mappingSet = mappingWay;
	paraSet = paraNum;
	paraSet2 = paraNum2;
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected JPanel execute(int queryType) {
	


	QuiltParser parser = new QuiltParser();
	QuiltQuery qq = null;
    
	// create a dummy tree Used to handle only one query is available.
	XATTree tree = new XATTreeImp();
	
	NodeContainer nc;
	NodeListener nl;
	GrappaPanel gp;
	DagParserTraverse pt1 = new DagParserTraverse();

	
	System.setProperty(
		edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.OperatorFactory.factoryID,
		"edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.PersistentOperatorFactory");
	
	//System.setProperty(OperatorFactory.factoryID, "edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.StreamOperatorFactory");
		
	// a flag to decide wether we will skip the Tree generation of this current query (e.g., user/view).
	boolean skip = false; //default is not.

	// if the getQueryToUse() is empty, or null, skip the parsing and generate an empty tree.
	String queryToUse = getQueryToUse();
	if (queryToUse == null) {
		skip = true;
	} else if (queryToUse.length() == 0) {
		skip = true;
	}

	try {

		if (!skip) {
			qq = parser.parseQuery(getQueryToUse());
			pt1.visit(qq);
			tree = pt1.getTree();
		}
	
	   	   
	   //step works, could be done by a function in the testpackage of raindrop
	   DagQueryDecorrelation qd = new DagQueryDecorrelation((XATDag)tree);
	   tree = qd.getDecorTree();
	   BindingTableComputer btc = new BindingTableComputer();
	   BindingTable bt = btc.computeBindingTable( tree );
	   tree.setBindingTable(bt);		
	   tree = TestSXE.treeRewrite(tree);
	   tree = TestSXE.treeSchema(tree);
	   
	   System.setProperty("DATA_MODEL", "XATMemoryQueueImp");	      
	   
	   //generator getting phy plan. not useful for the logical drawing
	   XATDag rainbowDagCopy = (XATDag)tree.clone();	
	   XATDag phyDag =
		 UtilForTesting.genPhyXATDag(rainbowDagCopy, mappingSet, paraSet, paraSet2);	
		 
		 
		 
		
	     
	   /*  
	   //generating the logical plan, also could be done by a function in testpackage of Raindrop
	   RaindropLogicalPlanGenerator planOptionGen = new RaindropLogicalPlanGenerator(mappingSet);	   
	   XATDag raindropPlan = planOptionGen.generatePlan(tree);
	   RaindropPhysicalPlanGenerator phyGen =
	   new RaindropPhysicalPlanGenerator();
	      XATDag phyPlan = phyGen.generatePhyPlan(raindropPlan);//dummy phy, not useful
	   XATDag drawRaindropPlan = UtilForTesting.refineLogicalPlan(raindropPlan);
		*/  
	  

	   System.out.println(".......................................................");
	   //+ paraSet +"-"+paraSet2 + "!!!!!!");
	   

		// create a new GrappaPanel from this XAT
		GrappaCreator gc = new GrappaCreator(rainbowDagCopy, true);
		gp = gc.getGrappaPanel();
		nc = gc.getNodeContainer();
		nl = gc.getNodeListener();

		if (queryType == this.USER_QUERY) {
			if (!skip)
				setUserBindingTable(pt1.getTree().getBindingTable());
			else { // create an empty hashtable.
				setUserBindingTable(new BindingTable());
			}
			setUserTree(tree);
			setUserGrappaPanel(gp);
			setUserNodeContainer(nc);
			setUserNodeListener(nl);
		} else {
			if (!skip)
				setViewBindingTable(pt1.getTree().getBindingTable());
			else { // create an empty hashtable.
				setViewBindingTable(new BindingTable());
			}
			setViewTree(tree);
			setViewGrappaPanel(gp);
			setViewNodeContainer(nc);
			setViewNodeListener(nl);
		}
		return gp;
	} catch (Exception e) {
		e.printStackTrace(System.out);
	}

	return null;

}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 */
public JPanel executeUser() {
	if(!isUserDone()){
		setUserDone(true);
		setQueryToUse(userQuery);
		return execute(USER_QUERY);	
	}
	else return getUserGrappaPanel();
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 */
public JPanel executeView() {
	if(!isViewDone()){
		setViewDone(true);
		setQueryToUse(viewQuery);
		return execute(VIEW_QUERY);
	} else return getViewGrappaPanel();
}
/**
 * Insert the method's description here.
 * 
 * @return java.lang.String
 */
protected java.lang.String getQueryToUse() {
	return queryToUse;
}
/**
 * Insert the method's description here.
 * 
 * @param newQueryToUse java.lang.String
 */
protected void setQueryToUse(java.lang.String newQueryToUse) {
	queryToUse = newQueryToUse;
}
}
