package edu.wpi.cs.dsrg.xmldb.xat.common.calculators;


/**
 * Insert the type's description here.
 * Creation date: (5/19/2003 11:55:02 AM)
 * @author: Tim Sutherland
 */
public class FreeMemoryCalculator extends edu.wpi.cs.dsrg.xmldb.xat.component.statisticsgatherer.StatisticsObject {
/**
 * OldestTupleInQueue constructor comment.
 */
public FreeMemoryCalculator() {
	super();
}
/**
 * OldestTupleInQueue constructor comment.
 * @param name java.lang.String
 * @param queryObject edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject
 */
public FreeMemoryCalculator(String name, edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATQueryObject queryObject) {
	super(name, queryObject);
}
/**
 * Calculates the new Value of the given property of this operator.  This
 * should be overwritten by subclasses who can tailor this method to calculating 1
 * specific property. <p>
 * This method should update at least the local propertyValue and possibly the
 * value with the operator The entire StatisticsGatherer is available for assistance.   <p>
 *
 * The procedure for calculating new values should be as follows:
 *
 * <ol>
 * <li> Consult the statsTable for any propertyValues that are needed.
 * <li> Perform the required calculations using the propertyValues from step 1
 * <li> Update the local propertyValue.
 * 
 * <li> Update the lastTimeUpdated value by using <tt>lastTimeUpdated = System.currentTimeMillis();</tt>
 * </ol> 
 */
public void calculateNewValue() {

	Runtime rt = Runtime.getRuntime();
	
	double freeMem = ((double) rt.freeMemory()) / 1048576.0;
	
	this.setPropertyValue("" + freeMem);	
	
}
}
