package edu.wpi.cs.dsrg.xmldb.xat.common.dag;

import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;

/**
 * Insert the type's description here.
 * Creation date: (9/25/02 4:17:14 PM)
 * @author: Xin Zhang
 */
public interface XATDag extends XATTree {
/**
 * Adds a new root to the Dag.  This will be added to the right of the others
 * @param newRoot edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode
 */
void addRoot(DagNode newRoot);
public void cleanup();
void deleteRoot(DagNode node);
/**
 * Insert the method's description here.
 * Creation date: (1/31/03 4:48:34 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode
 * @param i int
 */
DagNode getNthRoot(int i);
/**
 * Returns true if node is a root node; false otherwise.
 * @return boolean
 */
public boolean isRoot(DagNode node);
/**
 * Insert the method's description here.
 * Creation date: (1/31/03 4:49:28 PM)
 * @param i int
 * @param newRoot edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode
 */
void setNthRoot(int i, DagNode newRoot);
void addNode(DagNode child, DagNode newparent);

}
