package edu.wpi.cs.dsrg.xmldb.xat.common.operator;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//	Rainbow 1.0 - XQuery Processing.
//
//	Copyright 2003, All Rights Reserved.
//
//	Permission to use, copy, modify and distribute this software and
//	its documentation for educational, research and non-profit
//	purposes, without fee, and without a written agreement is hereby
//	granted, provided that this copyright notice appear in all copies.
//
//	Permission to incorporate this software into commercial products
//	may be obtained directly from the authors.
//
//	This software is provided "as is" without express or implied warranty.
//	In no event will the authors be held liable for any damages arising
//	from the use of this software.
//
//	Authors:
//	Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//	Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//	Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//	Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//		Computer Science Department
//		Worcester Polytechnic Institute
//		Worcester, MA 01609 USA
//
//		http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//	Send bug reports, bug fixes, enhancements, requests, or comments to
//	the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

import java.util.Enumeration;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.common.exception.XATNodeDoesNotExistException;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataSource;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATTable;

/**
 * @author lingw
 *
 * To change the template for this generated type comment go to
 * Window>Preferences>Java>Code Generation>Code and Comments
 */
public class XATMultiParentOperatorImp
	extends XATOperatorImp
	implements XATMultiParentOperator {

	/**
	 * 
	 */
	public XATMultiParentOperatorImp(XATNode init) {
		super(init);
		// TODO Auto-generated constructor stub
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATMultiParentOperator#getDataSourceAt(int)
	 */
	public XATDataSource getDataSource() {
		try {
			return this.getNode().getChild(0).getOperator().getOutputDataSource();
		} catch (XATNodeDoesNotExistException e) {
			e.printStackTrace();
			return null;
		}
	}
}
