package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator;

import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.navigation.NavigationStep;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.automata
	.storemanager
	.XATKeyDataValue;
/**
 * Insert the type's description here.
 * Creation date: (1/30/2003 5:38:56 PM)
 * @author: Hong Su
 */
public class OuterExtractByCollectionStream
	extends ExtractByCollectionStreamImp  
	{
	XATKeyDataValue[] placeHolder= new XATKeyDataValue[1];
	
	
	/**
	 * @param node
	 * @param ep
	 * @param dest
	 */
	public OuterExtractByCollectionStream(XATNode node, NavigationStep[] ep, NavigationStep[] dest) {
		super(node, ep, dest);
		placeHolder[0] = new XATKeyDataValue("");
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.ExtractStream#runGroupBy()
	 */
	public List runGroupBy() {
		List tempResult = new ArrayList();
		//	itemCountWithinEntry = 0;

		if (accummulateSubTuples[0].size() > 0) {
			//get sth that can be output
			XATKeyDataValue[] subTupleContentHolder =
				new XATKeyDataValue[accummulateSubTuples.length];

			for (int i = 0; i < accummulateSubTuples.length; i++) {

				subTupleContentHolder[i] =
					new XATKeyDataValue(((ArrayList)accummulateSubTuples[i]).clone());
				accummulateSubTuples[i].clear();
			}

			tempResult.add(new XATTupleImp(subTupleContentHolder));
			//	outputCount++;

		}else{
			tempResult.add(placeHolder);
		}

		return tempResult;
	}

	
}