package edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression;

import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.UniMinusExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class UniMinusExpressionStrImp extends ExpressionStrImp implements UniMinusExpressionStr
{
  ExpressionStr eValue;

/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 6:38:05 PM)
 * @param expr com.ibm.idl.constExpr.Expression
 */
public UniMinusExpressionStrImp(Expression expr) {
	ExpressionStrImp expressionStrImp = new ExpressionStrImp();
	
	eValue = expressionStrImp.createExpressionStr(((UniMinusExpressionImp)expr).getExpression());
	
	}
  public UniMinusExpressionStrImp(ExpressionStr exp)
  {
	eValue=exp;
    

  }
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 6:37:07 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 * @param expr edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression
 */
public ExpressionStr createExpressionStr(Expression expr) {
	return new UniMinusExpressionStrImp(expr);
}
 /**
	* It will evaluate itself and return the value as an object.
	* Remember, it could be like: Integer, Float, Double, String, Boolean.
	*/
public java.lang.Object eval(edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator xopOper, int[] iPositions) {
	return null;
}
  public Object eval(List tuples, XATStreamOperator op)
  {
	try
	{
	  return new Long(-((Long) eValue.eval(tuples, op)).longValue());
	}
	catch(ClassCastException e)
	{
		try
		{
		  return new Double(-((Number) eValue.eval(tuples, op)).doubleValue());
		}
		catch(ClassCastException e2)
		{
		  /* fail */
		  return null;
		}
	}

  }
/**
 * Insert the method's description here.
 * Creation date: (4/22/2003 9:00:49 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 */
public ExpressionStr getEValue() {
	return eValue;
}
  public ExpressionStr getExpression()
  {
	return eValue;
  }
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 4:30:01 PM)
 * @return java.util.Vector
 */
public java.util.Vector getTerminalColumnExprs() {
	Vector results = new Vector();
	results.addAll(eValue.getTerminalColumnExprs());
	return results;
}
  public void setExpression(ExpressionStr exp)
  {
	 eValue=exp;
  }

	public String toString()
	{
	return "-" + eValue.toString();
	}
}
