package edu.wpi.cs.dsrg.xmldb.xat.common.xmlstreamexpression;

import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.UniNotExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class UniNotExpressionStrImp extends ExpressionStrImp implements UniNotExpressionStr
{

  ExpressionStr eValue;

/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 6:43:07 PM)
 * @param expr edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression
 */
public UniNotExpressionStrImp(edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression expr) {
	ExpressionStrImp expressionStrImp = new ExpressionStrImp();
	
	eValue = expressionStrImp.createExpressionStr(((UniNotExpressionImp)expr).getExpression());

	
	}
  public UniNotExpressionStrImp(ExpressionStr exp)
  {
	eValue=exp;
  }
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 6:42:31 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
 * @param expr edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression
 */
public ExpressionStr createExpressionStr(Expression expr) {
	return new UniNotExpressionStrImp(expr);
}
 /**
	* It will evaluate itself and return the value as an object.
	* Remember, it could be like: Integer, Float, Double, String, Boolean.
	*/
public java.lang.Object eval(edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator xopOper, int[] iPositions) {
	return null;
}
  public Object eval(List tuples, XATStreamOperator op)
  {
	try
	{
	  return new Boolean(!((Boolean) eValue.eval(tuples, op)).booleanValue());
	}
	catch(ClassCastException e)
	{
	  /* fail */
	  return null;
	}

  }
  public ExpressionStr getExpression()
  {
	return eValue;
  }
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 4:30:01 PM)
 * @return java.util.Vector
 */
public java.util.Vector getTerminalColumnExprs() {
	int a=3;
	
	Vector results = new Vector();
	results.addAll(eValue.getTerminalColumnExprs());
	return results;
}
/**
 * setExpression method comment.
 */
public void setExpression(ExpressionStr exp) {}

	public String toString()
	{
	return "NOT " + eValue.toString();
	}
}
