package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators;

import java.io.FileReader;

import org.xml.sax.InputSource;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.XMLReaderFactory;
/**
 * Insert the type's description here.
 * Creation date: (5/29/2003 6:11:40 PM)
 * @author: Hong Su
 */
public class TokenFileGenerator {
/**
 * TokenFileGenerator constructor comment.
 */
public TokenFileGenerator() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (5/20/2003 11:09:18 AM)
 */
private static void initializeTokenQueueToFile(
    String rawFile,
    String tokenFile) {

    try {
        XMLReader parser =
            XMLReaderFactory.createXMLReader("org.apache.xerces.parsers.SAXParser");

        EmptySAXHandler exec = new EmptySAXHandler(tokenFile);

        parser.setContentHandler(exec);

        parser.setFeature("http://xml.org/sax/features/validation", false);
        //The only way that the parser can determine if text is ignorable is by reading the associated grammar and having a content model for the document.
        //a dtd is needed always
        parser.setFeature(
            "http://apache.org/xml/features/nonvalidating/load-external-dtd",
            true);

        System.out.println("parsing " + rawFile);
        parser.parse(new InputSource(new FileReader(rawFile)));

        //free space of exec
        exec = null;

        
    } catch (Exception e) {
        e.printStackTrace();
        System.exit(-1);
    }

}
/**
 * Insert the method's description here.
 * Creation date: (5/29/2003 6:13:08 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
	String rawFile = args[0];

	String targetFile = args[1];

	initializeTokenQueueToFile(rawFile, targetFile);
	
	}
}
