package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators;

/**
 * A special queue in terms of its on-the-fly nature, 
 
 * Creation date: (3/30/2003 4:26:57 PM)
 * @author: Hong Su
 */

import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
 
public class XATTokenQueue implements java.io.Serializable //extends XATQueueImp{
{

	private List queue;
	private boolean finished = false;
/**
 * XATTokenQueue constructor comment.
 */
public XATTokenQueue() {
	super();
	queue = new LinkedList();
}
/**
 * Insert the method's description here.
 * Creation date: (5/10/2003 10:45:43 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.datasource.XATTokenQueue
 */
public Object clone() {
  XATTokenQueue newXATTokenQueue = new XATTokenQueue();
  
  
  int size = queue.size();
  for (Iterator i= queue.iterator(); i.hasNext();){
	  newXATTokenQueue.queue.add(i.next());
  }
  
  

  return newXATTokenQueue;
  

}
/**
 * Insert the method's description here.
 * Creation date: (3/30/2003 4:29:14 PM)
 * @param token edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.Token
 */
public XMLToken dequeue() {
/*	if (!finished)
	//only when the queue is still under being added new tokens, do wait
	
    try {
        wait();
    } catch (InterruptedException e) {
        e.printStackTrace();
        return null;
    }*/

    //tokens have all be put into the queue, directly retrieve the tuple
    if (queue.size() > 0)
        return (XMLToken) queue.remove(0);

    else{
	    System.out.println("should not reach here: when queue is empty, no dequeue method should be called");
        return null;
    }

}
/**
 * Insert the method's description here.
 * Creation date: (3/30/2003 4:29:14 PM)
 * @param token edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.Token
 */
public void enqueue(XMLToken token) {
    queue.add(token);
   /* if (token.getType() == XMLToken.EOF)
        finished = true;

    notifyAll();*/
}
/**
 * Insert the method's description here.
 * Creation date: (4/2/2003 1:17:56 PM)
 * @return int
 */
public int getQueueSize() {
	return queue.size();
}
/**
 * Returns the contents of the queue by calling toString() on
 * each tuple.
 * caller is the consumer of the queue you want to print out
 * caller can be null if this is the top output queue
 */
public String printContent() {
    String rs = new String();

    for (int i = 0; i < queue.size(); i++) {
        XATTuple tuple = (XATTuple) queue.get(i);
        rs = rs + tuple.toString() + "\n";
    }

    return rs;
}
}
