
package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

import java.io.IOException;

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.exceptions.StreamEmptyException;

/**
 * Used to test the data generated bu the tuples
 * @author Luping Ding
 *
 */
public class TestDataGenerator {

	public static void main(String[] args) {
		AttributeGenerator[] generators = new AttributeGenerator[1];

		//generators[0] = new TransactionAttributeGenerator(10, 200,AttributeGenerator.RANDOM,10000);								
		//generators[0] = new UniquePunctAttributeGenerator(0, 600,AttributeGenerator.ASC,600);								

		//generators[0] = new UniquePunctAttributeGenerator(0, 60,AttributeGenerator.ASC,60);								
		//generators[0] = new ClusterAttributeGenerator(0, 1000,AttributeGenerator.ASC,30000, 1);
		//generators[0] = new ClusterAttributeGenerator(0, 1000,AttributeGenerator.RANDOM,30000, 1);
		//generators[0] = new ClusterAttributeGenerator(0, 1000,AttributeGenerator.ASC,40000, 1);
		//generators[0] = new ClusterAttributeGenerator(0, 1000,AttributeGenerator.RANDOM,40000, 1);
		//generators[0] = new ClusterAttributeGenerator(0, 1000,AttributeGenerator.ASC,50000, 1);
		//generators[0] = new ClusterAttributeGenerator(0, 1000,AttributeGenerator.RANDOM,50000, 1);
		//generators[0] = new ClusterAttributeGenerator(0, 1500,AttributeGenerator.ASC,45000, 1);
		//generators[0] = new ClusterAttributeGenerator(0, 1500,AttributeGenerator.RANDOM,45000, 1);

		//generators[0] = new RandomPunctAttributeGenerator(0, 1000, AttributeGenerator.ASC, 30000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 1000, AttributeGenerator.RANDOM, 30000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 1000, AttributeGenerator.ASC, 40000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 1000, AttributeGenerator.RANDOM, 40000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 1000, AttributeGenerator.ASC, 50000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 1000, AttributeGenerator.RANDOM, 50000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 200, AttributeGenerator.ASC, 40000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 200, AttributeGenerator.RANDOM, 40000, 0.6, 1);

		//generators[0] = new RandomAttributeGenerator(0, 1000, 30000);
		//generators[0] = new RandomAttributeGenerator(0, 1500, 45000);
		//generators[0] = new RandomAttributeGenerator(0, 1000, 50000);
		//generators[0] = new RandomAttributeGenerator(0, 3000, 90000);
		
		//generators[0] = new ClusterAttributeGenerator(1, 2000, AttributeGenerator.ASC, 20000, 1);
		//generators[0] = new ClusterAttributeGenerator(250, 250,AttributeGenerator.RANDOM,10000, 1);
		//generators[0] = new ClusterAttributeGenerator(500, 250,AttributeGenerator.RANDOM,10000, 1);
		//generators[0] = new ClusterAttributeGenerator(750, 250,AttributeGenerator.RANDOM,10000, 1);

		//generators[0] = new RandomPunctAttributeGenerator(0, 500,AttributeGenerator.RANDOM, 15000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(500, 500,AttributeGenerator.RANDOM, 15000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(1000, 500,AttributeGenerator.RANDOM, 15000, 0.6, 1);
		
		//generators[0] = new RandomPunctAttributeGenerator(0, 1500, AttributeGenerator.ASC, 45000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 1500, AttributeGenerator.RANDOM, 45000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 150, AttributeGenerator.ASC, 30000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 150, AttributeGenerator.RANDOM, 30000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 300, AttributeGenerator.ASC, 30000, 0.6, 1);
		//generators[0] = new RandomPunctAttributeGenerator(0, 300, AttributeGenerator.RANDOM, 30000, 0.6, 1);
		
		//generators[0] = new RoughClusterAttributeGenerator(0, 10, 60, 0.5, 1);
		//generators[0] = new AuctionPunctAttributeGenerator(0, 60, 6000, 100, 1);	
					
		generators[0] = new RandomUniformAttributeGenerator(100, 500);
						
		//TupleGenerator tg = new TupleGenerator(generators,"StreamGeneratorResources/Streams/synthetic/cluster-asc-1000-40000.txt");		
		//TupleGenerator tg = new TupleGenerator(generators,"StreamGeneratorResources/Streams/synthetic/cluster-random-1000-40000.txt");		
		//TupleGenerator tg = new TupleGenerator(generators,"StreamGeneratorResources/Streams/synthetic/punct-asc-1000-40000.txt");		
		//TupleGenerator tg = new TupleGenerator(generators,"StreamGeneratorResources/Streams/synthetic/punct-random-1000-40000.txt");		
		TupleGenerator tg = new TupleGenerator(generators,"resources/PWJoin/syntheticdata.txt");		

		try {
			tg.writeTuples();
		} catch (IOException e) {

			e.printStackTrace();
		} catch (StreamEmptyException e) {

			e.printStackTrace();
		}
	}
}
