package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.randomgenerators;

/**
 * Insert the type's description here.
 * Creation date: (5/22/2003 10:34:09 AM)
 * @author: Yali Zhu
 */
public class ExponentialRandomGenerator extends RandomGenerator {
	//double mean;
	//double lambda; // the mean arrival rate for a stream
/**
 * Insert the method's description here.
 * Creation date: (5/23/2003 5:01:59 AM)
 */
public ExponentialRandomGenerator() {
}
/**
 * Insert the method's description here.
 * Creation date: (5/22/2003 11:07:42 AM)
 * @param mean double
 */
public ExponentialRandomGenerator(double mean) {
    
	this.mean = mean;
    //this.lambda = lambda;
}
/**
 * Insert the method's description here.
 *
 * This method generates the next inter-arrival time for a stream, given the mean arrival rate of a stream as lambda.
 *
 * Returns an exponentially distributed, positive, random deviate of unit mean,  
 * using ran1(idum) as the source of uniform deviates.
 *
 * Creation date: (5/22/2003 10:35:12 AM)
 * @return double
 */
public double exponentialRand() {
    //double ran1(long idum);
    double dum;

    do dum = uniformRand();
    while (dum == 0.0);

    return -mean * Math.log(dum);

}
/**
 * Insert the method's description here.
 * Creation date: (5/22/2003 10:34:09 AM)
 */
public double generateRandom() {
	return exponentialRand();
}
}
