package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.xml;

/**
 * Insert the type's description here.
 * Creation date: (4/16/2003 6:29:02 PM)
 * @author: Hong Su
 */

public class TokenBuffer {
	private XMLToken[] tokenBuffer;
	private int putPos = 0;
	private int getPos;
	int capacity = 2000;
	
/**
 * TokenBuffer constructor comment.
 */
public TokenBuffer(int capacity) {
	super();
	this.capacity = capacity;
	tokenBuffer = new XMLToken[capacity];
	getPos = capacity;
}
/**
 * Insert the method's description here.
 * Creation date: (4/16/2003 6:32:00 PM)
 * @param token edu.wpi.cs.dsrg.xmldb.xat.component.automata.automata.XMLToken
 */
public void addIntoBuffer(XMLToken token) {
	tokenBuffer[putPos] = token;
	putPos ++;
		
    if (putPos == capacity) 
        //reached the limity of the token buffer, again put from the very beginning
        putPos = 0;
    
	
	}
/**
 * Insert the method's description here.
 * Creation date: (5/30/2003 10:15:45 AM)
 * @return int
 */
public int getCapacity() {
	return capacity;
}
/**
 * Insert the method's description here.
 * Creation date: (4/16/2003 6:35:04 PM)
 */
public XMLToken getFrBuffer() {

	if (getPos == capacity) 
        //reached the limity of the token buffer, again read from the very beginning
        getPos = 0;

    XMLToken token = tokenBuffer[getPos];

    if (token != null)
        getPos++;

    

        return token;

    }
/**
 * Insert the method's description here.
 * Creation date: (5/30/2003 10:20:29 AM)
 * @return int
 */
public int getGetPos() {
	return getPos;
}
/**
 * Insert the method's description here.
 * Creation date: (4/16/2003 6:50:33 PM)
 * @return int
 */
public int getPutPos() {
	return putPos;
}
/**
 * Insert the method's description here.
 * Creation date: (5/30/2003 10:20:29 AM)
 * @param newGetPos int
 */
public void setGetPos(int newGetPos) {
	getPos = newGetPos;
}
}
