package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATPropertiesImp;
import java.util.*;
import java.io.*;
/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Oct 27, 2003
 * 
 * Insert comments here.
 */
public class Stream extends XATPropertiesImp implements Serializable{


	private Server server;
	/**
	 * 
	 */
	public Stream() {
		super();
		setDefaultProperties();
		server = new Server();
	}

	protected void setDefaultProperties(){
		super.setDefaultProperties();
		addProperty("name","none");
		addProperty("server","none");
	}
	
	public void setName(String name){
		try{
			this.setProperty("name", name);
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public void setServer(Server server){
		this.server = server;
	}
	
	public String getName(){
		return this.getProperty("name");
	}
	
	public Server getServer(){
		return this.server;
	}
	
	public String toString(){
			String ret = new String();
		
			ret+= "Stream: " + this.getName() + "\n";
			ret+= "\t Properties: \t\t\t\t";
			Enumeration e = this.getProperties();
			while(e.hasMoreElements()){
				String name = (String) e.nextElement();
				String prop = this.getProperty(name);
				ret+= name + "=" + prop + ", ";
			}
			ret+="\n";
			ret+= "\t" +server.toString();
			return ret;
		
		}
}
