package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.*;
/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 26, 2004
 * 
 * Insert comments here.
 */
public class State implements Connection {

	private OperatorState[] state;
	private String toOperator;
	
	/**
	 * 
	 */
	public State(OperatorState[] state) {
		this.state = new OperatorState[state.length];
		for(int i = 0; i < state.length; i++){
			this.state[i] = state[i];
		}
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getClassName()
	 */
	public String getClassName() {
		return this.getClass().getName();
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getFromIPAddress()
	 */
	public String getFromIPAddress() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getFromOperator()
	 */
	public String getFromOperator() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getFromPort()
	 */
	public int getFromPort() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getFromQueueNumber()
	 */
	public int getFromQueueNumber() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getStreamLength()
	 */
	public int getStreamLength() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getStreamName()
	 */
	public String getStreamName() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getToIPAddress()
	 */
	public String getToIPAddress() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getToOperator()
	 */
	public String getToOperator() throws ConnectionException {
		return toOperator;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getToPort()
	 */
	public int getToPort() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.connection.Connection#getToQueueNumber()
	 */
	public int getToQueueNumber() throws ConnectionException {
		throw new ConnectionException(this.getClassName());
	}
	
	public OperatorState[] getState(){
		return this.state;
	}

	public String toString(){
		return "Created state for Operator" + toOperator;
	}
}
