package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.costmodel;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Mar 19, 2004
 * 
 * Insert comments here.
 */
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;

public class NodeCost {

	XATNode node;
	double cost;
	
	/**
	 * 
	 */
	public NodeCost(XATNode node, double cost) {
		this.node = node;
		this.cost = cost;
		
	}


	/**
	 * @return
	 */
	public double getCost() {
		return cost;
	}

	/**
	 * @return
	 */
	public XATNode getNode() {
		return node;
	}

	/**
	 * @param d
	 */
	public void setCost(double d) {
		cost = d;
	}

	/**
	 * @param node
	 */
	public void setNode(XATNode node) {
		this.node = node;
	}

	public String toString(){
		return ((XATStreamOperator)node.getOperator()).toShortString() + ", " + cost;
	}
}
