package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern;

import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.QueryPlan;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Feb 17, 2004
 * 
 * Insert comments here.
 */
public class DistributionValidator {

	ArrayList nodes = new ArrayList();
	/**
	 * 
	 */
	public DistributionValidator(QueryPlan[] qp) {

		try {

			for (int i = 0; i < qp.length; i++) {
				XATNode[] n = qp[i].getQueryPlan().convertToArray();
				for(int j = 0; j < n.length; j++){
					nodes.add(n[j]);
				}
			}

		}catch(Exception e){}
	}
	
	public boolean validate(DistributionTable t){
		
		Iterator i = nodes.iterator();
		while(i.hasNext()){
			XATNode n = (XATNode) i.next();
			if(!t.contains(n)){
				return false;
			}
		}
		
		return true;
		
	}
}