package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

/**
 * Insert the type's description here.
 * Creation date: (5/9/2002 8:12:54 PM)
 * @author: Michal Andrzej Dobosz
 */

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;
 
public class KweeltFilter extends FileFilter {
    // accept all directories and all qlt files
    public boolean accept(File f) {
        if (f.isDirectory()) {
            return true;
        }

        String extension = Utils.getExtension(f);
        if (extension != null) {
            if (extension.equals(Utils.qlt) || extension.equals(Utils.xml) ||extension.equals(Utils.txtf)|| extension.equals(Utils.token)) {
                return true;
            }
        }
        
        return false;
    }

    // the description of this filter
    public String getDescription() {
        return "Related Files (*.qlt, *.xml, *.token, *.txt)";
    }
}