package edu.wpi.cs.dsrg.xmldb.xat.component.gui;

import java.util.Hashtable;
import java.util.Vector;

import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.JScrollPane;

import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;

/**
 * Creation date: (5/30/2002 1:03:28 PM)
 * @author: Mukesh Mulchandani
 */
public abstract class UpdateProcessStep extends ProcessStep {

    protected Vector divector;
    protected Vector rpvector;
    protected Vector othersvector;
    protected Vector originalUpdates;
    protected Vector translatedUpdates;
    protected Hashtable conditionHashtable;
    protected JPanel sqlPanel;

    /**
     * UpdateProcessStep constructor comment.
     */
    public UpdateProcessStep(XATTree userXAT) {
        super(userXAT);
    }
    /**
     * UpdateProcessStep constructor comment.
     */
    public UpdateProcessStep(XATTree userXAT, XATTree viewXAT) {
        super(userXAT, viewXAT);
    }
    /**
     * Insert the method's description here.
     * 
     * @return att.grappa.GrappaPanel
     * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
     */
    protected abstract JPanel execute(int queryType);
    public Hashtable getConditionHashtable() {
        return conditionHashtable;
    }
    public Vector getDIVector() {
        return divector;
    }
    public Vector getOriginalUpdates() {
        return originalUpdates;
    }
    public Vector getOthersVector() {
        return othersvector;
    }
    public Vector getRPVector() {
        return rpvector;
    }
    public JPanel getSQLPanel(){
	    return sqlPanel;
    }
    public Vector getTranslatedUpdates() {
        return translatedUpdates;
    }
    public void setConditionHashtable(Hashtable condHashtable) {
        conditionHashtable = condHashtable;
    }
    public void setDIVector(Vector di) {
        divector = di;
    }
    public void setOriginalUpdates(Vector origUpdates) {
        originalUpdates = origUpdates;
    }
    public void setOthersVector(Vector others) {
        othersvector = others;
    }
    public void setRPVector(Vector rp) {
        rpvector = rp;
    }
    public void setSQLPanel(JPanel sql){
	    sqlPanel = sql;
    }
    public void setTranslatedUpdates(Vector transUpdates) {
        translatedUpdates = transUpdates;
    }
    public void updateContentPane(JPanel jpanel) {

        // get the current content pane.
        JComponent theContent = this.getContentPane();
        theContent.setDoubleBuffered(true);

        JScrollPane js = ((JScrollPane) this.getContentPane());
        js.setViewportView(jpanel);
        theContent.revalidate();

    }
}
