package edu.wpi.cs.dsrg.xmldb.xat.component.migrationexperiments;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.windowstreamoperator.*;
//import streamgenerator.*;
import java.util.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
//import edu.wpi.cs.dsrg.xmldb.xat.component.executioncontroller.*;
/**
 * Insert the type's description here.
 * Creation date: (2/18/2003 4:00:44 PM)
 * @author: Yali Zhu
 */
public class TestQueryPlan {
/**
 * TestQueryPlan constructor comment.
 */
public TestQueryPlan() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (3/21/2003 3:23:53 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) {

    TestQueryPlan t = new TestQueryPlan();
    //t.testSingleStaticJoin();
	//t.testSingleStreamJoin(args[0]);
    
    System.out.println("done!");
    return;
}
/**
 * Insert the method's description here.
 * Creation date: (2/1/2003 1:24:34 PM)
 */
public void testSingleStaticJoin() {
    /*TerminalExpressionStr expLeft =
        new TerminalExpressionStrImp(new ColumnNameImp("Col1"));
    TerminalExpressionStr expRight =
        new TerminalExpressionStrImp(new ColumnNameImp("Col2"));

    BinCOMPExpressionStr testExpression1 =
        new BinCOMPExpressionStrImp(expLeft, expRight, BinCOMPExpressionStr.EQ); */

    XATNode node1 = new XATNodeImp();
    WBinaryJoinOperatorImp wbjoinop = new WBinaryJoinOperatorImp(node1);
    wbjoinop.setWindowSize(10);   
//    wbjoinop.setJoinPredicate("Col1", "Col2", BinCOMPExpressionStr.EQ);
    node1.setOperator(wbjoinop);

    wbjoinop.setAsOldBoxLeaf();
    wbjoinop.setAsOldBoxRoot();
    wbjoinop.setAsOldOperator();

    DagNode sourceNode1 = new DagNodeImp();
    Source sourceOp1 = new SourceImp(sourceNode1);
    sourceNode1.setOperator(sourceOp1);
    sourceNode1.setParent(node1);
    node1.addChild(sourceNode1);

    DagNode sourceNode2 = new DagNodeImp();
    Source sourceOp2 = new SourceImp(sourceNode2);
    sourceNode2.setOperator(sourceOp2);
    sourceNode2.setParent(node1);
    node1.addChild(sourceNode2);

    XATQueue inputQ1 = new XATMemoryQueueImp(sourceOp1);
    sourceOp1.setOutput(inputQ1);
    Vector cols1 = new Vector();
    cols1.add("Col1");
    XATQueueSchema schema1 = new XATQueueSchema(cols1);
    inputQ1.setSchema(schema1);

    XATQueue inputQ2 = new XATMemoryQueueImp(sourceOp2);
    sourceOp2.setOutput(inputQ2);
    Vector cols2 = new Vector();
    cols2.add("Col2");
    XATQueueSchema schema2 = new XATQueueSchema(cols2);
    inputQ2.setSchema(schema2);

    XATQueue outputQ = new XATMemoryQueueImp(wbjoinop);
    Vector cols3 = new Vector();
    cols3.add("Col1");
    cols3.add("Col2");
    XATQueueSchema schema3 = new XATQueueSchema(cols3);
    outputQ.setSchema(schema3);

    wbjoinop.setLeftInputQueue(inputQ1);
    wbjoinop.setRightInputQueue(inputQ2);
    try {
        wbjoinop.setOutputQueue(outputQ);
        outputQ.register(this);
    } catch (XATQueueException e) {
        System.out.println(e);
    }

    try {
        XATDataValue [] data1 = new XATDataValue[1]; 
        data1[0] = new XATDataValueImp(new Integer(15));
        XATTuple t1 = new XATTupleImp(data1);
        t1.setUniTimeStamp(0);
        inputQ1.enqueue(t1, sourceOp1);

		XATDataValue[] data2 = new XATDataValue[1];
		data2[0] = new XATDataValueImp(new Integer(2));
		XATTuple t2 = new XATTupleImp(data2);
		t2.setUniTimeStamp(5);
		inputQ1.enqueue(t2, sourceOp1);

      	XATDataValue [] data3 = new XATDataValue[1];
      	data3[0] = new XATDataValueImp(new Integer(11));
        XATTuple t3 = new XATTupleImp(data3);
		t3.setUniTimeStamp(10);
        //time = 10;
        //t3.setSingleTimeStamp(10);
        inputQ1.enqueue(t3, sourceOp1);
        
        XATDataValue [] data4 = new XATDataValue[1];
      	data4[0] = new XATDataValueImp(new Integer(9));
        XATTuple t4 = new XATTupleImp(data4);
		t4.setUniTimeStamp(15);
        //t4.setSingleTimeStamp(15);
        inputQ1.enqueue(t4, sourceOp1);

 		XATDataValue [] data5 = new XATDataValue[1];
      	data5[0] = new XATDataValueImp(new Integer(4));
        XATTuple t5 = new XATTupleImp(data5);
		t5.setUniTimeStamp(2);
        //t5.setSingleTimeStamp(2);
        inputQ2.enqueue(t5, sourceOp2);

        XATDataValue [] data6 = new XATDataValue[1];
      	data6[0] = new XATDataValueImp(new Integer(11));
        XATTuple t6 = new XATTupleImp(data6);
		t6.setUniTimeStamp(8);
        //t6.setSingleTimeStamp(8);
        inputQ2.enqueue(t6, sourceOp2);

        XATDataValue [] data7 = new XATDataValue[1];
      	data7[0] = new XATDataValueImp(new Integer(2));
        XATTuple t7 = new XATTupleImp(data7);
		t7.setUniTimeStamp(12);
        //t7.setSingleTimeStamp(12);
        inputQ2.enqueue(t7, sourceOp2);

        XATDataValue [] data8 = new XATDataValue[1];
      	data8[0] = new XATDataValueImp(new Integer(9));
        XATTuple t8 = new XATTupleImp(data8);
		t8.setUniTimeStamp(16);
        //t8.setSingleTimeStamp(16);
        inputQ2.enqueue(t8, sourceOp2);

    } catch (Exception e) {
        System.out.println(e);
    }

    wbjoinop.setDebug(true);
    wbjoinop.run();

    int howmany = wbjoinop.getOutputQueue().getQueueSize(this);
    for (int i = 0; i < howmany; i++) {
        try {
            XATTuple t = wbjoinop.getOutputQueue().dequeue(this);
            System.out.println(t.getArrayData().toString());
        } catch (XATQueueException e) {
            System.out.println(e);
            return;
        }
    }
    return;
}
}
