package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.policy;

import java.io.Serializable;

/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 10:10:53 PM)
 * @author: Administrator
 */
public class TuplePolicy implements IPolicy, Serializable{
	protected boolean tuples;
	protected boolean timeUnits;
	protected int updateNumTuples;
	protected long updateNumTimeUnits;
	protected final static java.lang.String tuplePolicy = "tuples";
	protected final static java.lang.String timePolicy = "timePolicy";
/**
 * TuplePolicy constructor comment.
 */
public TuplePolicy() {
	super();
}
/**
 * Returns the policy.
 * Creation date: (1/9/2003 10:21:31 PM)
 * @return java.lang.String
 */
public String getPolicy() {
	return tuplePolicy;
}
/**
 * Insert the method's description here.
 * Creation date: (1/9/2003 10:18:14 PM)
 * @return java.lang.String
 */
public final static java.lang.String getTimePolicy() {
	return timePolicy;
}
/**
 * Insert the method's description here.
 * Creation date: (1/9/2003 10:17:25 PM)
 * @return java.lang.String
 */
public String getTuplePolicy() {
	return tuplePolicy;
}
/**
 * Returns the number of time units, any tuples within this range will be processed.
 * Creation date: (1/9/2003 10:12:17 PM)
 * @return long
 */
public long getUpdateNumTimeUnits() {
	return updateNumTimeUnits;
}
/**
 * Returns the greatest number of tuples processed at a time.
 * Creation date: (1/9/2003 10:12:02 PM)
 * @return int
 */
public int getUpdateNumTuples() {
	return updateNumTuples;
}
/**
 * The policy is either processing by number of tuples and by tuples within a time unit range.
 * Creation date: (1/9/2003 10:11:36 PM)
 * @return boolean
 */
public boolean isTimeUnits() {
	return timeUnits;
}
/**
 * The policy is either processing by number of tuples and by tuples within a time unit range.
 * Creation date: (1/9/2003 10:11:10 PM)
 * @return boolean
 */
public boolean isTuples() {
	return tuples;
}
/**
 * Sets the policy, either processing by number of tuples or tuples with in time units.
 * Creation date: (1/9/2003 10:32:52 PM)
 * @param tuples java.lang.Boolean
 * @param timeUnits java.lang.Boolean
 */
public void setPolicy(Boolean tuples, Boolean timeUnits) {}
/**
 * Sets the number of time units range for this policy.
 * Creation date: (1/9/2003 10:11:36 PM)
 * @param newTimeUnits boolean
 */
public void setTimeUnits(boolean newTimeUnits) {
	timeUnits = newTimeUnits;
}
/**
 * Sets the true if Policy is number of tuple processing Policy.
 * Creation date: (1/9/2003 10:11:10 PM)
 * @param newTuples boolean
 */
public void setTuples(boolean newTuples) {
	tuples = newTuples;
}
/**
 * Sets the number of time units if policy is determined by time units.
 * Creation date: (1/9/2003 10:12:17 PM)
 * @param newUpdateNumTimeUnits long
 */
public void setUpdateNumTimeUnits(long newUpdateNumTimeUnits) {
	updateNumTimeUnits = newUpdateNumTimeUnits;
}
/**
 * Sets the number of tuples if Policy is determined by number of tuples.
 * Creation date: (1/9/2003 10:12:02 PM)
 * @param newUpdateNumTuples int
 */
public void setUpdateNumTuples(int newUpdateNumTuples) {
	updateNumTuples = newUpdateNumTuples;
}
}
