package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.policy;

import java.io.Serializable;

/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 10:33:54 PM)
 * @author: Administrator
 */
public class WinPolicy implements IPolicy, Serializable{
	protected boolean maxWin;
	protected boolean minWin;
	protected boolean greedyMinWin;
	protected final static java.lang.String maxWindowString = "max";
	protected final static java.lang.String minWinString = "min";
	protected final static java.lang.String greedyMin = "greedyMin";
/**
 * WinPolicy constructor comment.
 */
public WinPolicy() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (1/9/2003 10:49:23 PM)
 * @return java.lang.String
 */
public final static java.lang.String getGreedyMin() {
	return greedyMin;
}
/**
 * Insert the method's description here.
 * Creation date: (1/9/2003 10:48:30 PM)
 * @return java.lang.String
 */
public final static java.lang.String getMaxWindowString() {
	return maxWindowString;
}
/**
 * Insert the method's description here.
 * Creation date: (1/9/2003 10:48:56 PM)
 * @return java.lang.String
 */
public final static java.lang.String getMinWinString() {
	return minWinString;
}
/**
 * Returns the window policy: maximum, minimum, greedy minimum.
 * Creation date: (1/9/2003 10:48:03 PM)
 * @return java.lang.String
 */
public String getPolicy() {
	return null;
}
/**
 * Returns true if policy is greedy minimum window.
 * Creation date: (1/9/2003 10:46:54 PM)
 * @return boolean
 */
public boolean isGreedyMinWin() {
	return greedyMinWin;
}
/**
 * Returns true if policy is maximum window.
 * Creation date: (1/9/2003 10:46:21 PM)
 * @return boolean
 */
public boolean isMaxWin() {
	return maxWin;
}
/**
 * Returns the policy if minimum window.
 * Creation date: (1/9/2003 10:46:36 PM)
 * @return boolean
 */
public boolean isMinWin() {
	return minWin;
}
/**
 * Sets policy as greedy minimum window.
 * Creation date: (1/9/2003 10:46:54 PM)
 * @param newGreedyMinWin boolean
 */
public void setGreedyMinWin(boolean newGreedyMinWin) {
	greedyMinWin = newGreedyMinWin;
}
/**
 * Sets true if policy is maximum window.
 * Creation date: (1/9/2003 10:46:21 PM)
 * @param newMaxWin boolean
 */
public void setMaxWin(boolean newMaxWin) {
	maxWin = newMaxWin;
}
/**
 * Sets true if policy is minimum window
 * Creation date: (1/9/2003 10:46:36 PM)
 * @param newMinWin boolean
 */
public void setMinWin(boolean newMinWin) {
	minWin = newMinWin;
}
/**
 * Sets window policy, one of the three choices: maximum, minimum, or greedyMin.
 * Only the maximum policy is implemented.
 * Creation date: (1/9/2003 10:47:41 PM)
 * @param max boolean
 * @param min boolean
 * @param greedyMin boolean
 */
public void setWin(boolean max, boolean min, boolean greedyMin) {}
/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
	// Insert code to print the receiver here.
	// This implementation forwards the message to super. You may replace or supplement this.
	return super.toString();
}
}
