package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparatorOperators.Operator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.IPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;
/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 7:35:30 PM)
 * @author: Administrator
 */
public abstract class OrderList implements Serializable{
	protected ArrayList streamName1;
	protected java.lang.String column1;
	protected Operator op;
	protected java.util.LinkedList predicateList;
	protected int ListIndex;
	protected java.lang.String predicateListName;
	protected int columnInt1;
/**
 * OrderList constructor comment.
 */
public OrderList() {
	super();
	predicateList = new LinkedList();
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 8:21:52 PM)
 * @param predName java.lang.String
 */
public OrderList(String predName) {
	super();
	this.setListName(predName);
	
	}
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 7:47:08 PM)
 * @return int
 * @param obj org.omg.CORBA.Object
 */
public int compareTo(Object obj) {
	return 0;
}
/**
 * Deletes the Predicate in the Linked List.
 * Creation date: (1/9/2003 8:04:36 PM)
 * @param predicate juggler.predicatestructure.Predicate
 */
public void delete(Predicate predicate) {

    if (predicateList.isEmpty()) {
        //return since the list is empty
        return;
    } else {
        //deletes the predicate in the appropriate position
        predicateList.remove(predicate);
    }
}
/**
 * Compares two objects for equality. Returns a boolean that indicates
 * whether this object is equivalent to the specified object. This method
 * is used when an object is stored in a hashtable.
 * @param obj the Object to compare with
 * @return true if these Objects are equal; false otherwise.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
    // Insert code to compare the receiver and obj here.
    // This implementation forwards the message to super.  You may replace or supplement this.
    // NOTE: obj might be an instance of any class
    //return super.equals(obj);
   /* OrderList o = (OrderList) obj;

    if (o.getColumn1() == this.getColumn1()
        && o.getOp().equals(this.getOp())
        && o.getStreamName1() == this.getStreamName1())
        return true;
    else
        return false;*/
        return false;
}
/**
 * Returns the column of the first stream in this predicatelist.
 * Creation date: (1/9/2003 7:37:51 PM)
 * @return java.lang.String
 */
public java.lang.String getColumn1() {
	return column1;
}
/**
 * Insert the method's description here.
 * Creation date: (4/13/2003 7:28:21 PM)
 * @return int
 */
public int getColumnInt1() {
	return columnInt1;
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 8:44:48 PM)
 * @return java.util.LinkedList
 */
public java.util.LinkedList getList() {
	return predicateList;
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 8:51:07 PM)
 * @return int
 */
public int getListIndex() {
	return ListIndex;
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 8:22:39 PM)
 * @return java.lang.String
 */
public java.lang.String getListName() {
	return predicateListName;
}
/**
 * Returns the operator in this predicate list.
 * Creation date: (1/9/2003 7:52:53 PM)
 * @return juggler.predicatestructure.Operator
 */
public Operator getOp() {
	return op;
}
/**
 * Insert the method's description here.
 * Creation date: (3/10/2003 9:56:28 PM)
 * @return juggler.predicatestructure.IPredicate
 * @param predIndex int
 */
public IPredicate getPredicate(int predIndex) {
	return ((IPredicate) this.getList().get(predIndex));
}
/**
 * Insert the method's description here.
 * Creation date: (2/20/2003 1:17:54 AM)
 * @return int
 * @param pred juggler.predicatestructure.Predicate
 */
public int getPredicateIndex(Predicate pred) {

	return (this.predicateList.indexOf(pred));
}
/**
 * Returns the first stream's name in this predicate list.
 * Creation date: (1/9/2003 7:36:57 PM)
 * @return ArrayList
 */
public ArrayList getStreamName1() {
	return streamName1;
}
/**
 * Generates a hash code for the receiver.
 * This method is supported primarily for
 * hash tables, such as those provided in java.util.
 * @return an integer hash code for the receiver
 * @see java.util.Hashtable
 */
public int hashCode() {
	// Insert code to generate a hash code for the receiver here.
	// This implementation forwards the message to super.  You may replace or supplement this.
	// NOTE: if two objects are equal (equals(Object) returns true) they must have the same hash code
	return super.hashCode();
}
/**
 * Inserts the Predicate in the Predicate Linked List.
 * It returns the corresponding BitPosition of the Predicate.
 * Creation date: (1/9/2003 8:03:41 PM)
 * @return juggler.predicatestructure.BitPosition
 * @param predicate juggler.predicatestructure.Predicate
 */
public BitPosition insertPredicate(Predicate predicate) {	
 
 //check if the predicate already exists
    if (predicateList.contains(predicate)) {   
        Predicate p =
            (Predicate) predicateList.get(predicateList.indexOf(predicate));
            //add in the query number iDs for the predicate
        Iterator qIt = predicate.getQueryNumIDs().iterator();
        while (qIt.hasNext()) {
            String itemp = (String) qIt.next();
            if (!p.getQueryNumIDs().contains(itemp))
                p.addQueryID(new Integer(itemp).intValue());
        }
        return (new BitPosition(this.getListIndex(), predicateList.indexOf(predicate)));
    }
	
	if (predicateList.isEmpty()) {
		predicateList.add(predicate);
		//return the first predicate bitposition
		return (new BitPosition(this.getListIndex(), 0));
	}
	else {
		Iterator list = predicateList.iterator();
		while (list.hasNext()) {
			Predicate p = (Predicate) list.next();
			int index = Collections.binarySearch(predicateList, predicate);


			 //if the key is the greatest
            //if the index is between 0 and predicateList size
            if (index < predicateList.size() && index >= 0) {
                predicateList.add(index, predicate);
                break;
            }
            //if the index is the list size, it is greater than all the predicates in the list
            if (index == predicateList.size()) {
                predicateList.add(predicateList.size() + 1, predicate);
                break;
                //if the index should be somewhere in the middle of the list
            } else {
                //inserts the predicate in teh appropriate position
                predicateList.add(Math.abs(index) - 1, predicate);
                break;
				
			}
		}
	}
	return null;
}
/**
 * Sets the first stream's column name in this predicate list.
 * Creation date: (1/9/2003 7:37:51 PM)
 * @param newColumn1 java.lang.String
 */
public void setColumn1(java.lang.String newColumn1) {
	column1 = newColumn1;
}
/**
 * Insert the method's description here.
 * Creation date: (4/13/2003 7:28:21 PM)
 * @param newInt int
 */
public void setColumnInt1(int newInt) {
	columnInt1 = newInt;
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 8:44:48 PM)
 * @param newList java.util.LinkedList
 */
public void setList(java.util.LinkedList newList) {
	predicateList = newList;
}
/**
 * Insert the method's description here.
 * Creation date: (2/12/2003 8:51:07 PM)
 * @param newListIndex int
 */
public void setListIndex(int newListIndex) {
	ListIndex = newListIndex;
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 8:22:39 PM)
 * @param newListName java.lang.String
 */
public void setListName(java.lang.String newListName) {
	predicateListName = newListName;
}
/**
 * Sets the Operator of this list.
 * Creation date: (1/9/2003 7:52:53 PM)
 * @param newOp juggler.predicatestructure.Operator
 */
public void setOp(Operator newOp) {
	op = newOp;
}
/**
 * Sets the first stream name in this predicate list.
 * Creation date: (1/9/2003 7:36:57 PM)
 * @param newStreamName1 ArrayList
 */
public void setStreamName1(ArrayList newStreamName1) {
	streamName1 = newStreamName1;
}
/**
 * Insert the method's description here.
 * Creation date: (3/10/2003 9:50:52 PM)
 * @return int
 */
public int size() {
	return predicateList.size();
	}
/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
	// Insert code to print the receiver here.
	// This implementation forwards the message to super. You may replace or supplement this.
	return super.toString();
}

/**
 * Finds the most covering predicate for the specified tuple.
 * Creation date: (1/9/2003 8:12:57 PM)
 * @param tuple juggler.stream.Tuple
 * @return int
 */
public int findMostCovering(JugglerTuple tuple) {
	return -100;
}
}
