package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query;

import java.io.Serializable;
import java.util.ArrayList;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.AttrPredicate;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;
/**
 * Insert the type's description here.
 * Creation date: (3/4/2003 9:23:05 PM)
 * @author: Administrator
 */
public class Query extends QueryQED implements Serializable {
	/*juggler.predicatestructure.AttrPredicate[]*/ 
	protected ArrayList attributePredicates;
	/* juggler.predicatestructure.Predicate[]  */
	protected ArrayList joinPredicates;
	/* juggler.predicatestructure.Predicate[]  */
	protected ArrayList windowPredicates;
/**
 * Query constructor comment.
 */
public Query() {
	//super();
	attributePredicates = new ArrayList();
	joinPredicates = new ArrayList();
	windowPredicates = new ArrayList();
}
/**
 * Compares two objects for equality. Returns a boolean that indicates
 * whether this object is equivalent to the specified object. This method
 * is used when an object is stored in a hashtable.
 * @param obj the Object to compare with
 * @return true if these Objects are equal; false otherwise.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
    // Insert code to compare the receiver and obj here.
    // This implementation forwards the message to super.  You may replace or supplement this.
    // NOTE: obj might be an instance of any class
    //return super.equals(obj);
    Query queryObj = (Query) obj;
    if (attributePredicates.equals(queryObj.attributePredicates)
        && joinPredicates.equals(queryObj.joinPredicates)
        && windowPredicates.equals(queryObj.windowPredicates)
        && this.getPredicates().equals(queryObj.getPredicates()))
        return true;
    else
        return false;
}
/**
 * Returns an array of AttrPredicate.
 * Creation date: (3/4/2003 9:24:41 PM)
 * @return ArrayList
 */
public ArrayList getAttrPredicates() {
	return attributePredicates;
}
/**
 * Returns an array of Predicate.
 * Creation date: (3/5/2003 8:23:29 PM)
 * @return ArrayList
 */
public ArrayList getJoinPredicates() {
	return joinPredicates;
}
/**
 * Returns an array of Predicate.
 * Creation date: (3/5/2003 8:22:40 PM)
 * @return ArrayList
 */
public ArrayList getWindowPredicates() {
	return windowPredicates;
}
/**
 * Generates a hash code for the receiver.
 * This method is supported primarily for
 * hash tables, such as those provided in java.util.
 * @return an integer hash code for the receiver
 * @see java.util.Hashtable
 */
public int hashCode() {
	// Insert code to generate a hash code for the receiver here.
	// This implementation forwards the message to super.  You may replace or supplement this.
	// NOTE: if two objects are equal (equals(Object) returns true) they must have the same hash code
	return super.hashCode();
}
/**
 * Inserts an arrayList of AttrPredicate.
 * Creation date: (3/4/2003 9:24:41 PM)
 * @param newPredicates juggler.predicatestructure.Predicate[]
 */
public void setAttrPredicates(ArrayList newPredicates) {
	attributePredicates = newPredicates;
}
/**
 * Inserts an arrayList of Predicate
 * Creation date: (3/5/2003 8:23:29 PM)
 * @param newPredicates juggler.predicatestructure.Predicate[]
 */
public void setJoinPredicates(ArrayList newPredicates) {
	joinPredicates = newPredicates;
}
/**
 * Inserts an arrayList of Predicate.
 * Creation date: (3/5/2003 8:22:40 PM)
 * @param newPredicates juggler.predicatestructure.Predicate[]
 */
public void setWindowPredicates(ArrayList newPredicates) {
	windowPredicates = newPredicates;
}
/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
	// Insert code to print the receiver here.
	// This implementation forwards the message to super. You may replace or supplement this.
	//return super.toString();

	String queryString ="";

	queryString += "Query :" + this.getQueryNum() + "\n";

queryString += "Attribute : \n";
	
	for (int i = 0; i < attributePredicates.size(); i++) {
		AttrPredicate attrPred = (AttrPredicate) attributePredicates.get(i);
		queryString += attrPred.toString() + "\n";
	}

	queryString += "Join : \n";

	for (int j = 0; j < joinPredicates.size(); j++) {
		Predicate joinPred = (Predicate) joinPredicates.get(j);
		queryString += joinPred.toString() + "\n";
	}

queryString += "Window : \n";
	
	for (int k = 0; k < windowPredicates.size(); k++) {
		Predicate winPred = (Predicate) windowPredicates.get(k);
		queryString += winPred.toString() + "\n";
	}

	return queryString;
}
}
