package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.queryplan;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueueSchema;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.streamoperator
	.XATMultiQueueStreamOperatorImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparableTupleValues
	.KeyDouble;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparatorOperators
	.EqualToOperator;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparatorOperators
	.GreaterThanEqualToOp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparatorOperators
	.GreaterThanOp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparatorOperators
	.LessThanEqualToOp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparatorOperators
	.LessThanOp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparatorOperators
	.Operator;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.JugglerTuple
	.JugglerTuple;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.JugglerTuple
	.JugglerTupleList;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.JugglerTuple
	.JugglerTupleListIterator;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatemanagers
	.PredicateOrderingManager;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatestructure
	.AttrPredicate;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatestructure
	.AttributePredicatePart;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatestructure
	.Predicate;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicatestructure
	.PredicatePart;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.query.Query;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.query
	.QueryDependentEncoding;
/**
 * Insert the type's description here.
 * Creation date: (1/12/2003 10:36:12 PM)
 * @author: Administrator
 */

public class XATJugglerOperatorImp
	extends XATMultiQueueStreamOperatorImp
	implements XATJugglerOperator {
	private boolean parsePlan;
	protected int howMany;
	protected long MaxWin;
	protected PredicateOrderingManager predicateManager;
	protected QueryDependentEncoding inputQDE;
	protected HashMap mappingOfQueriesToQueues;
	protected int[] streamIDs;
	protected ArrayList queueStreamNames;
	protected String numQueues;
	protected String queryInfo;
	protected String attrPred;
	protected String joinPred;
	protected String windowPred;

	/**
	 * XATSreamOperatorImp constructor comment.
	 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 */
	public XATJugglerOperatorImp(XATNode node) {
		super(node);
		parsePlan = false; //this is ot parse lt and gt rather than <,>
		//setNode(node);
	}
	/**
	 * 
	 */
	//public XATJugglerOperatorImp() {
	//	super();
	//}
	/**
	 * Query String format: "Query ID = n; streams;"
	 * Predicate String format: "Query ID = n; streamName.columnName(columnID) *factor +add -sub > value; streamName.columnName(columnID) *factor +add -sub > value;"
	 * 
	 */

	public void initialize_Old(
		String num,
		String queryInfo,
		String attrPredicates,
		String joinPredicates,
		String windowPredicates) {

		mappingOfQueriesToQueues = new HashMap();
		queueStreamNames = new ArrayList();

		int numQueues = (new Integer(num)).intValue();
		//register the incoming queues
		int numQueuesAdded = 0;
		while (numQueuesAdded < numQueues) {
			XATQueue currQueue = new XATQueueImp();
			inputQueue.add(numQueuesAdded, currQueue);
			((XATQueue) inputQueue.get(numQueuesAdded)).register(this);
			numQueuesAdded++;
		}

		ArrayList QueryObjects = new ArrayList();

		HashMap attrMap = parseAttrPredicates(attrPredicates);
		HashMap joinMap = parseJWPredicates(joinPredicates);
		HashMap winMap = parseJWPredicates(windowPredicates);

		//		parse the string with query IDs and streams
		QueryObjects =
			parseQueryInfoString(queryInfo, attrMap, joinMap, winMap);

		//create output queues
		int numQueries = QueryObjects.size();
		for (int i = 0; i < numQueries; i++) {
			Query aquery = (Query) QueryObjects.get(i);
			mappingOfQueriesToQueues.put(
				new Integer(aquery.getQueryNum()),
				new Integer(i));
			outputQueue.add(i, new XATQueueImp());
			((XATQueue) outputQueue.get(i)).register(this);

			for (int j = 0; j < aquery.getStreams().size(); j++) {
				if (!queueStreamNames.contains(aquery.getStreams().get(j)))
					queueStreamNames.add(aquery.getStreams().get(j));
			}
		}

		predicateManager = new PredicateOrderingManager();

		predicateManager.registerQueries(QueryObjects);

	}

	/**
	 * 
	 */
	//public XATJugglerOperatorImp() {
	//	super();
	//}
	/**
	 * Query String format: "Query ID = n; streams;"
	 * Predicate String format: "Query ID = n; streamName.columnName(columnID) *factor +add -sub > value; streamName.columnName(columnID) *factor +add -sub > value;"
	 * 
	 */
	public void visitInit(
		String num,
		String queryInfo,
		String attrPredicates,
		String joinPredicates,
		String windowPredicates) {
		this.numQueues = num;
		this.queryInfo = queryInfo;
		this.attrPred = attrPredicates;
		this.windowPred = windowPredicates;
		this.joinPred = joinPredicates;
	}

	public synchronized void initialize(
		String num,
		String queryInfo,
		String attrPredicates,
		String joinPredicates,
		String windowPredicates) {

		System.out.println("Initializing XATJugglerOperatorImp....");

		/*
				try {
					Thread.sleep(30000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				*/

		mappingOfQueriesToQueues = new HashMap();
		queueStreamNames = new ArrayList();

		int numQueues = (new Integer(num)).intValue();

		/* this is done by execution controller or distribution manager
				Iterator it = this.getInputQueues();
				//register the incoming queues
				int numQueuesAdded = 0;
				while (it.hasNext()) {
					XATQueue currQueue = (XATQueue) it.next();
					inputQueue.add(numQueuesAdded, currQueue);
					numQueuesAdded++;
				}
			*/

		System.out.println("Initializing XATJugglerOperatorImp input queues.");

		ArrayList QueryObjects = new ArrayList();

		System.out.println("Parsing attribute predicates.");
		HashMap attrMap = parseAttrPredicates(attrPredicates);
		System.out.println("Parsing join predicates.");
		HashMap joinMap = parseJWPredicates(joinPredicates);
		System.out.println("Parsing window predicates.");
		HashMap winMap = parseJWPredicates(windowPredicates);

		System.out.println("Entering query information.");

		//		parse the string with query IDs and streams
		QueryObjects =
			parseQueryInfoString(queryInfo, attrMap, joinMap, winMap);

		System.out.println("Initializing XATJugglerOperatorImp output queues.");

		//create output queues
		int numQueries = QueryObjects.size();
		for (int i = 0; i < QueryObjects.size(); i++) {
			Query aquery = (Query) QueryObjects.get(i);
			mappingOfQueriesToQueues.put(
				new Integer(aquery.getQueryNum()),
				new Integer(i));
			XATQueue outputQueue = new XATQueueImp();

			outputQueue.setQueueName(aquery.getStreams().toString());
			this.addOutputQueue(outputQueue);
			i++;
			for (int j = 0; j < aquery.getStreams().size(); j++) {
				if (!queueStreamNames.contains(aquery.getStreams().get(j)))
					queueStreamNames.add(aquery.getStreams().get(j));
			}
		}

		System.out.println(
			"Finished Initializing XATJugglerOperatorImp output queues.");

		predicateManager = new PredicateOrderingManager();

		System.out.println(
			"Initializing XATJugglerOperatorImp registering queries.");

		predicateManager.registerQueries(QueryObjects);

	}

	/**
	 * @param joinPredicates
	 * @return
	 */
	private HashMap parseJWPredicates(String jwPredicates) {
		//check format!
		ArrayList jwPredicatesSplit = splitString(jwPredicates, ";");
		//positive limit
		ArrayList currQueryID = new ArrayList();
		HashMap jwHash = new HashMap();
		ArrayList jwPredicatesList = new ArrayList();
		Operator op = null;
		for (int i = 0; i < jwPredicatesSplit.size(); i++) {
			String jwPredStr = (String) jwPredicatesSplit.get(i);
			String queryIDBeginning = "Query ID =";
			if (jwPredStr.startsWith(queryIDBeginning)) {
				if (!currQueryID.isEmpty()) {
					jwHash.put(currQueryID, jwPredicatesList);
					currQueryID = new ArrayList();
					jwPredicatesList = new ArrayList();
				}
				int start = jwPredStr.indexOf(queryIDBeginning);
				int querylength = queryIDBeginning.length();
				start += querylength + 1;
				int end = jwPredStr.length();
				String queryIDStr = jwPredStr.substring(start, end);
				currQueryID.add(queryIDStr);
			} else {
				op = getPredicateOperatorPlan(op, jwPredStr);
				int start = jwPredStr.indexOf(op.toStringXML());
				String PredPartStr1 = jwPredStr.substring(0, start);
				PredicatePart PredPart1 = getPredicatePart(PredPartStr1);
				start += (op.toStringXML().length() + 1);
				String PredParStr2 =
					jwPredStr.substring(start, jwPredStr.length());
				PredicatePart PardPart2 = getPredicatePart(PredParStr2);
				Predicate aPred = new Predicate(PredPart1, PardPart2, op);
				aPred.setQueryNumIDs(currQueryID);
				jwPredicatesList.add(aPred);
			} //end else

		} //end for
		//		put the last query done
		jwHash.put(currQueryID, jwPredicatesList);
		return jwHash;
	}
	/**
	 * @param attrPredicates
	 */
	private HashMap parseAttrPredicates(String attrPredicates) {
		//check format!
		ArrayList attrPredicatesSplit = splitString(attrPredicates, ";");
		//positive limit
		ArrayList currQueryID = new ArrayList();
		HashMap attrHash = new HashMap();
		ArrayList attrPredicatesList = new ArrayList();
		Operator op = null;
		for (int i = 0; i < attrPredicatesSplit.size(); i++) {
			String attrPredStr = (String) attrPredicatesSplit.get(i);
			String queryIDBeginning = "Query ID =";
			if (attrPredStr.startsWith(queryIDBeginning)) {
				if (!currQueryID.isEmpty()) {
					attrHash.put(currQueryID, attrPredicatesList);
					currQueryID = new ArrayList();
					attrPredicatesList = new ArrayList();
				}
				int start = attrPredStr.indexOf(queryIDBeginning);
				int querylength = queryIDBeginning.length();
				start += querylength + 1;
				int end = attrPredStr.length();
				String queryIDStr = attrPredStr.substring(start, end);
				currQueryID.add(queryIDStr);
			} else {
				//				need to do this conversion since xml file cannot handle <,> symbols in our plan.xml file
				String operatorString = "";
				if (parsePlan) {
					op = getPredicateOperatorPlan(op, attrPredStr);
					operatorString = getPredicateStringRepresentation(op);
				} else {
					op = getPredicateOperatorPlan(op, attrPredStr);
					operatorString = op.toStringXML();
				}
				int start = attrPredStr.indexOf(operatorString);
				start += op.toStringXML().length() + 1;
				String valStr =
					attrPredStr.substring(start, attrPredStr.length());
				double valDouble = (new Double(valStr)).doubleValue();
				KeyDouble value = new KeyDouble(valDouble);
				AttributePredicatePart aValue1 =
					new AttributePredicatePart(value);
				start -= op.toStringXML().length() + 2;
				String attrPredPartStr = attrPredStr.substring(0, start);
				PredicatePart attrPredPart = getPredicatePart(attrPredPartStr);
				AttrPredicate aPred =
					new AttrPredicate(attrPredPart, aValue1, op);
				aPred.setQueryNumIDs(currQueryID);
				attrPredicatesList.add(aPred);
			} //end else

		} //end for
		//put the last query done
		attrHash.put(currQueryID, attrPredicatesList);
		return attrHash;

	}
	/**
	 * format: streamName.columnName(columnID) *factor +add -sub
	 * @param attrPredPartStr
	 * @return
	 */
	private PredicatePart getPredicatePart(String attrPredPartStr) {
		//streamName.column
		int dot = attrPredPartStr.indexOf(".");
		String streamName = attrPredPartStr.substring(dot - 1, dot);
		ArrayList streamNames = new ArrayList();
		streamNames.add(streamName);
		int parenBeg = attrPredPartStr.indexOf("(");
		String columnName = attrPredPartStr.substring(dot + 1, parenBeg);
		int parenEnd = attrPredPartStr.indexOf(")");
		String columnID = attrPredPartStr.substring(parenBeg + 1, parenEnd);
		/////get the column Id from the queue

		if (!columnName.equals("ts"))
			columnID = getColumnIDFromInputQueue(columnName, streamName);
		else
			columnID = "0";
		int star = attrPredPartStr.indexOf("*");
		double factorDouble = 1.0;
		int addition = attrPredPartStr.indexOf("+");
		double addDouble = 0.0;
		int subtraction = attrPredPartStr.indexOf("-");
		double subDouble = 0.0;
		int additionTemp = -1;
		int subtractionTemp = -1;

		if (star > 0) {
			if (addition == -1)
				additionTemp = attrPredPartStr.length();
			else
				additionTemp = addition;
			String factor = attrPredPartStr.substring(star + 1, additionTemp);
			factorDouble = (new Double(factor)).doubleValue();
		}
		if (addition > 0) {
			if (subtraction == -1)
				subtractionTemp = attrPredPartStr.length();
			else
				subtractionTemp = subtraction;
			String add =
				attrPredPartStr.substring(addition + 1, subtractionTemp);
			addDouble = (new Double(add)).doubleValue();
		}
		if (subtraction > 0) {
			String sub =
				attrPredPartStr.substring(
					subtraction,
					attrPredPartStr.length());
			subDouble = (new Double(sub)).doubleValue();
		}

		return new PredicatePart(
			streamNames,
			columnName,
			(new Integer(columnID)).intValue(),
			factorDouble,
			addDouble,
			subDouble);
	}
	/**
	 * @param columnName
	 * @param streamName
	 * @return
	 * could chnage the return type to int if change code in getPredicatePart
	 */
	private String getColumnIDFromInputQueue(
		String columnName,
		String streamName) {
		Iterator it = this.getInputQueues();
		int col = -1;
		while (it.hasNext()) {
			XATQueue element = (XATQueue) it.next();
			String queueName = element.getQueueName();
			int queyNameIndex = queueName.indexOf(streamName);
			if (queueName.indexOf(streamName) == 0) {
				col = element.getSchema().getPos(columnName);
				return (new Integer(col)).toString();
			}
			//if (col == 0 || col == -1)
			//col = element.getSchema().getPos(streamName + "." + columnName);
		}
		return (new Integer(col)).toString();
	}
	/**
	 * We need this conversion since the plan.xml file cannot handle <,> signs.
	 * It gets confused with xml tags.
	 * @param op
	 * @return
	 */
	private String getPredicateStringRepresentation(Operator op) {
		String opString = "";
		if (op.toString() == ">=")
			opString = " gt= ";
		else {
			if (op.toString() == "<=")
				opString = "lt=";
			else {
				if (op.toString() == ">")
					opString = "gt";
				else {
					if (op.toString() == "<")
						opString = "lt";
					else
						opString = op.toString(); //for = case
				}
			}
		}
		return opString;
	}

	/**
	 * @param op
	 * @return
	 */
	private Operator getPredicateOperatorPlan(Operator op, String predStr) {
		int start = 0;
		int startGrEq = predStr.indexOf(" gt= ");
		if (startGrEq > 0) {
			op = new GreaterThanEqualToOp();
			start = startGrEq;
		} else {
			int startLessEq = predStr.indexOf(" lt= ");
			if (startLessEq > 0) {
				op = new LessThanEqualToOp();
				start = startLessEq;
			} else {
				int startEq = predStr.indexOf(" = ");
				if (startEq > 0) {
					op = new EqualToOperator();
					start = startEq;
				} else {
					int startGr = predStr.indexOf(" gt ");
					if (startGr > 0) {
						op = new GreaterThanOp();
						start = startGr;
					} else {
						int startLess = predStr.indexOf(" lt ");
						if (startLess > 0) {
							op = new LessThanOp();
							start = startLess;
						}
					}

				}
			}
		}
		//return start;
		return op;
	}

	/**
	 * @param op
	 * @return
	 */
	private Operator getPredicateOperator(Operator op, String predStr) {
		int start = 0;
		int startGrEq = predStr.indexOf(" >= ");
		if (startGrEq > 0) {
			op = new GreaterThanEqualToOp();
			start = startGrEq;
		} else {
			int startLessEq = predStr.indexOf(" <= ");
			if (startLessEq > 0) {
				op = new LessThanEqualToOp();
				start = startLessEq;
			} else {
				int startEq = predStr.indexOf(" = ");
				if (startEq > 0) {
					op = new EqualToOperator();
					start = startEq;
				} else {
					int startGr = predStr.indexOf(" > ");
					if (startGr > 0) {
						op = new GreaterThanOp();
						start = startGr;
					} else {
						int startLess = predStr.indexOf(" < ");
						if (startLess > 0) {
							op = new LessThanOp();
							start = startLess;
						}
					}

				}
			}
		}
		//return start;
		return op;
	}
	/**
	 * @param queryInfo
	 * @return
	 */
	private ArrayList parseQueryInfoString(
		String queryInfo,
		HashMap attrHash,
		HashMap joinHash,
		HashMap winHash) {
		ArrayList QueryObjects = new ArrayList();
		//	check if the format is right!
		if (queryInfo.startsWith("Query ID = ")) {
			String queryIDBeginning = "Query ID = ";
			ArrayList queries = splitString(queryInfo, ";");
			Iterator queriesIt = queries.iterator();
			while (queriesIt.hasNext()) {
				String element = (String) queriesIt.next();
				int QueryIndexBeginning = element.indexOf(queryIDBeginning);
				if (QueryIndexBeginning >= 0) {
					QueryIndexBeginning += (queryIDBeginning.length());
					int QueryIndexEnd = element.length();
					String queryNumStr =
						element.substring(QueryIndexBeginning, QueryIndexEnd);
					int QueryID = (new Integer(queryNumStr)).intValue();
					Query queryTemp = new Query();
					queryTemp.setQueryNum(QueryID);
					ArrayList queryIDArray = new ArrayList();
					queryIDArray.add(queryNumStr);
					ArrayList attrList = (ArrayList) attrHash.get(queryIDArray);
					ArrayList joinList = (ArrayList) joinHash.get(queryIDArray);
					ArrayList winList = (ArrayList) winHash.get(queryIDArray);
					queryTemp.setAttrPredicates(attrList);
					queryTemp.setJoinPredicates(joinList);
					queryTemp.setWindowPredicates(winList);
					QueryObjects.add(queryTemp);
				} else {
					//get the query that was last inserted
					element = element.substring(1, element.length());
					Query queryTemp =
						(Query) QueryObjects.get(QueryObjects.size() - 1);
					QueryObjects.remove(queryTemp);
					ArrayList queryStreamsTemp = new ArrayList();
					for (int i = 0; i < element.length(); i++) {
						String oneStream = element.substring(i, i + 1);
						queryStreamsTemp.add(oneStream);
					}
					queryTemp.setStreams(queryStreamsTemp);
					QueryObjects.add(queryTemp);
				}

			}
		}
		return QueryObjects;
	}
	/**
	 * @param queryInfo
	 * @param string
	 * @return
	 */
	private ArrayList splitString(String strInfo, String string) {
		ArrayList parsedStrs = new ArrayList();
		int start = 0;
		int end = 0;
		while (strInfo.length() > 0) {
			end = strInfo.indexOf(string);
			String anElement = strInfo.substring(start, end);
			parsedStrs.add(anElement);
			strInfo = strInfo.substring(end + 1, strInfo.length());
		}
		return parsedStrs;
	}
	/**
	 * Returns the maximum window  of this node.
	 * Creation date: (1/12/2003 10:36:31 PM)
	 * @return long
	 */
	protected long getMaxWin() {
		return MaxWin;
	}
	/**
	 * Returns teh predicate manager of this node.
	 * Creation date: (1/12/2003 10:36:58 PM)
	 * @return juggler.predicatemanagers.PredicateOrderingManager
	 */
	protected PredicateOrderingManager getPredicateManager() {
		return predicateManager;
	}
	/**
	 * Returns the qde of this node.
	 * Creation date: (1/12/2003 10:37:17 PM)
	 * @return juggler.exploitationstructures.QueryDependentEncoding
	 */
	protected QueryDependentEncoding getQde() {
		return inputQDE;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/9/2003 9:46:43 PM)
	 * @return int[]
	 */
	protected int[] getStreamIDs() {
		return streamIDs;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/26/2003 11:30:08 PM)
	 * @param tuples java.util.Iterator
	 */
	public ArrayList processTuples(Iterator tuples) {
		//make sure they are JugglerTupleLists!!!
		//also check if this isn't the "first" tuples entering the system.
		if (!this.predicateManager.isExpStructuresEmpty())
			return this.predicateManager.processTuples(tuples);
		else
			return null;
	}
	/**
	 * Runs the actual operator.
	 *
	 * Unlike in Rainbow, the Stream operators have the implementation tied to the operator
	 * because the StreamOperators represent physical operators instead of Logic.
	 * Creation date: (1/13/2003 1:54:47 PM)
	 */

	public void run_Old() {
		parsePlan = false;
		/** get the tuples */
		//for each queue using the round robin approach
		//for (int i = 0; i < this.getinputQueue.size(); i++) {
		Iterator inputQueuesIt = this.getInputQueues();
		while (inputQueuesIt.hasNext()) {
			int howMany = 1;
			XATQueue aqueue = (XATQueue) inputQueuesIt.next();
			//dequeue 10 tuples
			if (aqueue.getQueueSize() >= howMany) {
				howMany = aqueue.getQueueSize();
				List tuples = aqueue.dequeueN(howMany, this);
				if (!tuples.isEmpty()) {
					//proecess tuples
					ArrayList resultingTuples =
						processTuples(tuples.iterator());
					if (resultingTuples != null) {
						int numresultingTuples = resultingTuples.size();

						//enqueue the resulting tuples to the output queue
						if (numresultingTuples > 0) {
							printOutForDebugging(resultingTuples);
							/** now enqueue the tuples */
							outputQueues(resultingTuples);
						}
					} //if resultingTuples != null
					//				enter the tuples into the operator
					predicateManager.enterTuplesOptimized(
						new ArrayList(tuples));
					//update the selectivity of each predicate type after processing the tuples
					predicateManager.updateSelectivites();
				} //if tuples is not empty
			} //if aqueue has enough tuples
		} //for each incoming tuples
	}

	/**
	 * Runs the actual operator.
	 *
	 * Unlike in Rainbow, the Stream operators have the implementation tied to the operator
	 * because the StreamOperators represent physical operators instead of Logic.
	 * Creation date: (1/13/2003 1:54:47 PM)
	 */
	public void run_XATTuple() {
		parsePlan = true;
		int howMany = 10;
		/** get the tuples */
		//for each queue using the round robin approach
		Iterator it = this.getInputQueues();
		while (it.hasNext()) {
			XATQueue aqueue = (XATQueue) it.next();
			//dequeue 10 tuples
			if (aqueue.getQueueSize() < howMany) {
				howMany = aqueue.getQueueSize();
			} else
				howMany = 10;
			List XATtuples = aqueue.dequeueN(howMany, this);
			if (!XATtuples.isEmpty()) {
				String queueString = aqueue.getSchema().getName().toString();
				JugglerTuple[] tuples =
					setTupleStreamNames(XATtuples, queueString);
				//proecess tuples
				ArrayList resultingTuples = processTuples_XATTuple(tuples);
				System.out.println("\n-------------------------------------\n");
				printOutForDebugging(resultingTuples);
				if (resultingTuples != null) {
					int numresultingTuples = resultingTuples.size();

					//enqueue the resulting tuples to the output queue
					if (numresultingTuples > 0) {
						printOutForDebugging(resultingTuples);
						/** now enqueue the tuples */
						outputQueues_XATTuple(resultingTuples);
					}
				}
				//if resultingTuples != null
				//				enter the tuples into the operator
				predicateManager.enterTuplesOptimized_XATTuples(tuples);
				//update the selectivity of each predicate type after processing the tuples
				predicateManager.updateSelectivites();
			} //if tuples is not empty
		} //if aqueue has enough tuples
		//for each incoming tuples
	}

	/**
	 * Runs the actual operator.
	 *
	 * Unlike in Rainbow, the Stream operators have the implementation tied to the operator
	 * because the StreamOperators represent physical operators instead of Logic.
	 * Creation date: (1/13/2003 1:54:47 PM)
	 */

	public boolean run() {

		parsePlan = true;
		/** get the tuples */
		//for each queue using the round robin approach
		System.out.println("Entered XATJugglerOperatorImp run");
		//
		if (predicateManager == null) {
			System.out.println("Predicate Manager is NULL!!!!");

			Iterator it = this.getInputQueues();
			while (it.hasNext()) {
				XATQueue aInputQueue = (XATQueue) it.next();
				if (aInputQueue.getQueueName().length() == 0) {
					System.out.println(
						"all queues have not been stream changed");
					return true;
				}
			}

			System.out.println(
				"Initializing with "
					+ this.numQueues
					+ ", "
					+ this.queryInfo
					+ ", "
					+ this.attrPred
					+ ", "
					+ this.joinPred
					+ ", "
					+ this.windowPred);
			initialize(
				this.numQueues,
				this.queryInfo,
				this.attrPred,
				this.joinPred,
				this.windowPred);
			System.out.println("initialization done");
			System.out.println(predicateManager.toString());
		}

		int i = 0;
		Iterator inputQueuesIt = this.getInputQueues();
		while (inputQueuesIt.hasNext()) {
			int howMany = 2;
			System.out.println("The " + i + "th queue.");
			XATQueue aqueue = (XATQueue) inputQueuesIt.next();
			//dequeue 10 tuples
			if (aqueue.getQueueSize() < howMany)
				howMany = aqueue.getQueueSize();
			System.out.println("Dequeuing " + howMany + " tuples.");
			List XATtuples = aqueue.dequeueN(howMany, this);
			if (!XATtuples.isEmpty()) {

				String queueString = aqueue.getSchema().getName().toString();
				JugglerTuple[] tuples =
					setTupleStreamNames(XATtuples, queueString);
				//proecess tuples
				ArrayList resultingTuples = processTuples_XATTuple(tuples);
				System.out.println("\n-------------------------------------\n");
				printOutForDebugging(resultingTuples);
				if (resultingTuples != null) {
					int numresultingTuples = resultingTuples.size();

					//enqueue the resulting tuples to the output queue
					if (numresultingTuples > 0) {
						printOutForDebugging(resultingTuples);
						/** now enqueue the tuples */
						outputQueues_XATTuple(resultingTuples);
					}
				}
				//if resultingTuples != null
				//				enter the tuples into the operator
				predicateManager.enterTuplesOptimized_XATTuples(tuples);
				//update the selectivity of each predicate type after processing the tuples
				predicateManager.updateSelectivites();
			} //if tuples is not empty
			i++;
		} //for each incoming tuples
		return true;
	}

	/**
	 * @param iterator
	 * @return
	 */
	private ArrayList processTuples_XATTuple(JugglerTuple[] jts) {
		//make sure they are JugglerTupleLists!!!
		//also check if this isn't the "first" tuples entering the system.
		if (!this.predicateManager.isExpStructuresEmpty_XATTuple())
			return this.predicateManager.processTuples_XATTuple(jts);
		else
			return null;
	}
	/**
	 * @param tuples
	 */
	private JugglerTuple[] setTupleStreamNames(
		List tuples,
		String streamName) {
		ArrayList streamNamesList = new ArrayList();

		JugglerTuple[] jtArray = new JugglerTuple[tuples.size()];
		for (int j = 0; j < streamName.length(); j++) {
			streamNamesList.add(j, streamName.substring(j, j + 1));
		}

		for (int i = 0; i < tuples.size(); i++) {
			XATTuple t = (XATTuple) tuples.get(i);
			String tupleClass = t.getClass().toString();
			if (!tupleClass
				.equals("class edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList")) {

				JugglerTuple jt = new JugglerTuple(t);
				jt.setStreamNames(streamNamesList);
				jtArray[i] = jt;
			}

		}
		return jtArray;
	}
	/**
	 * @param resultingTuples
	 */
	private void printOutForDebugging(ArrayList resultingTuples) {
		String result = "";
		if (resultingTuples == null) {
			System.out.println("This Operator had no results");
			return;
		}
		Iterator outputTuples = resultingTuples.iterator();
		while (outputTuples.hasNext()) {
			ArrayList resultTupleArray = (ArrayList) outputTuples.next();
			Iterator resultTupleIt = resultTupleArray.iterator();
			while (resultTupleIt.hasNext()) {
				JugglerTupleList resultTupleList =
					(JugglerTupleList) resultTupleIt.next();
				result += "Queries Satisfied: "
					+ resultTupleList
						.getFirstTuple()
						.getQuerySatisfied()
						.toString()
					+ " ";
				result += resultTupleList.getStreamNames().toString() + " ";
				JugglerTupleListIterator resultListIt =
					new JugglerTupleListIterator(resultTupleList);
				while (resultListIt.hasNext()) {
					JugglerTuple atuple = (JugglerTuple) resultListIt.next();
					result += atuple.toString() + " ";
				}
				result += "\n";
			}
			result += "\n";
			//result += resultTupleList.getFirstTuple().getPredicates().toString();
			//result += "\n \n \n";
		}
		System.out.println(result);
		System.out.println("DONE \n\n");

	}

	/**
	 * @param resultingTuples
	 */
	private void outputQueues(ArrayList resultingTuples) {
		int numQueryResults = resultingTuples.size();
		for (int i = 0; i < resultingTuples.size(); i++) {
			ArrayList array_element = (ArrayList) resultingTuples.get(i);
			JugglerTupleList atupleList =
				(JugglerTupleList) array_element.get(0);
			ArrayList queryNums = atupleList.getTuple().getQuerySatisfied();
			for (int j = 0; j < queryNums.size(); j++) {
				Integer queryNum = new Integer((String) queryNums.get(j));
				int queryIndexOutputQueue =
					((Integer) mappingOfQueriesToQueues.get(queryNum))
						.intValue();
				((XATQueue) outputQueue.get(queryIndexOutputQueue)).enqueue(
					array_element,
					this);
			}
		}

	}
	/**
		 * @param resultingTuples
		 */
	private void outputQueues_XATTuple(ArrayList resultingTuples) {
		int numQueryResults = resultingTuples.size();
		for (int i = 0; i < resultingTuples.size(); i++) {
			ArrayList array_element = (ArrayList) resultingTuples.get(i);
			JugglerTupleList atupleList =
				(JugglerTupleList) array_element.get(0);
			ArrayList queryNums = atupleList.getTuple().getQuerySatisfied();
			for (int j = 0; j < queryNums.size(); j++) {
				Integer queryNum = new Integer((String) queryNums.get(j));
				int queryIndexOutputQueue =
					((Integer) mappingOfQueriesToQueues.get(queryNum))
						.intValue();

				//set schema if not already done so
				XATQueue aqueue = this.getOutputQueue(
				/*queryIndexOutputQueue*/
				);

				if (array_element.isEmpty())
					return;
				ArrayList queueOutputTuples =
					convertToQueueOutputOrder(
						array_element,
						queryNum.intValue());
				ArrayList outputXATTuples = convertToXATTuples(
				/*array_element.iterator()*/
				queueOutputTuples.iterator());
				((XATQueue) outputQueue.get(queryIndexOutputQueue)).enqueue(
					outputXATTuples,
					this);
			}
		}

	}
	/**
	 * @param array_element
	 * @param queryNum
	 * @return
	 */
	private ArrayList convertToQueueOutputOrder(
		ArrayList array_element,
		int queryNum) {
		ArrayList outputTuples = new ArrayList();
		ArrayList queryStreams =
			this.predicateManager.getQDE().getQueryQED(queryNum).getStreams();
		Iterator queryStrIt = queryStreams.iterator();
		Iterator arrayIt = array_element.iterator();
		while (arrayIt.hasNext()) {
			JugglerTupleList element = (JugglerTupleList) arrayIt.next();
			JugglerTupleList tempTL = new JugglerTupleList();

			while (queryStrIt.hasNext()) {
				String aStr = (String) queryStrIt.next();
				ArrayList aStrArray = new ArrayList();
				aStrArray.add(aStr);
				JugglerTuple atuple =
					element.getTupleStream_XATTuple(aStrArray);
				tempTL.appendTupleList(new JugglerTupleList(atuple));
			}
			outputTuples.add(tempTL);
		}
		return outputTuples;
	}
	/**
	 * @param iterator
	 * @return
	 */
	private ArrayList convertToXATTuples(Iterator iter) {
		ArrayList dataValues = new ArrayList();
		ArrayList xatTuples = new ArrayList();
		while (iter.hasNext()) {
			JugglerTupleList element = (JugglerTupleList) iter.next();
			ArrayList streamNames = element.getStreamNames();
			JugglerTuple atuple = element.getFirstTuple();
			while (element != null) {
				atuple = element.getTuple();
				dataValues.addAll((atuple.getValues()));
				element = element.getNext();
			}
			XATDataValue[] data = new XATDataValue[dataValues.size()];
			for (int i = 0; i < dataValues.size(); i++) {
				data[i] = (XATDataValue) dataValues.get(i);
			}
			XATTupleImp newTuple = new XATTupleImp();
			newTuple.setValues(data);
			xatTuples.add(newTuple);
			dataValues = new ArrayList();
		}
		return xatTuples;
	}
	/**
	 * Sets the maximum window of this node.
	 * Creation date: (1/12/2003 10:36:31 PM)
	 * @param newMaxWin long
	 */
	protected void setMaxWin(long newMaxWin) {
		MaxWin = newMaxWin;
	}
	/**
	 * Sets the predicate manager of this node.
	 * Creation date: (1/12/2003 10:36:58 PM)
	 * @param newPredicateManager juggler.predicatemanagers.PredicateOrderingManager
	 */
	protected void setPredicateManager(PredicateOrderingManager newPredicateManager) {
		predicateManager = newPredicateManager;
	}
	/**
	 * Sets the QDE of this node.
	 * Creation date: (1/12/2003 10:37:17 PM)
	 * @param newQde juggler.exploitationstructures.QueryDependentEncoding
	 */
	protected void setQde(QueryDependentEncoding newQde) {
		inputQDE = newQde;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (1/9/2003 9:46:43 PM)
	 * @param newStreamIDs int[]
	 */
	protected void setStreamIDs(int[] newStreamIDs) {
		streamIDs = newStreamIDs;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/5/2003 8:53:22 AM)
	 * @return java.lang.String
	 */
	public String toString() {
		return "XATJugglerOperatorImp " /*+ this.queueStreamNames.toString() + "  "*/;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperatorImp#init()
	 */
	public void init() {
		// TODO Auto-generated method stub

	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#toToolTipString()
	 */
	public String toToolTipString() {
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * @return
	 */
	public boolean isParsePlan() {
		return parsePlan;
	}

	/**
	 * @param b
	 */
	public void setParsePlan(boolean b) {
		parsePlan = b;
	}

	/**
	 * @return
	 */
	public int getHowMany() {
		return howMany;
	}

	/**
	 * @param i
	 */
	public void setHowMany(int i) {
		howMany = i;
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator#getStateSize()
	 */
	public int getStateSize() {
		// TODO Asima
		return 0;
	}

}
