package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.client;

import edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.Packet;

/**
 * @author 
 * Interface to remove packets from the PacketPool
 */
public interface Consumer {
	/**
	 * Removes the 1st packet from the packet pool and returns it
	 * @return Packet
	 * @throws InterruptedException
	 */
	public Packet removePacket() throws InterruptedException;
}