package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;



/**
 * @author Administrator
 *
 * This interface is used to access the client pool
 */
public interface Accessor {
	/**
	 * This method returns an array of client sockets registered for 
	 * a single stream
	 * @param streamName
	 * @return
	 */
	public abstract Client[] getClients(String streamName);
	/**
	 * This method removes a client from the stream
	 * Note this method will not be called frequently therefore
	 * the scan of the hashMap is good enough
	 * @param s
	 */
	public abstract void removeClient(Client c); 
	
}