package edu.wpi.cs.dsrg.xmldb.xat.rsox;

import junit.framework.TestCase;

public class PuncParserTest extends TestCase {

	/*
	 * Test method for 'edu.wpi.dsrg.rsox.PuncParser.parsePunc(String)'
	 */
	public void testParsePunc() {
		
		try
		{
			String[] ret = PuncParser.parsePunc("((/news, inf, COUNT), (/news/category, /news/paragraph, * ), + )");
			for (int i = 0 ; i < 6 ; i ++)
			{				
				assertTrue(ret[0].equals("/news"));
				assertTrue(ret[1].equals("inf"));
				assertTrue(ret[2].equals("COUNT"));
				assertTrue(ret[3].equals("/news/category"));
				assertTrue(ret[4].equals("/news/paragraph"));
				assertTrue(ret[5].equals("*"));
				assertTrue(ret[6].equals("+"));
			}
		}
		catch (Exception e)
		{
			fail();
			e.printStackTrace();
		}
	}
}
