

	package edu.wpi.cs.dsrg.xmldb.xat.testing;

	import java.io.BufferedWriter;
	import java.io.FileNotFoundException;
	import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
	import edu
		.wpi
		.cs
		.dsrg
		.xmldb
		.xat
		.common
		.operator
		.streamoperator
		.schedulemode
		.BottomUpPipelineScheduler;
	import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DagTraversal;

	/**
	 * @author suhong
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	public class TestBaseLocal {

		public static void main(java.lang.String[] args)
			throws FileNotFoundException {

			int repeatingTimes = 1;

			String schemaFileName = null;
			String queryFileName = null;
			String xmlFileName = null;
			String outputFileName = null;

			if (args.length == 3) {
				schemaFileName = args[0];
				queryFileName = args[1];
				xmlFileName = args[2];				
			} else if (args.length == 5) {
				schemaFileName = args[0];
				queryFileName = args[1];
				xmlFileName = args[2];
				outputFileName = args[3];
				repeatingTimes = Integer.parseInt(args[4]);
			} else
				return;

			XATDag phyDag2 = UtilForTesting.genPhyXATDag(queryFileName);
				
			UtilForTesting.setDataDriven(phyDag2);
			UtilForTesting.setUpAuto(phyDag2);
			System.out.println("base one:");
			DagTraversal.printDag(phyDag2);

			System.out.println("begin execution...");

			BufferedWriter out = null;
			try {
			//out = new BufferedWriter(new FileWriter(outputFileName));
			} catch (Exception e) {
				e.printStackTrace();
			}

			BottomUpPipelineScheduler scheduler =
				new BottomUpPipelineScheduler(phyDag2);

			int outputNum = 0;

			for (int i = 0; i < repeatingTimes; i++) {
				outputNum =
					UtilForTesting.execute(scheduler, phyDag2, xmlFileName, i);
				System.gc();	
			}

			//UtilForTesting.statisticsTime(out, repeatingTimes, outputNum);

			try {
				//out.flush();
				//out.close();
			} catch (Exception e) {
				e.printStackTrace();
			}

			/*BottomUpPipelineScheduler scheduler =
				new BottomUpPipelineScheduler(phyDag);
		
			//set up input first,
			FileInputStream fis = new FileInputStream(xmlFileName);
			BufferedInputStream bis = new BufferedInputStream(fis, 1000000);
		
			//BufferedInputStream bis =
			//	new BufferedInputStream(socket.getInputStream());
		
			//ObjectInputStream ois = new ObjectInputStream(bis);
			// sourceOps[m].setInputTokenQueue(tokenQueue);
			//sourceOps[0].setP(ois);
			XMLScanStream sourceOp =
				(XMLScanStream) phyDag.getLeaves()[0].getOperator();
		
			sourceOp.setB(bis);
			//sourceOps[0].setIs(socket.getInputStream());
			// sourceOps[m].setQueueCapacity(1000000);
		
			// TokenBuffer tokenBuffer = new TokenBuffer(1000000);
			// sourceOps[0].setTokenBuffer(tokenBuffer);
			scheduler.scheduling();
		
			Vector v = DagTraversal.dagBottomUpTraverse(phyDag);
			XATStreamOperator op =
				(XATStreamOperator) (((DagNode) v.get(v.size() - 1)).getOperator());
			int outputNum = ((TaggerStream) op).getOutputCount();
			System.out.println(outputNum + " tuples");
			((TaggerStream) op).setOutputCount(0);
			//clear the output queue to save memory
			op.getOutputQueue().removeAllTuples();
		
			//recordTimes();
		
			System.out.println("finished");
			*/
			System.out.println("finished");
		}

	}



