/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.impl.dom;

public class NodeListImpl
    extends xacute.util.NodeListDefaultImpl
{

    public NodeListImpl()
    {
	super();
    }
    
    public NodeListImpl( xacute.common.Node n )
    {
	this();
	add(n);
    }

    public NodeListImpl( org.w3c.dom.Node n )
    {
	this();
	add( new NodeImpl(n) );
    }

    public NodeListImpl( org.w3c.dom.NodeList nl )
    {
	this();
	for(int i=0; i < nl.getLength(); i++)
	    this.add( new NodeImpl(nl.item(i)) );
    }
    
}
