/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.QuiltException;

import java.util.Vector;

/**
 * This class represents the <b>INTERSECT</b> binary operator.
 */
public class BinOpIntersection
    extends BinOpNodeLists
{
    
    BinOpIntersection(QuiltExpression e, Vector v)
    {
	super(e,v, Constants.KEEP_INTER);
    }
    
/**
 * Insert the method's description here.
 * Creation date: (2/8/2002 10:57:59 PM)
 * @return xacute.quilt.QuiltExpression
 */
public QuiltExpression getE() {
	return e;
}

/**
 * Insert the method's description here.
 * Creation date: (2/8/2002 10:59:28 PM)
 * @return xacute.quilt.QuiltExpression[]
 */
public QuiltExpression[] getOperands() {
	return operands;
}
}






