package edu.wpi.cs.dsrg.demo;

import java.util.*;
import javax.swing.*;

import edu.wpi.cs.dsrg.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.common.dag.*;

/**
 * Insert the type's description here.
 * @author: Brad Pielech
 */
public class ReWriteGUI {
    private JButton ivjAddButton1 = null;
    private JList ivjHeuristicList = null;
    private JComboBox ivjHeuristicsCombo = null;
    private JFrame ivjReWriteParameterDialog = null;
    private JButton ivjReWriteStartButton = null;
    private JLabel ivjSelectReWriteHeuristicsLabel = null;
    IvjEventHandler ivjEventHandler = new IvjEventHandler();
    private javax.swing.ButtonGroup directionButtonGroup;
    private JPanel ivjReWriteContentPane = null;
    private JCheckBox ivjShowTreeCheckBox = null;
    private JButton ivjRemoveButton1 = null;
    protected javax.swing.DefaultListModel heuristicModel = null;
    protected edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree tree;
    protected BindingTable bindingTable;
    protected ReWriteGUIStepper stepGUI;
    protected java.lang.Object parentObject;
    protected java.util.Vector stepTrees;
    protected edu.wpi.cs.dsrg.xmldb.xat.component.gui.ProcessStep callbackGUI;

    class IvjEventHandler
        implements java.awt.event.ActionListener, javax.swing.event.ListSelectionListener {
        public void actionPerformed(java.awt.event.ActionEvent e) {

            if (e.getSource() == ReWriteGUI.this.getReWriteStartButton())
                connEtoC4(e);
            if (e.getSource() == ReWriteGUI.this.getAddButton1())
                connEtoC5(e);
            if (e.getSource() == ReWriteGUI.this.getRemoveButton1())
                connEtoC6(e);
        };
        public void valueChanged(javax.swing.event.ListSelectionEvent e) {

            if (e.getSource() == ReWriteGUI.this.getHeuristicList())
                connEtoC7();
        };
    };
    /**
     * ReWriteGUI constructor comment.
     */
    public ReWriteGUI() {
        super();
        initialize();
    }
    /**
     * Comment
     */
    public void addButton1_ActionPerformed(
        java.awt.event.ActionEvent actionEvent) {
        String newOp = (String) getHeuristicsCombo().getSelectedItem();
        if (!addSelectedHeuristic(newOp)) {
            JOptionPane.showMessageDialog(
                getReWriteParameterDialog(),
                "Please Select a new Heuristic");
        } else {
            getHeuristicList().setModel(this.heuristicModel);
        }
        return;

    }
    /**
     * Insert the method's description here.
     * 
     * @param newOp java.lang.String
     */
    public boolean addSelectedHeuristic(String newHeuristic) {
        if (this.heuristicModel.contains(newHeuristic)) {
            return false;
        } else {
            this.heuristicModel.addElement(newHeuristic);
        }
        return true;

    }
    /**
     * connEtoC4:  (ReWriteStartButton.action.actionPerformed(java.awt.event.ActionEvent) --> ReWriteGUI.reWriteStartButton_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
     * @param arg1 java.awt.event.ActionEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void connEtoC4(java.awt.event.ActionEvent arg1) {
        try {
            // user code begin {1}
            // user code end
            this.reWriteStartButton_ActionPerformed(arg1);
            // user code begin {2}
            // user code end
        } catch (java.lang.Throwable ivjExc) {
            // user code begin {3}
            // user code end
            handleException(ivjExc);
        }
    }
    /**
     * connEtoC5:  (AddButton1.action.actionPerformed(java.awt.event.ActionEvent) --> ReWriteGUI.addButton1_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
     * @param arg1 java.awt.event.ActionEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void connEtoC5(java.awt.event.ActionEvent arg1) {
        try {
            // user code begin {1}
            // user code end
            this.addButton1_ActionPerformed(arg1);
            // user code begin {2}
            // user code end
        } catch (java.lang.Throwable ivjExc) {
            // user code begin {3}
            // user code end
            handleException(ivjExc);
        }
    }
    /**
     * connEtoC6:  (RemoveButton1.action.actionPerformed(java.awt.event.ActionEvent) --> ReWriteGUI.removeButton1_ActionPerformed(Ljava.awt.event.ActionEvent;)V)
     * @param arg1 java.awt.event.ActionEvent
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void connEtoC6(java.awt.event.ActionEvent arg1) {
        try {
            // user code begin {1}
            // user code end
            this.removeButton1_ActionPerformed(arg1);
            // user code begin {2}
            // user code end
        } catch (java.lang.Throwable ivjExc) {
            // user code begin {3}
            // user code end
            handleException(ivjExc);
        }
    }
    /**
     * connEtoC7:  (HeuristicList.listSelection. --> ReWriteGUI.heuristicList_ListSelectionEvents()V)
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void connEtoC7() {
        try {
            // user code begin {1}
            // user code end
            this.heuristicList_ListSelectionEvents();
            // user code begin {2}
            // user code end
        } catch (java.lang.Throwable ivjExc) {
            // user code begin {3}
            // user code end
            handleException(ivjExc);
        }
    }
    /**
     * Return the AddButton1 property value.
     * @return javax.swing.JButton
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JButton getAddButton1() {
        if (ivjAddButton1 == null) {
            try {
                ivjAddButton1 = new javax.swing.JButton();
                ivjAddButton1.setName("AddButton1");
                ivjAddButton1.setText("Add");
                ivjAddButton1.setBounds(70, 119, 85, 25);
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjAddButton1;
    }
    /**
     * Insert the method's description here.
     * 
     * @return BindingTable
     */
    protected BindingTable getBindingTable() {
        return bindingTable;
    }
    /**
     * Insert the method's description here.
     * 
     * @return edu.wpi.cs.dsrg.xmldb.xat.component.gui.ProcessStep
     */
    public edu.wpi.cs.dsrg.xmldb.xat.component.gui.ProcessStep getCallbackGUI() {
        return callbackGUI;
    }
    /**
     * Return the HeuristicList property value.
     * @return javax.swing.JList
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JList getHeuristicList() {
        if (ivjHeuristicList == null) {
            try {
                ivjHeuristicList = new javax.swing.JList();
                ivjHeuristicList.setName("HeuristicList");
                ivjHeuristicList.setBounds(305, 32, 189, 151);
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjHeuristicList;
    }
    /**
     * Return the HeuristicsCombo property value.
     * @return javax.swing.JComboBox
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JComboBox getHeuristicsCombo() {
        if (ivjHeuristicsCombo == null) {
            try {
                ivjHeuristicsCombo = new javax.swing.JComboBox();
                ivjHeuristicsCombo.setName("HeuristicsCombo");
                ivjHeuristicsCombo.setBounds(34, 69, 158, 23);
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjHeuristicsCombo;
    }
    /**
     * Insert the method's description here.
     * 
     * @return java.lang.Object
     */
    public java.lang.Object getParentObject() {
        return parentObject;
    }
    /**
     * Return the RemoveButton1 property value.
     * @return javax.swing.JButton
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JButton getRemoveButton1() {
        if (ivjRemoveButton1 == null) {
            try {
                ivjRemoveButton1 = new javax.swing.JButton();
                ivjRemoveButton1.setName("RemoveButton1");
                ivjRemoveButton1.setText("Remove");
                ivjRemoveButton1.setBounds(170, 119, 85, 25);
                ivjRemoveButton1.setEnabled(false);
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjRemoveButton1;
    }
    /**
     * Return the JDialogContentPane3 property value.
     * @return javax.swing.JPanel
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JPanel getReWriteContentPane() {
        if (ivjReWriteContentPane == null) {
            try {
                ivjReWriteContentPane = new javax.swing.JPanel();
                ivjReWriteContentPane.setName("ReWriteContentPane");
                ivjReWriteContentPane.setLayout(null);
                getReWriteContentPane().add(
                    getSelectReWriteHeuristicsLabel(),
                    getSelectReWriteHeuristicsLabel().getName());
                getReWriteContentPane().add(
                    getHeuristicsCombo(),
                    getHeuristicsCombo().getName());
                getReWriteContentPane().add(getAddButton1(), getAddButton1().getName());
                getReWriteContentPane().add(
                    getReWriteStartButton(),
                    getReWriteStartButton().getName());
                getReWriteContentPane().add(
                    getShowTreeCheckBox(),
                    getShowTreeCheckBox().getName());
                getReWriteContentPane().add(getRemoveButton1(), getRemoveButton1().getName());
                getReWriteContentPane().add(getHeuristicList(), getHeuristicList().getName());
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjReWriteContentPane;
    }
    /**
     * Return the ReWriteParameterDialog property value.
     * @return javax.swing.JFrame
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JFrame getReWriteParameterDialog() {
        if (ivjReWriteParameterDialog == null) {
            try {
                ivjReWriteParameterDialog = new javax.swing.JFrame();
                ivjReWriteParameterDialog.setName("ReWriteParameterDialog");
                ivjReWriteParameterDialog.setDefaultCloseOperation(
                    javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
                ivjReWriteParameterDialog.setBounds(31, 47, 530, 318);
                ivjReWriteParameterDialog.setTitle("Set ReWrite Parameters");
                getReWriteParameterDialog().setContentPane(getReWriteContentPane());
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjReWriteParameterDialog;
    }
    /**
     * Return the ReWriteStartButton property value.
     * @return javax.swing.JButton
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JButton getReWriteStartButton() {
        if (ivjReWriteStartButton == null) {
            try {
                ivjReWriteStartButton = new javax.swing.JButton();
                ivjReWriteStartButton.setName("ReWriteStartButton");
                ivjReWriteStartButton.setText("Start ReWrite");
                ivjReWriteStartButton.setBounds(132, 252, 113, 25);
                ivjReWriteStartButton.setActionCommand("XQueryOkButton");
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjReWriteStartButton;
    }
    /**
     * Return the SelectReWriteHeuristicsLabel property value.
     * @return javax.swing.JLabel
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JLabel getSelectReWriteHeuristicsLabel() {
        if (ivjSelectReWriteHeuristicsLabel == null) {
            try {
                ivjSelectReWriteHeuristicsLabel = new javax.swing.JLabel();
                ivjSelectReWriteHeuristicsLabel.setName("SelectReWriteHeuristicsLabel");
                ivjSelectReWriteHeuristicsLabel.setText("Select Heuristic(s) to use");
                ivjSelectReWriteHeuristicsLabel.setBounds(34, 37, 153, 14);
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjSelectReWriteHeuristicsLabel;
    }
    /**
     * Return the ShowTreeCheckBox property value.
     * @return javax.swing.JCheckBox
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private javax.swing.JCheckBox getShowTreeCheckBox() {
        if (ivjShowTreeCheckBox == null) {
            try {
                ivjShowTreeCheckBox = new javax.swing.JCheckBox();
                ivjShowTreeCheckBox.setName("ShowTreeCheckBox");
                ivjShowTreeCheckBox.setText("Show XAT after each step");
                ivjShowTreeCheckBox.setBounds(25, 211, 179, 22);
                // user code begin {1}
                // user code end
            } catch (java.lang.Throwable ivjExc) {
                // user code begin {2}
                // user code end
                handleException(ivjExc);
            }
        }
        return ivjShowTreeCheckBox;
    }
    /**
     * Insert the method's description here.
     * 
     * @return java.util.Vector
     */
    public java.util.Vector getStepTrees() {
        return stepTrees;
    }
    /**
     * Insert the method's description here.
     * 
     * @return edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
     */
    public edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree getTree() {
        return tree;
    }
    /**
     * Called whenever the part throws an exception.
     * @param exception java.lang.Throwable
     */
    private void handleException(java.lang.Throwable exception) {

        /* Uncomment the following lines to print uncaught exceptions to stdout */
        System.out.println("--------- UNCAUGHT EXCEPTION ---------");
        exception.printStackTrace(System.out);
        System.out.println(exception.getMessage());
    }
    /**
     * Comment
     */
    public void heuristicList_ListSelectionEvents() {
        getRemoveButton1().setEnabled(true);
        return;
    }
    /**
     * Initializes connections
     * @exception java.lang.Exception The exception description.
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void initConnections() throws java.lang.Exception {
        // user code begin {1}
        // user code end

        getReWriteStartButton().addActionListener(ivjEventHandler);
        getAddButton1().addActionListener(ivjEventHandler);
        getRemoveButton1().addActionListener(ivjEventHandler);
        getHeuristicList().addListSelectionListener(ivjEventHandler);
    }
    /**
     * Initialize the class.
     */
    /* WARNING: THIS METHOD WILL BE REGENERATED. */
    private void initialize() {
        try {
            // user code begin {1}

            heuristicModel = new DefaultListModel();
            directionButtonGroup = new ButtonGroup();
            /*
            //add some types of operators to rewrite
            getOperatorsCombo().addItem("Navigate");
            getOperatorsCombo().addItem("NameColumn");
            getOperatorsCombo().addItem("Select");
            */
            //aReWriteGUI.getOperatorsCombo().addItem("OrderBy");
            getHeuristicsCombo().addItem("Computation Pushdown");
            getHeuristicsCombo().addItem("Rename Propagation");
            getHeuristicsCombo().addItem("Order Sensitive");
            getHeuristicsCombo().addItem("Cancel Duplicate Navigates");
            getHeuristicsCombo().addItem("Merge Taggers");
            getHeuristicsCombo().addItem("NavTag Cancelout");

            stepGUI = new ReWriteGUIStepper();
            stepTrees = new Vector();

            // user code end
            initConnections();
        } catch (java.lang.Throwable ivjExc) {
            handleException(ivjExc);
        }
        // user code begin {2}
        // user code end
    }
    /**
     * main entrypoint - starts the part when it is run as an application
     * @param args java.lang.String[]
     */
    public static void main(java.lang.String[] args) {
        try {
            ReWriteGUI aReWriteGUI;
            aReWriteGUI = new ReWriteGUI();
            aReWriteGUI.getReWriteParameterDialog().setVisible(true);

        } catch (Throwable exception) {
            System.err.println("Exception occurred in main() of java.lang.Object");
            exception.printStackTrace(System.out);
        }
    }
    /**
     * Comment
     */
    public void ok_ActionEvents() {
        return;
    }
    /**
     * Comment
     */
    public void removeButton1_ActionPerformed(
        java.awt.event.ActionEvent actionEvent) {
        getRemoveButton1().setEnabled(false);
        Object[] selectedValues = getHeuristicList().getSelectedValues();
        for (int i = 0; i < selectedValues.length; i++) {
            this.heuristicModel.removeElement(selectedValues[i]);
        }

        getHeuristicList().setModel(this.heuristicModel);
        return;

    }
    /**
     * Comment
     */
    public void reWriteStartButton_ActionPerformed(
        java.awt.event.ActionEvent actionEvent) {

        Vector typeVector = new Vector();
        typeVector.addElement(new String("Before ReWriting"));
        stepTrees.addElement(getTree().clone());
        boolean debug = false;
        /**
        * read in which heuristics to reWrite from the heuristicModel
        * and then determine the operators to use and the rest of pushdown 
        
        * after each heuritics, do pushdown, store the last tree in the setTree
        * then add in the trees after each operator
        */
        for (int i = 0; i < heuristicModel.size(); i++) {
            String heuristic = (String) heuristicModel.elementAt(i);
            //if the user selected Rename, then we push renames up 
            if (heuristic.startsWith("Rename")) {
                System.out.println("Doing Rename Propagation");
                Vector order = new Vector();
                Vector classList = new Vector();
                order.addElement(
                    new String("edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.NameColumnImp"));
                classList.addElement(
                    new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ComputationPushdownRules"));
                ReWriteRules rules = new ReWriteRules(classList);
                rules.setVariableTable(this.getBindingTable());
                ReWriteTraversal traverse =
                    new ReWriteTraversal(
                        this.getTree(),
                        rules,
                        order,
                        getShowTreeCheckBox().isSelected());
                setTree(traverse.doPushup());
                this.setBindingTable(rules.getVariableTable());
                //add all of the orders and intermediate trees 
                typeVector.addAll(order);
                if (traverse.getStepTrees() != null)
                    stepTrees.addAll(traverse.getStepTrees());
            } else
                if (heuristic.startsWith("Compu")) {
                    System.out.println("********** Nav/Tagger Cancel OUT*************");

                    BindingTable mergedTable =
                        (new BindingTableComputer()).computeBindingTable(this.getTree());
                    this.getTree().setBindingTable(mergedTable);

                    NavTaggerCancelout.cancelOut(this.getTree());

                    //first merge the Navigates
                    //first create a vector of the rule classes to look at
                    Vector classList = new Vector();
                    classList.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.MergeOperatorRules");
                    //instantiate the rules class 
                    ReWriteRules rules = new ReWriteRules(classList);

                    //now make the order of rules to look at
                    Vector order = new Vector();
                    System.out.println("**********Now merging navigates ************");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnestImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.DistinctImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.TaggerImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.GroupByImp");
                    //order.addElement(
                    //    "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.MergeImp");

                    //set the variable table in the rules class to be the hashtable from PT
                    rules.setVariableTable(this.getBindingTable());

                    //create the traversal strategy
                    ReWriteTraversal traverse = new ReWriteTraversal(this.getTree(), rules, order);

                    //Debug the traversal.

                    setTree(traverse.doPushdown());

                    System.out.println("********** Now rewriting the trees************");
                    ///////////////////////////// Now rewriting the rest of the tree ///////////			         

                    //first create a vector of the rule classes to look at
                    classList = new Vector();
                    String s1 =
                        new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ComputationPushdownRules");
                    classList.addElement(s1);

                    //instantiate the rules class
                    rules = new ReWriteRules(classList);

                    //now make the order of rules to look at
                    order = new Vector();
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.NameColumnImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnestImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.NameColumnImp");
                    order.addElement(
                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.SelectImp");
                    //set the variable table in the rules class to be the hashtable from PT
                    rules.setVariableTable(this.getBindingTable());

                    //create the traversal strategy

                    traverse = new ReWriteTraversal(this.getTree(), rules, order);

                    //Debug the traversal.

                    setTree(traverse.doPushdown());

                    this.setBindingTable(rules.getVariableTable());
                    typeVector.addAll(order);
                    if (traverse.getStepTrees() != null)
                        stepTrees.addAll(traverse.getStepTrees());

                } else
                    if (heuristic.startsWith("Cancel Duplicate")) {
                        System.out.println("Canceling Navigates");

                        Vector cancelClassList = new Vector();
                        Vector cancelOrder = new Vector();
                        cancelOrder.addElement(
                            "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavigateImp");
                        cancelClassList.addElement(
                            "edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.CancelOutNavigateRules");
                        ReWriteRules cancelRules = new ReWriteRules(cancelClassList);
                        cancelRules.setVariableTable(this.getBindingTable());
                        /*CancelOutTraversal cancelTraverse =
                            new CancelOutTraversal(
                                this.getTree(),
                                cancelRules,
                                cancelOrder,
                                getShowTreeCheckBox().isSelected());
                        setTree(cancelTraverse.doCancelOut());*/
						ReWriteTraversal rewriteTraverse =
							new ReWriteTraversal(
								this.getTree(),
								cancelRules,
								cancelOrder,
								getShowTreeCheckBox().isSelected());
						setTree(rewriteTraverse.doRewrite(ReWriteTraversal.DOWN));
                        this.setBindingTable(cancelRules.getVariableTable());
                        typeVector.addAll(cancelOrder);
                        if (rewriteTraverse.getStepTrees() != null)
                            stepTrees.addAll(rewriteTraverse.getStepTrees());

                    } else
                        if (heuristic.startsWith("NavTag")) {
                            System.out.println("**********Nav/Tagger Cancel OUT*************");

                            BindingTable mergedTable =
                                (new BindingTableComputer()).computeBindingTable(this.getTree());
                            this.getTree().setBindingTable(mergedTable);

                            NavTaggerCancelout.cancelOut(this.getTree());
                            stepTrees.add(this.getTree());
                        } else
                            if (heuristic.startsWith("Merge")) {
                                System.out.println("**********Now merging Taggers ************");
                                //first merge the Navigates
                                //first create a vector of the rule classes to look at
                                Vector classList = new Vector();
                                classList.addElement(
                                    "edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.MergeOperatorRules");
                                //instantiate the rules class 
                                ReWriteRules rules = new ReWriteRules(classList);

                                //now make the order of rules to look at
                                Vector order = new Vector();
                                order.addElement(
                                    "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.TaggerImp");
                                order.addElement(
                                    "edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.MergeImp");

                                //set the variable table in the rules class to be the hashtable from PT
                                rules.setVariableTable(this.getBindingTable());

                                //create the traversal strategy
                                ReWriteTraversal traverse = new ReWriteTraversal(this.getTree(), rules, order);

                                //Debug the traversal.
                                traverse.setDebug(debug);

                                setTree(traverse.doPushdown());

                                this.setBindingTable(rules.getVariableTable());
                                typeVector.addAll(order);
                                if (traverse.getStepTrees() != null)
                                    stepTrees.addAll(traverse.getStepTrees());
                            } else
                                if (heuristic.startsWith("Order Sens")) {
                                    // First fix any groupby's that may be nested
                                    System.out.println(
                                        "**********Now swapping position/order functions ************");
                                    Vector order = new Vector();
                                    Vector classList = new Vector();
                                    order.addElement(
                                        new String("edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.GroupByImp"));
                                    classList.addElement(
                                        new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.MergeOperatorRules"));
                                    ReWriteRules rules = new ReWriteRules(classList);
                                    rules.setVariableTable(this.getBindingTable());
                                    ReWriteTraversal traverse =
                                        new ReWriteTraversal(
                                            this.getTree(),
                                            rules,
                                            order,
                                            getShowTreeCheckBox().isSelected());
                                    setTree(traverse.doPushdown());
                                    this.setBindingTable(rules.getVariableTable());
                                    //add all of the orders and intermediate trees 
                                    typeVector.addAll(order);
                                    if (traverse.getStepTrees() != null)
                                        stepTrees.addAll(traverse.getStepTrees());

                                    //Second, find all "unnested" groupbys and run position rewrite rules over them
                                    Vector classListOrder = new Vector();
                                    classListOrder.addElement(
                                        "edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.ReWritePositionRules");
                                    //instantiate the rules class 
                                    ReWriteRules rulesOrder = new ReWriteRules(classListOrder);

                                    //now make the order of rules to look at
                                    Vector orderPos = new Vector();
                                    orderPos.addElement(
                                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.GroupByImp");
                                    orderPos.addElement(
                                        "edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.function.FunctionImp");

                                    //set the variable table in the rules class to be the hashtable from PT
                                    rulesOrder.setVariableTable(this.getTree().getBindingTable());

                                    //create the traversal strategy
                                    ReWriteTraversal traverseOrder =
                                        new ReWriteTraversal(this.getTree(), rulesOrder, orderPos);

                                    traverseOrder.doPushdown();

                                    this.setBindingTable(rulesOrder.getVariableTable());
                                    typeVector.addAll(orderPos);
                                    if (traverseOrder.getStepTrees() != null)
                                        stepTrees.addAll(traverseOrder.getStepTrees());

                                }

        }
        ((ReWriteStep) getCallbackGUI()).setUserBindingTable(this.getBindingTable());
        if (getShowTreeCheckBox().isSelected()) {
            stepGUI.setStepTrees(getStepTrees());
            stepGUI.setLastType(typeVector);
            stepGUI.run();
            //call the callback method with the last tree in stepTrees
            XATTree tree = (XATTree) stepTrees.elementAt(stepTrees.size() - 1);
            ((ReWriteStep) getCallbackGUI()).reWriteGUICallBack(tree);
        } else {
            ((ReWriteStep) getCallbackGUI()).reWriteGUICallBack(getTree());
        }
        //after pushdown has finished, hide the main gui
        getReWriteParameterDialog().setVisible(false);

        return;
    }
/**
 * Show the GUI
 * 
 */
public void run() {

    //show the GUI
    //getReWriteParameterDialog().setVisible(true);

    /**
     * LING: Now we get rid of flying window.
     * Directly using fixed rewrite.
     */
    Vector typeVector = new Vector();
    typeVector.addElement(new String("Before ReWriting"));
    stepTrees.addElement(getTree().clone());
    boolean debug = false;

    XATTree treeRewrite = this.getTree();
    
    //adding MPO node.
	RewriteUtilities.MPORewrite(treeRewrite, false);
	
	//recompute the binding table before the rewrite
	BindingTable mergedTable =
		(new BindingTableComputer()).computeBindingTable(treeRewrite);
	treeRewrite.setBindingTable(mergedTable);

	//first cancel out the duplicate navigate-tagger pair
	NavTaggerCancelout.cancelOut(treeRewrite);

	if (debug)
		System.out.println("**********Now cleaning the XAT************");
	XATCleanUp.doCleanUp(treeRewrite);

	System.out.println("********** Now rewriting the trees************");
	///////////////////////////// Now rewriting the rest of the tree ///////////			         

	Vector classList = new Vector();
	String s1 =
		new String("edu.wpi.cs.dsrg.xmldb.xat.component.xatrewrite.common.dag.ComputationPushdownRules");
	classList.addElement(s1);

	//instantiate the rules class 
	ReWriteRules rules = new ReWriteRules(classList);

	//now make the order of Operator types to look at
	Vector order = new Vector();
	order.addElement(
		"edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp");
	order.addElement(
		"edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnestImp");
	order.addElement(
		"edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp");
	order.addElement(
		"edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.SelectImp");
	//set the variable table in the rules class to be the hashtable from PT
	rules.setVariableTable(treeRewrite.getBindingTable());

	//create the traversal strategy
	ReWriteTraversal traverse = new ReWriteTraversal(treeRewrite, rules, order);

    setTree(traverse.doPushdown());

	if (debug)
		System.out.println("**********Now cleaning the XAT************");
	XATCleanUp.doCleanUp(treeRewrite);

	//get rid of the MPO
	RewriteUtilities.MPORewrite(treeRewrite, true);
	//RewriteUtilities.DagToTreeRewrite(treeRewrite);
	((XATDag)treeRewrite).cleanup();
    this.setBindingTable(rules.getVariableTable());
    typeVector.addAll(order);
    if (traverse.getStepTrees() != null)
        stepTrees.addAll(traverse.getStepTrees());

    ((ReWriteStep) getCallbackGUI()).setUserBindingTable(this.getBindingTable());
    if (getShowTreeCheckBox().isSelected()) {
        stepGUI.setStepTrees(getStepTrees());
        stepGUI.setLastType(typeVector);
        stepGUI.run();
        //call the callback method with the last tree in stepTrees
        XATTree tree = (XATTree) stepTrees.elementAt(stepTrees.size() - 1);
        ((ReWriteStep) getCallbackGUI()).reWriteGUICallBack(tree);
    } else {
        ((ReWriteStep) getCallbackGUI()).reWriteGUICallBack(getTree());
    }
    //after pushdown has finished, hide the main gui
    getReWriteParameterDialog().setVisible(false);

    return;
}
    /**
     * Insert the method's description here.
     * 
     * @param newBindingTable BindingTable
     */
    public void setBindingTable(BindingTable newBindingTable) {
        bindingTable = newBindingTable;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newCallbackGUI edu.wpi.cs.dsrg.xmldb.xat.component.gui.ProcessStep
     */
    public void setCallbackGUI(ProcessStep newCallbackGUI) {
        callbackGUI = newCallbackGUI;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newParentObject java.lang.Object
     */
    public void setParentObject(java.lang.Object newParentObject) {
        parentObject = newParentObject;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newStepTrees java.util.Vector
     */
    public void setStepTrees(java.util.Vector newStepTrees) {
        stepTrees = newStepTrees;
    }
    /**
     * Insert the method's description here.
     * 
     * @param newTree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
     */
    public void setTree(XATTree newTree) {
        tree = newTree;
    }
}