package edu.wpi.cs.dsrg.demo;

import javax.swing.*;
import java.awt.*;

/**
 * Insert the type's description here.
 * Creation date: (5/6/02 3:56:21 PM)
 * @author: Xin Zhang
 */
public class SQLFrame extends javax.swing.JFrame {
	
	private SQLHighLitePane XHLPsql = null;

/**
 * sqlFrame constructor comment.
 */
public SQLFrame() {
	this("sql");
}
/**
 * sqlFrame constructor comment.
 * @param title java.lang.String
 */
public SQLFrame(String title) {
	super(title);
	initialize();
}
/**
 * Called whenever the part throws an exception.
 * @param exception java.lang.Throwable
 */
private void handleException(java.lang.Throwable exception) {

	/* Uncomment the following lines to print uncaught exceptions to stdout */
	System.out.println("--------- UNCAUGHT EXCEPTION ---------");
	exception.printStackTrace(System.out);
}
/**
 * Initialize the class.
 */
/* WARNING: THIS METHOD WILL BE REGENERATED. */
private void initialize() {
	try {
		setName("sqlFrame");
		setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
		getContentPane().setLayout(new BorderLayout());
		XHLPsql = new SQLHighLitePane();
		XHLPsql.setName("JTextPane1");
		JScrollPane ivjJScrollPane1 = new JScrollPane(XHLPsql);
		getContentPane().add(ivjJScrollPane1, BorderLayout.CENTER);
	} catch (java.lang.Throwable ivjExc) {
		handleException(ivjExc);
	}
}
/**
 * main entrypoint - starts the part when it is run as an application
 * @param args java.lang.String[]
 */
public static void main(java.lang.String[] args) {
	try {
		SQLFrame asqlFrame;
		asqlFrame = new SQLFrame();
		asqlFrame.addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent e) {
				System.exit(0);
			};
		});
		asqlFrame.show();
		java.awt.Insets insets = asqlFrame.getInsets();
		asqlFrame.setSize(asqlFrame.getWidth() + insets.left + insets.right, asqlFrame.getHeight() + insets.top + insets.bottom);
		asqlFrame.setVisible(true);
		asqlFrame.readFile("test.qlt");
	} catch (Throwable exception) {
		System.err.println("Exception occurred in main() of javax.swing.JFrame");
		exception.printStackTrace(System.out);
	}
}
/**
 * Read a sql into this Frame.
 * Also need to refresh the frame.
 * Creation date: (5/14/02 11:39:00 AM)
 * @param filename java.lang.String
 */
public void readFile(String filename) {
	// load the sql.
	String sqlString = new String("Select R.name, R.position\nFrom teams as R\nWhere R.Name = \"Red Sox\"");
	XHLPsql.readString(sqlString);
	XHLPsql.doHighLite();
}
}
