package edu.wpi.cs.dsrg.demo.raindropdemo;



import edu.wpi.cs.dsrg.utils.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import java.util.Hashtable;
import javax.swing.*;

import edu.wpi.cs.dsrg.xmldb.xat.testfiles.TestSXE;
import edu.wpi.cs.dsrg.xmldb.xat.testing.*;

import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.AutoDistiller;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RaindropPhysicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RaindropLogicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.constructor.RuleBaseRaindropLogicalPlanGenerator;
import edu.wpi.cs.dsrg.xmldb.xat.testing.TestCases;

import edu.wpi.cs.dsrg.xmldb.xat.component.xatdaggeneration.DagParserTraverse;
import edu.wpi.cs.dsrg.xmldb.xat.component.xatdaggeneration.DagQueryDecorrelation;
import edu.wpi.cs.dsrg.xmldb.xat.component.xattreegeneration.*;
import xacute.quilt.*;
import att.grappa.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;






import java.util.HashSet;
import java.util.Set;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDag;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATDagImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.ColumnNameNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.ColumnNameNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.RootNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.RootNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.TagNode;
import edu.wpi.cs.dsrg.xmldb.xat.common.dompattern.TagNodeImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.expression.TerminalExpressionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnNameImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.specialoperator.SourceImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.Select;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.sqloperator.SelectImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavCollectionImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.NavUnnestImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.Tagger;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.TaggerImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NavigationStep;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.NodeStepImp;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.common
	.operator
	.xmloperator
	.navigation
	.VarStepImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.BinCOMPExpressionStr;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.DOMPatternImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.Pattern;
import edu.wpi.cs.dsrg.xmldb.xat.component.automata.sqo.QueryGraphNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.GrappaCreator;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.NodeContainer;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.NodeListener;
import edu.wpi.cs.dsrg.xmldb.xat.component.gui.ProcessStep;









/**
 * Insert the type's description here.
 * @Createdate: 2004 by Underdog
 */
public class RDPlanGenerationStep extends ProcessRDStep {
	protected java.lang.String userQuery;
	protected java.lang.String viewQuery;
	protected java.lang.String queryToUse;
	protected int mappingSet;
	protected int paraSet;
	protected int paraSet2;
/**
 * GenerationStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 * @param viewXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public RDPlanGenerationStep(XATTree userXAT, XATTree viewXAT, String userQ, String viewQ, int mappingWay, int paraNum, int paraNum2) {
	super(userXAT, viewXAT);
	userQuery = userQ;
	viewQuery = viewQ;
	setTabName("Logical Plan!");
	setTabTip("Generate the Raindrop Logical Plan");
	setContentPane(new JSplitPane(JSplitPane.VERTICAL_SPLIT));
	JSplitPane thisPane = (JSplitPane)getContentPane();
	thisPane.setOneTouchExpandable(true);
	thisPane.setDoubleBuffered(true);
	mappingSet = mappingWay;
	paraSet = paraNum;
	paraSet2 = paraNum2;
}
/**
 * GenerationStep constructor comment.
 * @param userXAT edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
public RDPlanGenerationStep(XATTree userXAT, String userQ, int mappingWay, int paraNum, int paraNum2) {
	super(userXAT);
	userQuery = userQ;
	setTabName("Logical Plan");
	setTabTip("Generate the Raindrop Logical Plan");
	setContentPane(new JScrollPane());
	mappingSet = mappingWay;
	paraSet = paraNum;
	paraSet2 = paraNum2;
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 * @param tree edu.wpi.cs.dsrg.xmldb.xat.common.treestructure.XATTree
 */
protected JPanel execute(int queryType) {
	


	QuiltParser parser = new QuiltParser();
	QuiltQuery qq = null;
    
	// create a dummy tree Used to handle only one query is available.
	XATTree tree = new XATTreeImp();
	
	NodeContainer nc;
	NodeListener nl;
	GrappaPanel gp;
	DagParserTraverse pt1 = new DagParserTraverse();

	
	System.setProperty(
		edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.OperatorFactory.factoryID,
		"edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.PersistentOperatorFactory");
	
	//System.setProperty(OperatorFactory.factoryID, "edu.wpi.cs.dsrg.xmldb.xat.component.operatorfactory.StreamOperatorFactory");
		
	// a flag to decide wether we will skip the Tree generation of this current query (e.g., user/view).
	boolean skip = false; //default is not.

	// if the getQueryToUse() is empty, or null, skip the parsing and generate an empty tree.
	String queryToUse = getQueryToUse();
	if (queryToUse == null) {
		skip = true;
	} else if (queryToUse.length() == 0) {
		skip = true;
	}

	try {

		if (!skip) {
			qq = parser.parseQuery(getQueryToUse());
			pt1.visit(qq);
			tree = pt1.getTree();
		}
	



		//source operator from handwriting, using as backup debug
		/*
		DagNode sourceNode = new DagNodeImp();
		XATOperator sourceOp =
			new SourceImp(sourceNode, "auction.xml", SourceImp.XML);
		sourceNode.setOperator(sourceOp);
		sourceOp.setOutputColumnName("$s");
		//navigate(source, open_auction_list/auction/bid->$o)/////////////////////////////////////////
		DagNode navNode1 = new DagNodeImp();
		NavigationStep[] navSteps0 = new NavigationStep[1];
		navSteps0[0] = new NodeStepImp("$s");
		NavigationStep[] navSteps1 = new NavigationStep[3];
		navSteps1[0] = new NodeStepImp("open_auction_list");
		navSteps1[1] = new NodeStepImp("auction");
		navSteps1[2] = new NodeStepImp("bid");
		XATOperator navOp1 = new NavUnnestImp(navNode1, navSteps0, navSteps1);
		navOp1.setOutputColumnName("$o");
		navNode1.setOperator(navOp1);
		navNode1.addChild(sourceNode);
		sourceNode.addParent(navNode1);
		//nav($o, /bidder->$b)
		DagNode navNode2 = new DagNodeImp();
		NavigationStep[] entry2 = new NavigationStep[1];
		entry2[0] = new VarStepImp("$o");
		NavigationStep[] navSteps2 = new NavigationStep[1];
		navSteps2[0] = new NodeStepImp("bidder");
		XATOperator navOp2 = new NavUnnestImp(navNode2, entry2, navSteps2);
		navOp2.setOutputColumnName("$b");
		navNode2.setOperator(navOp2);
		navNode2.addChild(navNode1);
		navNode1.addParent(navNode2);
		DagNode navNode3 = new DagNodeImp();
		NavigationStep[] navSteps3 = new NavigationStep[1];
		NavigationStep[] navSteps4 = new NavigationStep[2];
		navSteps3[0] = new VarStepImp("$b");
		navSteps4[0] = new NodeStepImp(QueryGraphNode.WILDCARD);
		navSteps4[1] = new NodeStepImp("phone");
		XATOperator navOp3 =
			new NavCollectionImp(navNode3, navSteps3, navSteps4);
		navOp3.setOutputColumnName("$name");
		navNode3.setOperator(navOp3);
		navNode3.addChild(navNode2);
		navNode2.addParent(navNode3);
		DagNode selectNode1 = new DagNodeImp();
		//create the expression for the predicate of the select of the operator
		ColumnName expressionColLeft = new ColumnNameImp("$name");
		TerminalExpressionImp eLeft =
			new TerminalExpressionImp(expressionColLeft);
		TerminalExpressionImp eRight = new TerminalExpressionImp("abc");
		BinCOMPExpression bin = new BinCOMPExpressionImp(eLeft, eRight);
		bin.setType(BinCOMPExpressionStr.EQ);
		Select selectOp1 = new SelectImp(selectNode1, bin);
		selectNode1.setOperator(selectOp1);
		selectNode1.addChild(navNode3);
		navNode3.addParent(selectNode1);
		//tagger
		DagNode taggerNode1 = new DagNodeImp();
		RootNode rootNodeForTag = new RootNodeImp();
		TagNode tag = new TagNodeImp("result");
		rootNodeForTag.addChild(tag);
		tag.setParent(rootNodeForTag);
		TagNode tag1 = new TagNodeImp("ouro");
		tag.addChild(tag1);
		tag1.setParent(tag);
		ColumnNameNode col1 = new ColumnNameNodeImp("$o");
		tag1.addChild(col1);
		col1.setParent(tag1);
		TagNode tag2 = new TagNodeImp("ourb");
		tag.addChild(tag2);
		ColumnNameNode col2 = new ColumnNameNodeImp("$b");
		tag2.addChild(col2);
		col2.setParent(tag2);
		Pattern pattern = new DOMPatternImp(rootNodeForTag);
		//Pattern pattern = new ListPatternImp(colNames);
		Tagger taggerOp = new TaggerImp(taggerNode1, pattern);
		taggerOp.setOutputColumnName("$final");
		taggerNode1.setOperator(taggerOp);
		taggerNode1.addChild(selectNode1);
		selectNode1.addParent(taggerNode1);
		//set up schema for each node
		Set schemaForSourceNode = new HashSet();
		schemaForSourceNode.add("$s");
		sourceNode.setSchema(schemaForSourceNode);
		Set schemaForNavNode1 = new HashSet();
		schemaForNavNode1.add("$o");
		navNode1.setSchema(schemaForNavNode1);
		Set schemaForNavNode2 = new HashSet();
		schemaForNavNode2.add("$o");
		schemaForNavNode2.add("$b");
		navNode2.setSchema(schemaForNavNode2);
		Set schemaForNavNode3 = new HashSet();
		schemaForNavNode3.add("$o");
		schemaForNavNode3.add("$b");
		schemaForNavNode3.add("$name");
		navNode3.setSchema(schemaForNavNode3);
		Set schemaForSelNode1 = new HashSet();
		schemaForSelNode1.add("$o");
		schemaForSelNode1.add("$b");
		selectNode1.setSchema(schemaForSelNode1);
		Set schemaForTaggerNode1 = new HashSet();
		schemaForTaggerNode1.add("$final");
		taggerNode1.setSchema(schemaForTaggerNode1);
		//Using the handwritten rainbow plan to get the RAINDROP logical and phy plan
		XATDag dag = new XATDagImp();
		dag.addRoot(taggerNode1);
		//RaindropLogicalPlanGenerator planOptionGen = new RaindropLogicalPlanGenerator(mappingSet);	   
		//XATDag raindropPlan = planOptionGen.generatePlan(dag);
		//RaindropPhysicalPlanGenerator phyGen =
		//new RaindropPhysicalPlanGenerator();
		//   XATDag phyPlan = phyGen.generatePhyPlan(raindropPlan);
		//XATDag drawRaindropPlan = UtilForTesting.refineLogicalPlan(raindropPlan);
        */
	   	   
		//step works, could be done by a function in the testpackage of raindrop
		DagQueryDecorrelation qd = new DagQueryDecorrelation((XATDag)tree);
		tree = qd.getDecorTree();
		BindingTableComputer btc = new BindingTableComputer();
		BindingTable bt = btc.computeBindingTable( tree );
		tree.setBindingTable(bt);		
		tree = TestSXE.treeRewrite(tree);
		tree = TestSXE.treeSchema(tree);
	      
	   
		//generator getting Logical plan. not useful for the logical drawing
		
		System.setProperty("DATA_MODEL", "XATMemoryQueueImp");
		
		XATDag rainbowDagCopy = (XATDag)tree.clone();	
		//System.out.println(rainbowDagCopy);	
		
			
 
		RuleBaseRaindropLogicalPlanGenerator.treeRewrite(rainbowDagCopy, mappingSet, paraSet, paraSet2);	
	   System.out.println("......................................................"); 
	   //+ paraSet +"-"+paraSet2 + "!!!!!!");
 
	    //DagTraversal.printDag(rainbowDagCopy);
	

		// create a new GrappaPanel from this XAT
		GrappaCreator gc = new GrappaCreator(rainbowDagCopy, true);
		gp = gc.getGrappaPanel();
		nc = gc.getNodeContainer();
		nl = gc.getNodeListener();

		if (queryType == this.USER_QUERY) {
			if (!skip)
			
				setUserBindingTable(pt1.getTree().getBindingTable());
			else { // create an empty hashtable.
				setUserBindingTable(new BindingTable());
			}
			setUserTree(tree);
			setUserGrappaPanel(gp);
			setUserNodeContainer(nc);
			setUserNodeListener(nl);
		} else {
			if (!skip){
			}
				//setViewBindingTable(pt1.getTree().getBindingTable());
			else { // create an empty hashtable.
				setViewBindingTable(new BindingTable());
			}
			setViewTree(tree);
			setViewGrappaPanel(gp);
			setViewNodeContainer(nc);
			setViewNodeListener(nl);
		}
		return gp;
	} catch (Exception e) {
		e.printStackTrace(System.out);
	}

	return null;

}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 */
public JPanel executeUser() {
	if(!isUserDone()){
		setUserDone(true);
		setQueryToUse(userQuery);
		return execute(USER_QUERY);	
	}
	else return getUserGrappaPanel();
}
/**
 * Insert the method's description here.
 * 
 * @return att.grappa.GrappaPanel
 */
public JPanel executeView() {
	if(!isViewDone()){
		setViewDone(true);
		setQueryToUse(viewQuery);
		return execute(VIEW_QUERY);
	} else return getViewGrappaPanel();
}
/**
 * Insert the method's description here.
 * 
 * @return java.lang.String
 */
protected java.lang.String getQueryToUse() {
	return queryToUse;
}
/**
 * Insert the method's description here.
 * 
 * @param newQueryToUse java.lang.String
 */
protected void setQueryToUse(java.lang.String newQueryToUse) {
	queryToUse = newQueryToUse;
}
}
