package edu.wpi.cs.dsrg.xmldb.xat.automata.utils;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import edu.wpi.cs.dsrg.utils.DeepCopyMaker;

/**
 * manage all the ClassExecTimeKeepers associated with the java classes
 * Creation date: (4/24/2003 10:28:49 PM)
 * @author: Hong Su
 */

public class ClassExecTimeKeeperMgr implements Cloneable, Serializable {
	List timeKeepers = new ArrayList();
	/**
	 * ClassExecTimeKeeperMgr constructor comment.
	 */
	public ClassExecTimeKeeperMgr() {
		super();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/24/2003 10:30:07 PM)
	 */
	public void addIntoMgr(ClassExecTimeKeeper keeper, boolean reset) {
		timeKeepers.add(keeper);
		if (reset)
			keeper.reset();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/11/2003 2:36:03 PM)
	 */
	public void clearUpMgr() {
		timeKeepers.clear();

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/9/2003 10:21:11 PM)
	 * @return java.util.List
	 */
	public List getTimeKeepers() {
		return timeKeepers;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/9/2003 10:21:11 PM)
	 * @param newTimeKeepers java.util.List
	 */
	public void setTimeKeepers(List newTimeKeepers) {
		timeKeepers = newTimeKeepers;
	}
	
	public Object clone(){  
		ClassExecTimeKeeperMgr o=new ClassExecTimeKeeperMgr();
		for (int i=0; i<timeKeepers.size(); i++)
			o.addIntoMgr((ClassExecTimeKeeper)((ClassExecTimeKeeper)timeKeepers.get(i)).clone(), false);
				
		return o;
	}
}
