package edu.wpi.cs.dsrg.xmldb.xat.common.operator.state;

import java.util.List;
import java.util.Vector;
import java.util.ArrayList;

//import streamgenerator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import java.io.Serializable;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
//import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression.ExpressionStr;
/**
 * Insert the type's description here.
 * Creation date: (2/17/2003 5:34:51 PM)
 * @author: Yali Zhu
 */
public class WFIFOState extends WOperatorState implements Serializable {
	
	private ArrayList statetuples = new ArrayList();
	
/**
 * FIFOState constructor comment.
 */
public WFIFOState() {
    super();
    
//    if (stateQ == null) {
//		if(System.getProperty("DATA_MODEL").endsWith("XATMemoryQueueImp")) {
//			stateQ = new XATMemoryQueueImp(this);
//		}
//		else if (System.getProperty("DATA_MODEL").endsWith("XATPersistentQueueImp")) {
//			stateQ = new XATPersistentQueueImp(this);
//		}
//		else {
//			System.out.println("!!! Error: Unknow type of DATA_MODEL !!!");
//			System.exit(-1);
//		}
//    }
    //stateQ = new XATQueueImp(this);
    //stateQ.register(this);
}

public WFIFOState(XATStreamOperator op) {
	super();
//	if (stateQ == null) {
//		if(System.getProperty("DATA_MODEL").endsWith("XATMemoryQueueImp")) {
//			stateQ = new XATMemoryQueueImp(this);
//			stateQ.register(op);
//		}
//		else if (System.getProperty("DATA_MODEL").endsWith("XATPersistentQueueImp")) {
//			stateQ = new XATPersistentQueueImp(this);
//			stateQ.register(op);
//		}
//		else {
//			System.out.println("!!! Error: Unknow type of DATA_MODEL !!!");
//			System.exit(-1);
//		}
//	}
	this.setOperator(op);
}

public WFIFOState(WFIFOState oldstate, XATStreamOperator newop) {
	super(oldstate, newop);
	
//	if (stateQ == null) {
//		if(System.getProperty("DATA_MODEL").endsWith("XATMemoryQueueImp")) {
//			stateQ = new XATMemoryQueueImp(this);
//			stateQ.register(newop);
//		}
//		else if (System.getProperty("DATA_MODEL").endsWith("XATPersistentQueueImp")) {
//			stateQ = new XATPersistentQueueImp(this);
//			stateQ.register(newop);
//		}
//		else {
//			System.out.println("!!! Error: Unknow type of DATA_MODEL !!!");
//			System.exit(-1);
//		}
//	}
	this.setOperator(newop);
	this.stateSchema = oldstate.stateSchema;
	//this.stateQ.setSchema(oldstate.stateQ.getSchema());
}
/**
 * copy current state
 * new state should be empty.
 */
//public OperatorStateImp makeNewCopy(XATStreamOperator op) {
//	WFIFOState newstate = new WFIFOState();
//	newstate.isMatched = false;
//	newstate.stateSchema = this.stateSchema;
//	newstate.setSchema(this.stateQ.getSchema());
//	newstate.debugFlag = this.debugFlag;
//	newstate.totalNumTuples = 0;
//	newstate.stateID = this.stateID;
//	newstate.operator = op;
//
//	return newstate;
//}

//public void setSchema(XATQueueSchema schema) {
//	this.stateQ.setSchema(schema);
//}
/**
 * Insert the method's description here.
 * Creation date: (4/10/2003 9:19:49 AM)
 * @return boolean
 */
public boolean checkAllOldTuplePurged() {

    if (totalNumTuples == 0) {
        allOldPurged = true;
        return true;
    }

    //return isOlder(tuple.getTimeStamps(), lastTimeStampBeforeMigration);
    for (int i = 0; i<totalNumTuples; i++) {
        if (!((XATTuple)statetuples.get(i)).isNew())
            return false;
    }
    allOldPurged = true;
    return true;
}

/**
 * Insert the method's description here.
 * Creation date: (6/1/2003 7:36:13 AM)
 * @return long
 */
public long[] getEarlistTimeStamp() {
	
    if (totalNumTuples > 0)
        return ((XATTuple)statetuples.get(0)).getTimeStamp();
    else 
 		return null;
}
/**
 * Insert the method's description here.
 *
 * Get tuple with earliest timestamp
 *
 * Creation date: (6/1/2003 7:36:13 AM)
 * @return long
 */
public XATTuple getEarlistTuple() {
	// return the first tuple in stateQ
    if (totalNumTuples > 0)
        return (XATTuple)statetuples.get(0);

    else
        return null;
}
/**
 * Insert the method's description here.
 * Creation date: (6/1/2003 7:36:35 AM)
 * @return long
 */
public long[] getLatestTimeStamp()
{
	if (totalNumTuples > 0) {
		return ((XATTuple)statetuples.get(totalNumTuples - 1)).getTimeStamp();
	}
	else 
 		return null;
}
/**
 * Insert the method's description here.
 *
 * Get tuple with latest timestamp
 *
 * Creation date: (6/1/2003 7:36:35 AM)
 * @return long
 */
public XATTuple getLatestTuple()
{
	if (totalNumTuples > 0) {
		return (XATTuple)statetuples.get(totalNumTuples-1);
	}
	else 
		return null;
}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:29:29 AM)
 * @return queryplanelements.FIFOQueue
 */
//public XATQueue getStateQueue() {
//	return stateQ;
//}

public XATTuple[] getAllStateTuples(){
	int size = statetuples.size();
	XATTuple[] tuples = new XATTuple[size];
	
	for(int i=0; i<size; i++) {
		tuples[i] = (XATTuple)statetuples.get(i);
	}
	return tuples;
}

/**
 * Insert the method's description here.
 * Creation date: (6/23/2003 5:38:12 AM)
 * @return int
 */
//public int getStateTupleCounts() {
//	return stateQ.getQueueSize();
//}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:26:24 AM)
 */

public void insertTuple(XATTuple newTuple) {
	// each state is the owner of the stateQ, and
	// each operator that contains the state is registered as a customer of the stateQ.
	//stateQ.enqueue(newTuple, this);
	statetuples.add(newTuple);
	totalNumTuples++;
}

public void insertTuple(XATTuple[] newTuples){
	// each state is the owner of the stateQ, and
	// each operator that contains the state is registered as a customer of the stateQ.
	//stateQ.enqueue(newTuples, this);
	for(int i=0; i<newTuples.length; i++) {
		statetuples.add(newTuples[i]);
	}
	totalNumTuples = totalNumTuples + newTuples.length;
}

//public boolean isRegistered(Object caller){
//	return stateQ.isRegistered(caller);
//}
/**
 * Insert the method's description here.
 * Creation date: (2/25/2003 11:27:47 AM)
 * @param newTuple streamgenerator.XATStreamTuple
 */
public void purgeByTuple(XATTuple newTuple) {
	if (newTuple == null) {
		return;
	}
	/** purge a tuple if its out of window bound, stop when meet the first tuple in the state that cannot be purged */
	for (int i = 0; i < totalNumTuples; i++) {
		if (timeStampExpired(newTuple, (XATTuple)statetuples.get(i))) {
			statetuples.remove(i);
			i--;
			totalNumTuples--;
		} 
	}
}

/**
 * Insert the method's description here.
 * Creation date: (3/20/2003 11:08:58 PM)
 */
//public void register(Object caller) {
//    stateQ.register(caller);
//}
/**
 * Insert the method's description here.
 * Creation date: (5/28/2003 6:01:33 AM)
 * @param queue edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATQueue
 */
//	public void setStateQueue(XATQueue queue) {
//    	stateQ = queue;
//	}
	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.WOperatorState#getSchema()
	 */
//	public XATQueueSchema getSchema() {
//		return stateSchema;
//	}

	public String toString() {
		return "state "+ stateSchema;
	}

//	public void probe(XATTuple tuple) {	
//	}
	
	public XATTuple[] probe(XATTuple[] tuples, ExpressionStr expression, int statepos) {
		
		int [][] outPositions = operator.getOutputPositions();
		int outputsize = operator.getOutputPositions(0).length + operator.getOutputPositions(1).length;
		ArrayList joinedtuples = new ArrayList();
		
		List tuplepair = new Vector();
		
		for(int x=0; x<tuples.length; x++) {
			XATTuple tuple = tuples[x];
			for(int i=0; i<totalNumTuples; i++) {

				/* if outside window constraints, purge the state tuple*/
				XATTuple nextstatetuple = (XATTuple)statetuples.get(i);
				if(this.timeStampExpired(tuple, nextstatetuple)) {
					statetuples.remove(i);
					i--;
					totalNumTuples--;
					continue;
				}
						
				/* join the two tuples if predicate is satisfied. */
				tuplepair.clear();
				
				if (statepos == 0) {
					tuplepair.add(nextstatetuple);
					tuplepair.add(tuple);

				} else {
					tuplepair.add(tuple);
					tuplepair.add(nextstatetuple);
				}
				
				if (((Boolean)expression.eval(tuplepair, operator)).booleanValue()) {
					List newvalues = new Vector();
					long[] newtimes = new long[outputsize];
					//newts.combine(lTuple.getTimeStamp(), rTuple.getTimeStamp());
					int timeindex=0;
					for(int j=0; j<2; j++) {
						for(int k=0; k<operator.getOutputPositions(j).length; k++) {
							newvalues.add(((XATTuple)tuplepair.get(j)).getCell(outPositions[j][k]));
							newtimes[timeindex] = ((XATTuple)tuplepair.get(j)).getNthTimeStamp(outPositions[j][k]);
							timeindex++;
						}
					}
					XATTuple joinedtuple = new XATTupleImp(newvalues);
					joinedtuple.setTimeStamp(newtimes);
					long m1 = tuple.getMinTimeStamp();
					long m2 = nextstatetuple.getMinTimeStamp();
					joinedtuple.setMinTimeStamp((m1<m2)?m1:m2);
					m1 = tuple.getMaxTimeStamp();
					m2 = nextstatetuple.getMaxTimeStamp();
					joinedtuple.setMaxTimeStamp((m1>m2)?m1:m2);
					joinedtuples.add(joinedtuple);
					if(tuple.isNew() && nextstatetuple.isNew()) {
						joinedtuple.setToNew(true);
					} else {
						joinedtuple.setToNew(false);
					}
				}
			}
		}
		//((Client[])al.toArray(new Client[0]));
		return (XATTuple[])joinedtuples.toArray(new XATTuple[]{});
	}
	
	public void copyStateContent(OperatorState newstate) {
		this.statetuples = ((WFIFOState)newstate).statetuples;
	}

//	public void probe(XATTuple[] tuples) {	
//	}
	
	//public void probe(XATTuple[] tuples, ExpressionStr expression, int statepos) {
	//}
}
