package edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator;

/**extracted items are grouped 
 * associated with a nav op which provides the grouping variable
 * Creation date: (1/13/2003 4:52:15 PM)
 * @author: Hong Su
 */



public interface ExtractByCollectionStream extends ExtractStream{
	
/**
 * get the associated nav op, 
 * the extraction result should be grouped on the destination of this nav op
 * Creation date: (2/3/2003 5:41:50 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAuto
 */
PureNavigateAutoStream getCollectionByNavOp();
/*
 * Creation date: (2/3/2003 5:41:26 PM)
 * @param newCollectionByNavOp edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.xmloperator.PureNavigateAuto
 */
void setCollectionByNavOp(PureNavigateAutoStream newCollectionByNavOp);


}
