package edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression;

import java.util.List;
//import java.util.Vector;
//import org.w3c.dom.Element;
//import org.w3c.dom.Node;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpressionImp;
//import edu.wpi.cs.dsrg.xmldb.xat.common.expression.Expression;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
//import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValueImp;
//import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.XMLNodeManipulator;


/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author 
 * @version 1.0.0.0 
 */

public class BinCOMPExpressionStrImp extends ExpressionStrImp implements BinCOMPExpressionStr {
  ExpressionStr eLeft,eRight;
  int iType;

/**
 * Insert the method's description here.
 * Creation date: (2/4/2003 12:56:05 PM)
 * @param expression edu.wpi.cs.dsrg.xmldb.xat.common.expression.BinCOMPExpression
 */
//public BinCOMPExpressionStrImp(Expression expr) {
//	
//	ExpressionStrImp expressionStrImp = new ExpressionStrImp();
//	
//	eLeft = expressionStrImp.createExpressionStr(((BinCOMPExpression)expr).getLeft());
//
//	eRight = expressionStrImp.createExpressionStr(((BinCOMPExpression)expr).getRight());
//
//	iType = ((BinCOMPExpressionImp)expr).getType();
//
//	//untrueExpression = (BinCOMPExpressionStrImp)this.clone();    
//}

  public BinCOMPExpressionStrImp() {
  	super();
  }
	
  public BinCOMPExpressionStrImp(ExpressionStr left, ExpressionStr right, int type) {
	eLeft = left;
	eRight = right;
	iType = type;
	//untrueExpression = (BinCOMPExpressionStrImp)this.clone();    
  }
/**
 * Insert the method's description here.
 * Creation date: (1/23/2003 10:08:21 PM)
 * @return boolean
 * @param left String
 * @param right String
 */
private boolean compare(String lLeft, String lRight) {
	switch (iType) {
		case EQ :
			return (lLeft.equals(lRight));
			//break;
		default :
			/* fail */
			return false;
	}
}

private boolean compare(long lLeft, long lRight) {
	switch (iType) {
		case LT :
			return (lLeft < lRight);
			//break;
		case GT :
			return (lLeft > lRight);
			//break;
		case LEQ :
			return (lLeft <= lRight);
			//break;
		case GEQ :
			return (lLeft >= lRight);
			//break;
		case EQ :
			return (lLeft == lRight);
			//break;
		case NEQ :
			return (lLeft != lRight);
			//break;
		default :
			/* fail */
			return false;
	}
}

private boolean compare(double lLeft, double lRight) {
	switch (iType) {
		case LT :
			return (lLeft < lRight);
			//break;
		case GT :
			return (lLeft > lRight);
			//break;
		case LEQ :
			return (lLeft <= lRight);
			//break;
		case GEQ :
			return (lLeft >= lRight);
			//break;
		case EQ :
			return (lLeft == lRight);
			//break;
		case NEQ :
			return (lLeft != lRight);
			//break;
		default :
			/* fail */
			return false;
	}
}

private boolean compare(int lLeft, int lRight) {
	switch (iType) {
		case LT :
			return (lLeft < lRight);
			//break;
		case GT :
			return (lLeft > lRight);
			//break;
		case LEQ :
			return (lLeft <= lRight);
			//break;
		case GEQ :
			return (lLeft >= lRight);
			//break;
		case EQ :
			return (lLeft == lRight);
			//break;
		case NEQ :
			return (lLeft != lRight);
			//break;
		default :
			/* fail */
			return false;
	}
}

private boolean compare(boolean bLeft, boolean bRight) {
	switch(iType) {
		case EQ:
			return (bLeft == bRight);
		default:
			return false;	
	}
}

/**
   * It will evaluate itself and return the value as an object.
   * Remember, it could be like: Integer, Float, Double, String, Boolean.
   */
//public java.lang.Object eval(edu.wpi.cs.dsrg.xmldb.xat.common.operator.XATOperator xopOper, int[] iPositions) {
// return null;
//}
 // this code is written incorrectly... this need to check for column names and such
 public Object eval(List tuples, XATStreamOperator op)
 {
	Object lValue = eLeft.eval(tuples, op);
   	Object rValue = eRight.eval(tuples, op);

	if ((lValue instanceof XATDataValue) && (rValue instanceof XATDataValue)) {
		try{
			double ldouble = ((XATDataValue)lValue).convertToDouble().doubleValue();
			double rdouble = ((XATDataValue)rValue).convertToDouble().doubleValue();
			return new Boolean(compare(ldouble, rdouble));
		} catch (ClassCastException e1) {
			try{
				String lstring = ((XATDataValue)lValue).convertToString();
				String rstring = ((XATDataValue)rValue).convertToString();
				return new Boolean(compare(lstring, rstring));
			} catch (ClassCastException e2) {
				try{
					boolean lbool = ((XATDataValue)lValue).convertToBoolean().booleanValue();
					boolean rbool = ((XATDataValue)rValue).convertToBoolean().booleanValue();
					return new Boolean(compare(lbool, rbool));
				}  catch (ClassCastException e3) {
					e3.printStackTrace();
					return new Boolean(false);
			}
		}
		}
	}
	if ((lValue instanceof XATDataValue) && (eRight instanceof TerminalConstant)) {
		int type = ((TerminalConstant)eRight).getType();
		switch(type) {
			case STRING:
				return new Boolean(compare(((XATDataValue)lValue).convertToString(), (String)rValue));
			case DOUBLE:
			case LONG:
			case INTEGER:
				double ldouble = ((XATDataValue)lValue).convertToDouble().doubleValue();
				double rdouble = ((Double)rValue).doubleValue();
				return new Boolean(compare(ldouble, rdouble));
			case BOOL:
				boolean lbool = ((XATDataValue)lValue).convertToBoolean().booleanValue();
				boolean rbool = ((Boolean)rValue).booleanValue();
				return new Boolean(compare(lbool, rbool));			
		}
	}
	
	if ((rValue instanceof XATDataValue) && (eLeft instanceof TerminalConstant)) {
		int type = ((TerminalConstant)eLeft).getType();
		switch(type) {
			case STRING:
				return new Boolean(compare((String)lValue, ((XATDataValue)rValue).convertToString()));
			case DOUBLE:
			case LONG:
			case INTEGER:
				double rdouble = ((XATDataValue)rValue).convertToDouble().doubleValue();
				double ldouble = ((Double)lValue).doubleValue();
				return new Boolean(compare(ldouble, rdouble));
			case BOOL:
				boolean rbool = ((XATDataValue)rValue).convertToBoolean().booleanValue();
				boolean lbool = ((Boolean)lValue).booleanValue();
				return new Boolean(compare(lbool, rbool));			
		}
	}
	
	return new Boolean(false);
 }
 

  	 public ExpressionStr getLeft()
  	 {
		 return eLeft;
  	 }
  	 public ExpressionStr getRight()
   	 {
		 return eRight;
  	 }
   
	public int getType()
   	{
		 return iType;
 	}
	 public void setLeft(ExpressionStr left)
	 {
	   eLeft = left;
	 }
	 public void setRight(ExpressionStr right)
	 {
	   eRight = right;
	 }
   public void setType(int type)
   {
	 iType = type;
   }
 /**
  * Insert the method's description here.
  * Creation date: (1/26/2003 8:51:26 PM)
  * @param newUntrueExpression edu.wpi.cs.dsrg.xmldb.xat.common.streamexpression.ExpressionStr
  */
// public void setUntrueExpression(ExpressionStr newUntrueExpression) {
//	 untrueExpression = newUntrueExpression;
// }

	 public String toString()
	 {
	 switch (iType)
	 {
	 case LT:
		 return "(" + eLeft.toString() + " < " + eRight.toString() + ")";
	 case GT:
		 return "(" + eLeft.toString() + " > " + eRight.toString() + ")";
	 case LEQ:
		 return "(" + eLeft.toString() + " <= " + eRight.toString() + ")";
	 case GEQ:
		 return "(" + eLeft.toString() + " >= " + eRight.toString() + ")";
	 case EQ:
		 return "(" + eLeft.toString() + " == " + eRight.toString() + ")";
	 case NEQ:
		 return "(" + eLeft.toString() + " != " + eRight.toString() + ")";
	 default:
		 return "(" + eLeft.toString() + " COMP(" + Integer.toString(iType) + ") " + eRight.toString() + ")";
	 }
	 }

//		if ((left instanceof String) || (right instanceof String)) {
//			if (left instanceof Element)
//				sLeft = (new XATDataValueImp(left)).toString();
//			else //if a dom node, actually its string value is compared
//				if (left instanceof XATDataValue){
//					if (((XATDataValueImp)left).isNode()){
//					Node node = ((XATDataValueImp) left).convertToDOM();
//					sLeft = XMLNodeManipulator.getStringValue(node);
//					}else
//					//must be an atomic value
//					sLeft = ((XATDataValueImp)left).toString();
//				}
//				else
//					sLeft = left.toString().trim();
//
//			if (right instanceof Element)
//				sRight = (new XATDataValueImp(left)).toString();
//			else
//				if (right instanceof XATDataValue){
//					Node node = ((XATDataValueImp)right).convertToDOM();
//					sRight = XMLNodeManipulator.getStringValue(node);
//				}
//				else
//					sRight = right.toString().trim();
//
//			if (iType == EQ) {
//				return new Boolean(sLeft.equals(sRight));
//			} else
//				return Boolean.FALSE;
//		}
//
//		long lLeft = ((Long) left).longValue();
//		long lRight = ((Long) right).longValue();
//		boolean bReturn;
//		switch (iType) {
//			case LT :
//				bReturn = (lLeft < lRight);
//				break;
//			case GT :
//				bReturn = (lLeft > lRight);
//				break;
//			case LEQ :
//				bReturn = (lLeft <= lRight);
//				break;
//			case GEQ :
//				bReturn = (lLeft >= lRight);
//				break;
//			case EQ :
//				bReturn = (lLeft == lRight);
//				break;
//			case NEQ :
//				bReturn = (lLeft != lRight);
//				break;
//			default :
//				/* fail */
//				return Boolean.FALSE;
//		}
//		return new Boolean(bReturn);
//	} catch (ClassCastException e) {
//		try {
//			double dLeft = ((Number) left).doubleValue();
//			double dRight = ((Number) right).doubleValue();
//			boolean bReturn;
//			switch (iType) {
//				case LT :
//					bReturn = (dLeft < dRight);
//					break;
//				case GT :
//					bReturn = (dLeft > dRight);
//					break;
//				case LEQ :
//					bReturn = (dLeft <= dRight);
//					break;
//				case GEQ :
//					bReturn = (dLeft >= dRight);
//					break;
//				case EQ :
//					bReturn = (dLeft == dRight);
//					break;
//				case NEQ :
//					bReturn = (dLeft != dRight);
//					break;
//				default :
//					/* fail */
//					return Boolean.FALSE;
//			}
//			return new Boolean(bReturn);
//		} catch (ClassCastException e2) {
//			String sLeft = left.toString();
//			String sRight = right.toString();
//			boolean bReturn;
//			switch (iType) {
//				case LT :
//					bReturn = (sLeft.compareTo(sRight) < 0);
//					break;
//				case GT :
//					bReturn = (sLeft.compareTo(sRight) > 0);
//					break;
//				case LEQ :
//					bReturn = (sLeft.compareTo(sRight) <= 0);
//					break;
//				case GEQ :
//					bReturn = (sLeft.compareTo(sRight) >= 0);
//					break;
//				case EQ :
//					bReturn = (sLeft.equals(sRight));
//					break;
//				case NEQ :
//					bReturn = (!sLeft.equals(sRight));
//					break;
//				default :
//					/* fail */
//					return Boolean.FALSE;
//			}
//
//			return new Boolean(bReturn);
//		}
//	} catch (NullPointerException e) {
//		return Boolean.FALSE;
//	}
//}

/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 4:25:52 PM)
 * @return java.util.Vector
 */
//public java.util.Vector getTerminalColumnExprs() {
//	Vector results = new Vector();
//
//	results.addAll(eLeft.getTerminalColumnExprs());
//	results.addAll(eRight.getTerminalColumnExprs());
//	
//	return results;
//}
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 4:25:52 PM)
 * @return java.util.Vector
 */
//public java.util.Vector getTerminalColumnNames() {
//	if (terminalColumnNames == null) {
//		terminalColumnNames = new Vector();
//
//		terminalColumnNames.addAll(eLeft.getTerminalColumnNames());
//		terminalColumnNames.addAll(eRight.getTerminalColumnNames());
//	}
//
//	return terminalColumnNames;
//
//}


  /**
   * reset column positions in expression according to the given position mapping.
   * this method is usually called by optimizer when switching two operators and as a result we
   * have to reset the column IDs of involving operators' expressions.
   * 
   * This method is usually called right before the method "getRelatedSubExpression" in this class.
   * @param pos
   * @return
   */
  public boolean resetColumnPosition(int[][] positionmap) {
  	return false;
  }
    
  /**
  * get the sub-expressions that contains ONLY the given
  * queue position and column positions.
  * the returned expression could be as large as this expression itself, or as small as null.
  * 
  * This method is usually called by the optimizer right after the method "resetColumnPosition" in this class.
  */
  public ExpressionStr getRelatedSubExpression(int queuepos, int[] columnpos) {
  	return null;
  }
  
  public boolean containColumnPositions(int queuePos, int[] columnPos) {
	return (eLeft.containColumnPositions(queuePos, columnPos) || eRight.containColumnPositions(queuePos, columnPos));
   }
}
