package edu.wpi.cs.dsrg.xmldb.xat.common.relationalstreamexpression;

//import edu.wpi.cs.dsrg.xmldb.xat.common.operator.ColumnName;
/**
* It's going to represent the leaf expressions, e.g.,
* A String, Double, or a ColumnName.
* Hits: You can keep an Object property, that maybe objects of
* String, Double or ColumnName.
*/
public interface TerminalExpressionStr extends ExpressionStr {
//    final static int STRING = 0;
//    final static int DOUBLE = 1;
//    final static int NAME = 2;
//    final static int BOOL = 3;
    /**
    * Return the type of this terminalExpression.
    * It could be a String, or a Double, or a ColumnName.
    */
    int getType();
    /**
     * get the value of this expresssion.
     * 
     * @return java.lang.Object
     */
    Object getValue();
    /**
    * Set the type of this terminal expression.
    */
//    void setType(int type);
//    public void setValue(double value);
//    public void setValue(ColumnName value); 
//    public void setValue(String value);
//    public void setValue(boolean value);

	public void setIColumnPosition(int i);
	public void setIQueuePosition(int i);
}
