package edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator;

/**
 * Insert the type's description here.
 * Creation date: (2002-12-20 17:43:07)
 * @author: sk
 */

import java.util.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;
import edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DagTraversal;

public class AutoMegaImp extends XATOperatorImp implements AutoMegaOperator{
	private XATQueue queue = null;
	private DagNode boundaryNode = null;
	
	
public AutoMegaImp(XATNode owner) {
  super(owner);

}
/**
 * Insert the method's description here.
 * Creation date: (2003-2-4 13:35:29)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.DagNode
 */
public DagNode getBoundary() {
	return this.boundaryNode;
}
/**
 * Insert the method's description here.
 * Creation date: (2002-12-25 17:16:34)
 * @param b edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public void setBoundary(DagNode b) {
	this.boundaryNode = b;
}
/**
 * Insert the method's description here.
 * Creation date: (2002-12-20 20:04:17)
 * @return java.lang.String
 */
public String toString() {

	StringBuffer result = new StringBuffer();
  result.append("AutoMega: "  + " := \n" );

 //do a breadth first traverse from top down
  try {
    //do a breadth first traverse from top down
    Vector traversal = DagTraversal.dagTopDownTraverse(this.boundaryNode);
    for (Iterator it = traversal.iterator(); it.hasNext();) {
      DagNode curNode = (DagNode) it.next();
      //visit curNode
      result.append("   ( " + curNode.getOperator() + "\n");

      for (int i = 0; i < curNode.getChildrenSize(); i++){
        result.append("       -->" + curNode.getChild(i).getOperator());
        result.append("\n");
      }
      result.append("   )\n");
    }
  } catch (Exception e) {
    e.printStackTrace();
  }
  
  return result.toString();
}
}
