package edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator;

/**
 * Insert the type's description here.
 * Creation date: (2003-1-12 19:30:16)
 * @author: JinHui Jian
 */
import java.util.*;

import edu.wpi.cs.dsrg.xmldb.xat.common.operator.xmloperator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
public class ExtractCollImp extends ExtractImp implements ExtractColl {
	/**
	 * StreamNavigateImp constructor comment.
	 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 */
	public ExtractCollImp(XATNode node) {
		super(node);
	}
	/**
	 * StreamNavigateImp constructor comment.
	 * @param node edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
	 */
	public ExtractCollImp(XATNode node, Navigate nav) {
		super(node, nav);
	}
	/**
	 * printNode method comment.
	 */
	public String printNode() {
		return null;
	}
	/**
	 * Runs the actual operator.
	 *
	 * Unlike in Rainbow, the Stream operators have the implementation tied to the operator
	 * because the StreamOperators represent physical operators instead of Logic.
	 * Creation date: (2003-1-12 19:30:16)
	 */
	public boolean run() {
		return true;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2003-1-12 21:57:38)
	 * @return java.lang.String
	 */
	public String toString() {
		StringBuffer sb = new StringBuffer();

		if (this instanceof OuterExtractColl)
			sb.append("OuterExtractColl(");
		else
			sb.append("ExtractColl (");

		sb.append(getBinding());
		sb.append(" ");
		for (int i = 0; i < entry.length; i++)
			sb.append(entry[i] + "/");

		for (int i = 0; i < dest.length; i++)
			sb.append(dest[i] + "/");

		sb.append(")");
		sb.append("<");
		Set schema = this.getNode().getSchema();
		
		if (schema!=null)
		for (Iterator it = schema.iterator(); it.hasNext();) {
			String s = (String) it.next();
			sb.append(s + ", ");
		}
		sb.append(">");
		return sb.toString();
	}
}
