package edu.wpi.cs.dsrg.xmldb.xat.component.automata.logicaloperator;

/**
 * Insert the type's description here.
 * Creation date: (2002-12-20 17:43:07)
 * @author: sk
 */
import java.util.*;


import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.*;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.state.OperatorState;
import edu.wpi.cs.dsrg.xmldb.xat.common.operator.streamoperator.XATStreamOperator;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.*;


public class StructuralJoinImp extends XATOperatorImp implements StructuralJoin{
	private XATQueue queue = null;
	protected XATNode shadowNode = null;
	private XATNode boundaryNode = null;
public StructuralJoinImp(XATNode node) {
	super(node);
}
public StructuralJoinImp(XATNode node, XATNode shadowNode) {
	super(node);
	this.shadowNode = shadowNode;
}
/**
 * Insert the method's description here.
 * Creation date: (2003-1-28 23:13:59)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public XATNode getShadowNode() {
	return shadowNode;
}
/**
 * Insert the method's description here.
 * Creation date: (2003-1-28 23:15:41)
 * @param shadowNode edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode
 */
public void setShadowNode(XATNode shadowNode) {
	this.shadowNode = shadowNode;
}
/**
 * Insert the method's description here.
 * Creation date: (2003-1-22 22:55:26)
 * @return java.lang.String
 */
public String toString() {
	StringBuffer sb = new StringBuffer();
	sb.append("StructuralJoin <");
	Set schema = this.getNode().getSchema();
	if (schema!=null)
	for(Iterator it = schema.iterator();it.hasNext();){
		String s = (String)it.next();
		sb.append(s + ", ");
	}
	sb.append(">");
	
	sb.append("on "+((StreamNavigate)shadowNode.getOperator()).getOutputColumnName());
	return sb.toString();
}
}