package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators;

/**
 * Insert the type's description here.
 * Creation date: (3/28/2003 6:30:32 PM)
 * @author: Hong Su
 */
import org.xml.sax.Attributes;
 
public class XMLToken implements java.io.Externalizable{

	public static final byte OPEN = 1;
	public static final byte CLOSE = 2;
	public static final byte PCDATA = 3;
	public static final byte EOF = 4;
	private byte type;
	private String val;
	//private Attributes attrs = null;
	//private short tid;
	

/**
 * Token constructor comment.
 */
public XMLToken() {
	
}
/**
 * Token constructor comment.
 */
public XMLToken(byte type, String val, Attributes attrs) {
	//super();
	this.type = type;
	this.val = val;
	//this.attrs = attrs;
}
/**
 * Insert the method's description here.
 * Creation date: (4/12/2003 10:59:16 PM)
 * @return Attributes
 */
public Attributes getAttrs() {
	//return attrs;
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (3/30/2003 1:02:10 PM)
 * @return int
 */
public int getTid() {
	//return tid;
	return 0;
}
/**
 * Insert the method's description here.
 * Creation date: (3/30/2003 1:01:47 PM)
 * @return int
 */
public byte getType() {
	return type;
}
/**
 * Insert the method's description here.
 * Creation date: (3/30/2003 1:01:59 PM)
 * @return java.lang.String
 */
public java.lang.String getVal() {
	return val;
}
	/**
	 * The object implements the readExternal method to restore its
	 * contents by calling the methods of DataInput for primitive
	 * types and readObject for objects, strings and arrays.  The
	 * readExternal method must read the values in the same sequence
	 * and with the same types as were written by writeExternal.
	 * @exception ClassNotFoundException If the class for an object being
	 *              restored cannot be found.
	 */
public void readExternal(java.io.ObjectInput in) throws java.io.IOException, java.lang.ClassNotFoundException {
	    type = in.readByte();
        val = in.readUTF();  

	
	}
/**
 * Insert the method's description here.
 * Creation date: (4/12/2003 10:59:16 PM)
 * @param newAttrs Attributes
 */
public void setAttrs(Attributes newAttrs) {
	//attrs = newAttrs;
}
/**
 * Insert the method's description here.
 * Creation date: (3/31/2003 4:11:00 PM)
 * @return java.lang.String
 */
public String toString() {
    if (type == OPEN) {
        String openTagString = "<" + val + " ";

       /* if (attrs != null)
            for (int i = 0; i < attrs.getLength(); i++) {
                openTagString =
                    openTagString + attrs.getLocalName(i) + "= " + attrs.getValue(i);
            }*/

        openTagString = openTagString + ">";

        return openTagString;

    } else
        if (type == CLOSE)
            return "</" + val + ">";
        else //must be a PCDATA
            //    if (val.equals("  ")){
            //   return "empty("+ val.length() +")";
            //   }else return val;
            if (type == PCDATA)
                return val;
            else
                if (type == EOF)
                    return "Specaial EOF";

    return null;
}
	/**
	 * The object implements the writeExternal method to save its contents
	 * by calling the methods of DataOutput for its primitive values or
	 * calling the writeObject method of ObjectOutput for objects, strings,
	 * and arrays.
	 *
	 * @serialData Overriding methods should use this tag to describe
	 *             the data layout of this Externalizable object.
	 *             List the sequence of element types and, if possible,
	 *             relate the element to a public/protected field and/or
	 *             method of this Externalizable class.
	 *
	 * @exception IOException Includes any I/O exceptions that may occur
	 */
public void writeExternal(java.io.ObjectOutput out) throws java.io.IOException {
	    out.writeByte(type);
	    out.writeUTF(val);
   
       // out.flush();
     

	
	}
}
