package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;


/**
 * Stores all the information about a particular attribute
 * @author Luping Ding
 *
 */
public class AttributeElement extends Element {
	/**Stores the name of the attribute*/
	protected String attrName = null;
	/**the type of the Attribute*/
	protected String type = null;		
	
	/**
	 * @param name
	 * @param parent
	 */
	
	public AttributeElement(String name, Element parent) {
		super(name, parent);	
	}
	
	public AttributeGenerator makeAttributeGenerator()
	{
		AttributeGenerator ae = null;
		if(al.size() == 1)
		{
			DistributionElement de = (DistributionElement) al.get(0);			
			ae = de.makeAttributeGenerator();
			//setting the name inside the attribute to the
			//one we got from the file
			ae.setAttributeName(this.attrName);			
		}else
		System.out.println("Invalid File Format Cannot make Attribute generator");
		return(ae);
	}

	/**
	 * @param string
	 */
	public void setAttrName(String string) {
		attrName = string;
	}

	/**
	 * @param string
	 */
	public void setType(String string) {
		type = string;
	}

}
