package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;


/**
 * Represents the root element of the tree, Stores 
 * all the information required
 * @author Luping Ding
 */
public class StreamsElement extends Element {

	/**
	 * @param name
	 * @param parent
	 */
	public StreamsElement(String name, Element parent) {
		super(name, parent);
		
	}
	
	/**
	 * Generates the tuples and returns an array of tuple generators
	 * @return
	 */
	public TupleGenerator[] makeTupleGenerators()
	{
		TupleGenerator[] tg = new TupleGenerator[al.size()];
		for(int i=0;i<al.size();i++)
		{
			tg[i] = ((StreamElement) al.get(i)).makeTupleGenerator();	
		}
		return(tg);
	}
}
