package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.plaintext;

/**
 * Constructs a new TupleElement
 * @author Luping Ding
 *
 */
public class TupleElement extends Element {
		

	/**
	 * @param name
	 * @param parent
	 */
	public TupleElement(String name, Element parent) {
		super(name, parent);	
	}
	
	/**
	 * Returns a new Tuple Generator
	 * @return TupleGenerator
	 */
	public AttributeGenerator[] makeAttributeGenerators()
	{
		AttributeGenerator ag[] = new AttributeGenerator[al.size()]; 
		for(int i=0;i<al.size();i++)
		{
			AttributeElement ae = (AttributeElement) al.get(i);
			ag[i] = ae.makeAttributeGenerator();				
		}
		return(ag);
	}

}
