package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.randomgenerators;

import java.io.FileWriter;
import java.io.IOException;
/**
 * Insert the type's description here.
 * Creation date: (2/7/2003 3:49:26 PM)
 * @author: Yali Zhu
 */
public class RandomTest {

/**
 * RandomTest constructor comment.
 */
public RandomTest() {
	super();
}
/**
 * Starts the application.
 * @param args an array of command-line arguments
 */
public static void main(java.lang.String[] args) {

	double num1 = 1.9;
	long num2 = (long)num1;
	System.out.println(num2);
	
    StringBuffer outputString = new StringBuffer();
    String dir = "D:\\research\\implementation\\Experiments\\results\\";
    String fileName = dir + "timesuniform.txt";

    //PoissonRandomGenerator poisson = new PoissonRandomGenerator(20.0);
    UniformRandomGenerator uniform = new UniformRandomGenerator();
    uniform.updateMean(10);
    //System.out.println("poisson seed = " + poisson.getSeed());
    for (int i = 0; i < 1000; i++) {
        //outputString.append(poisson.generateRandom() + "\n");
        //System.out.println(uniform.generateRandom() + " ");
        outputString.append(uniform.generateRandom() + "\n");
    } 
    try {
        FileWriter out = new FileWriter(fileName, true);
        /** print the outputString*/
        out.write(outputString.toString());
        out.close();
        /** now erase the string so we dont print it out again later*/
        outputString = new StringBuffer();
    } catch (IOException e) {
        System.out.println(e.toString());
    }

    /** poisson */
    outputString = new StringBuffer();
    dir = "D:\\research\\implementation\\Experiments\\results\\";
    fileName = dir + "timespoisson.txt";

    PoissonRandomGenerator poisson = new PoissonRandomGenerator();
    poisson.updateMean(2);
    //System.out.println("poisson seed = " + poisson.getSeed());
    for (int i = 0; i < 1000; i++) {
        double num;
        if ((num = poisson.generateRandom()) != 0)
            num = 1 / num;
        outputString.append(num + "\n");
        //System.out.println(poisson.generateRandom() + " ");
    }
    try {
        FileWriter out = new FileWriter(fileName, true);
        /** print the outputString*/
        out.write(outputString.toString());
        out.close();
        /** now erase the string so we dont print it out again later*/
        outputString = new StringBuffer();
    } catch (IOException e) {
        System.out.println(e.toString());
    }

    /** gaussian */
    outputString = new StringBuffer();
    dir = "D:\\research\\implementation\\Experiments\\results\\";
    fileName = dir + "timesguassian.txt";

    GaussianRandomGenerator gaussian = new GaussianRandomGenerator(1);
    //System.out.println("poisson seed = " + poisson.getSeed());
    for (int i = 0; i < 1000; i++) {
        //outputString.append(poisson.generateRandom() + "\n");
        //System.out.println(gaussian.generateRandom() + " ");
        outputString.append(100 * gaussian.generateRandom() + "\n");
    }
    try {
        FileWriter out = new FileWriter(fileName, true);
        /** print the outputString*/
        out.write(outputString.toString());
        out.close();
        /** now erase the string so we dont print it out again later*/
        outputString = new StringBuffer();
    } catch (IOException e) {
        System.out.println(e.toString());
    }

    /** gaussian */
    outputString = new StringBuffer();
    dir = "D:\\research\\implementation\\Experiments\\results\\";
    fileName = dir + "timesexpo.txt";

    ExponentialRandomGenerator expo = new ExponentialRandomGenerator(20);
    //System.out.println("poisson seed = " + poisson.getSeed());
    for (int i = 0; i < 1000; i++) {
        //outputString.append(poisson.generateRandom() + "\n");
        //System.out.println(gaussian.generateRandom() + " ");
        outputString.append(expo.generateRandom() + "\n");
    }
    try {
        FileWriter out = new FileWriter(fileName, true);
        /** print the outputString*/
        out.write(outputString.toString());
        out.close();
        /** now erase the string so we dont print it out again later*/
        outputString = new StringBuffer();
    } catch (IOException e) {
        System.out.println(e.toString());
    }

}
}
