package edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.xml;

/**
 * Insert the type's description here.
 * Creation date: (3/30/2003 1:37:59 PM)
 * @author: Hong Su
 */

import edu.wpi.cs.dsrg.xmldb.xat.component.datagenerators.randomgenerators.*;
 
public class ArrivalPatternController extends Thread{
	TokenBuffer[] tokenBuffers;
	XATTokenQueue[] tokenQueues;
	//hardcode: a fixed possion average time
	double aver_Possion = 10.0;
	private PoissonRandomGenerator poissonRand = new PoissonRandomGenerator(aver_Possion);
	long lastTime = System.currentTimeMillis();
	int srcNum;
	
/**
 * ArrivalPatternController constructor comment.
 */
public ArrivalPatternController(int srcNum, TokenBuffer[] tokenBuffers, XATTokenQueue[] tokenQueues) {
	super();
	this.srcNum = srcNum;
	this.tokenBuffers = tokenBuffers;
	this.tokenQueues = tokenQueues;
	
	/*bufferPoses = new int[srcNum];
	for (int i=0; i<srcNum; i++)
	  bufferPoses[i] = 0;*/
}
/**
 * Insert the method's description here.
 * Creation date: (3/31/2003 4:05:59 PM)
 * @return edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTokenQueue
 */
public XATTokenQueue getTokenQueue(int i) {
	return tokenQueues[i];
}
/**
 * Insert the method's description here.
 * Creation date: (3/30/2003 4:06:45 PM)
 */
public void run() {

    long interval = (long) poissonRand.generateRandom();

    /*   try {
           sleep(lastTime + interval);
       } catch (InterruptedException e) {
           e.printStackTrace();
       }*/

    //  while (bufferPos < tokenBuffer.length) {
    //      tokenQueue.enqueue(tokenBuffer[bufferPos]);
    //      bufferPos ++;
    //  }

    //reset, read from the very beginning
    //bufferPos = 0;
    //}

    //count how many src has finished
    int finishCount = 0;
    boolean[] finishFlags = new boolean[srcNum];
    for (int i = 0; i < srcNum; i++)
        finishFlags[i] = false;

    while (true) {

      /*  try {
            sleep(100);
        } catch (InterruptedException e) {
            e.printStackTrace();
        }*/

        for (int i = 0; i < srcNum; i++) {

           // System.out.println("arrivalPatternController");

            if (finishCount == srcNum){
                //all finished
           //     System.out.println("arrival pattern controller has finished sending all tokens");
                return;
            }

            if (finishFlags[i])
                //this src has finished
                continue;

            // if (tokenBuffers[i][bufferPoses[i]] != null) {
            XMLToken fetchedToken = tokenBuffers[i].getFrBuffer();

            if (fetchedToken != null) {
                // System.out.println("in arrival:" + tokenBuffers[i][bufferPoses[i]]);
                // tokenQueues[i].enqueue(tokenBuffers[i][bufferPoses[i]]);
                //System.out.println(fetchedToken + "put in queue");
                tokenQueues[i].enqueue(fetchedToken);

                if (fetchedToken.getType() == XMLToken.EOF) {
                    //all tokens are finished
                    //return;
                    finishFlags[i] = true;
                    finishCount++;
                    System.out.println("source " + i +" all put in the token queue");
                    continue;
                }

            }
        }

    }

}
/**
 * Insert the method's description here.
 * Creation date: (3/30/2003 4:04:46 PM)
 * @param newAver_Possion double
 */
public void setAver_Possion(double newAver_Possion) {
	aver_Possion = newAver_Possion;
}
}
