package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Feb 17, 2004
 * 
 * Insert comments here.
 */
public interface ConnectionManager {

/**
 * Connects the Query Plans to the machines based on the distribution table.
 * 
 * @return true if successful.
 * 
 */
public boolean connect();


/**
 * 
 * @param newTable -The new  distribution table that we will use
 * @return
 */
public boolean reconnect(DistributionTable newTable);

}
