package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern;

import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATNode;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.Machine;
import edu.wpi.cs.dsrg.xmldb.xat.component.distribution.configuration.QueryPlan;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Feb 10, 2004
 * 
 * Insert comments here.
 */
public class NoDistribution extends DesignPattern {

	public NoDistribution(Machine[] m, QueryPlan[] qp){
		super(m,qp);
	}

	/* (non-Javadoc)
	 * @see edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern.XATDesignPattern#distribute()
	 */
	public DistributionTable distribute() {
	System.out.println("Distributing Query Plan");
	
	DistributionTable table = new DistributionTable();
	
	try{
	
		//This one is really easy.. simply put each operator in the table of the first machine.
		for(int i = 0 ; i < this.queryPlans.length ; i++){
			XATNode[] nodes = queryPlans[i].getQueryPlan().convertToArray();
			
			for(int j=0; j< nodes.length;j++){
				table.add(nodes[j],this.machines[0]);
			}
		}
	
	}catch(Exception e){
		e.printStackTrace();
	}
		return table;
	}

}
