package edu.wpi.cs.dsrg.xmldb.xat.component.distribution.pattern;

/**
 * @author Timothy M. Sutherland
 * @author tims@cs.wpi.edu
 * @author http://www.tsutherland.com
 * @version 1.0
 * 
 * Feb 10, 2004
 * 
 * This Interface represents the design pattern that the distribution
 * manager will use to distribute the query plan.
 * 
 */
public interface XATDesignPattern {

	/**
	 * 
	 * Distributes the query plan amongst the machines.
	 * 
	 * @return -True if successful, False otherwise.
	 * 
	 */
	public DistributionTable distribute();
	
}
