package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.Vector;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.TimeStamp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStamp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampImp;
import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTuple;
import edu.wpi.cs.dsrg.xmldb.xat.common.xatnode.XATDataValue;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparableTupleValues
	.KeyDouble;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparableTupleValues
	.KeyInterface;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.ComparableTupleValues
	.KeyLong;
import edu
	.wpi
	.cs
	.dsrg
	.xmldb
	.xat
	.component
	.operator
	.Juggler
	.predicateBitRepresentation
	.ExtPredicateBitSet;
/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 8:11:41 PM)
 * @author: Administrator
 */
public class JugglerTuple
	extends edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTupleImp
	implements Serializable {
	/**
	 * @param t
	 * @param i
	 */
	public JugglerTuple(XATTuple t, long i) throws XATTimeStampException {
		super();
		if (t != null) {
			arrayCell = t.getArrayData();
			streamIDs = new ArrayList();
			streamNames = new ArrayList();
			XATTimeStamp ts = new XATTimeStampImp();
			ts.setTimeStamp(i, 0, arrayCell.length - 1);
			t.setTimeStamp(ts);
			/*try {
				ts.setTimeStamp(0, this.getArrayData().length);
			} catch (XATTimeStampException e) {
				e.printStackTrace();
			}*/
			if (t.getTimeStamp() != null)
				this.setTimeStamp(t.getTimeStamp());
			else {
				try {
					ts.setTimeStamp(0, this.getArrayData().length);
				} catch (XATTimeStampException e) {
					e.printStackTrace();
				}
				this.setTimeStamp(ts);
			}
			predicates = new ExtPredicateBitSet();
			firstHalfJoinedTupleMarker = true;
			possibleQuerySatisfied = new ArrayList();
		} else {
			//hello
			System.out.println("tuple is null");
		}
	}
	protected ExtPredicateBitSet predicates;
	protected ArrayList streamIDs;
	protected ArrayList streamNames;
	//protected long timeStamp;
	protected boolean firstHalfJoinedTupleMarker;
	protected java.util.ArrayList possibleQuerySatisfied;
	/**
	 * Tuple constructor comment.
	 */
	public JugglerTuple() {
		super();
		streamIDs = new ArrayList();
		streamNames = new ArrayList();
		XATTimeStamp ts = new XATTimeStampImp();
		try {
			ts.setTimeStamp(0, 1);
		} catch (XATTimeStampException e) {
			e.printStackTrace();
		}
		this.setTimeStamp(ts);
		predicates = new ExtPredicateBitSet();
		firstHalfJoinedTupleMarker = true;
		possibleQuerySatisfied = new ArrayList();
	}
	public JugglerTuple(XATTuple t) {
		super();
		if (t != null) {
			arrayCell = t.getArrayData();
			streamIDs = new ArrayList();
			streamNames = new ArrayList();
			XATTimeStamp ts = new XATTimeStampImp();
			/*try {
				ts.setTimeStamp(0, this.getArrayData().length);
			} catch (XATTimeStampException e) {
				e.printStackTrace();
			}*/
			if (t.getTimeStamp() == null) {
				try {
					ts.setTimeStamp(0, this.getArrayData().length - 1);
				} catch (XATTimeStampException e) {
					e.printStackTrace();
				}
				this.setTimeStamp(ts);
			} else {
				int numTSobjects = t.getTimeStamp().getNumTimeStamps();
				TimeStamp[] allTS = null;
				XATTimeStamp temp = new XATTimeStampImp();
				try {
					allTS = t.getTimeStamp().getTimeStampObjects();

					for (int i = 0; i < numTSobjects; i++) {
						TimeStamp aTS = (TimeStamp) allTS[i];
						temp.setTimeStamp(
							aTS.getTimeStamp(),
							aTS.getStartColumn(),
							aTS.getEndColumn());
						//this.getTimeStamp().
					}
				} catch (XATTimeStampException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
				this.setTimeStamp(temp);
			}
			predicates = new ExtPredicateBitSet();
			firstHalfJoinedTupleMarker = true;
			possibleQuerySatisfied = new ArrayList();
		} else {
			//hello
			System.out.println("tuple is null");
		}
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/1/2003 7:27:10 PM)
	 * @param param java.util.Vector
	 */
	public JugglerTuple(Vector param) {

		super(param);
		streamIDs = new ArrayList();
		streamNames = new ArrayList();
		predicates = new ExtPredicateBitSet();
		firstHalfJoinedTupleMarker = true;
		possibleQuerySatisfied = new ArrayList();

		Iterator it = param.iterator();
		int index = 0;
		/*while (it.hasNext()) {
								KeyInterface val = (KeyInterface) it.next();
								this.data.add(index, val);
								index ++;
							}*/
		timeStamp = new XATTimeStampImp();
		try {
			timeStamp.setTimeStamp(0, this.getLength());
		} catch (XATTimeStampException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	/**
	 * Adds stream ID to the tuple.
	 * Creation date: (1/12/2003 10:03:53 PM)
	 * @param streamID int
	 */
	public void addStreamID(int streamID) {
	}
	/**
	 * Adds stream name.
	 * Creation date: (1/12/2003 9:37:12 PM)
	 * @param streamName ArrayList
	 */
	public void addStreamName(ArrayList streamName) {
		streamNames.add(streamName);

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/17/2003 7:01:49 PM)
	 * @param tuple juggler.stream.Tuple
	 */
	public void appendStreamIDs(ArrayList streamIDs) {
		//make sure that no stream IDs are repeated

		Iterator it = streamIDs.iterator();
		KeyInterface tempStreamID;

		while (it.hasNext()) {
			tempStreamID = (KeyInterface) it.next();
			//if it contains doesn't contain the stream, continue
			if (!this.streamIDs.contains(tempStreamID))
				continue;
			else {
				//if it contains the stream ID, then delete it in the tuple and return
				streamIDs.remove(tempStreamID);
			}
		}

		//joins the streamIDs

		this.streamIDs.addAll(streamIDs);

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/17/2003 6:34:27 PM)
	 * @param streamNames java.util.ArrayList
	 */
	public void appendStreamNames(ArrayList streamNames) {
		//make sure that no stream Names are repeated

		Iterator it = this.streamNames.iterator();
		while (it.hasNext()) {
			String tempStreamName = (String) it.next();
			//if streamNames don't contain the tempStreamName continue
			if (!this.streamNames.contains(tempStreamName))
				continue;
			else {
				streamNames.remove(tempStreamName);
			}
			//else delete the streamName
		}

		this.streamNames.addAll(streamNames);

	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/29/2003 2:46:03 PM)
	 * @return juggler.stream.Tuple
	 */
	public JugglerTuple getJugglerClone() {
		JugglerTuple t = new JugglerTuple();
		try {
			t.ifLastTuple = this.ifLastTuple;
			t.isNewTuple = this.isNewTuple;
			t.oneCell = this.oneCell;
			t.firstHalfJoinedTupleMarker = firstHalfJoinedTupleMarker;
			t.arrayCell = this.arrayCell;
			if (predicates != null)
				t.predicates = (ExtPredicateBitSet) predicates.getClone();
			else
				t.predicates = null;
			t.streamIDs =
				(
					ArrayList) edu
						.wpi
						.cs
						.dsrg
						.xmldb
						.xat
						.raindrop
						.utils
						.DeepCopyMaker
						.makeDeepCopy(
					streamIDs);
			t.streamNames =
				(
					ArrayList) edu
						.wpi
						.cs
						.dsrg
						.xmldb
						.xat
						.raindrop
						.utils
						.DeepCopyMaker
						.makeDeepCopy(
					streamNames);
			t.possibleQuerySatisfied =
				(
					ArrayList) edu
						.wpi
						.cs
						.dsrg
						.xmldb
						.xat
						.raindrop
						.utils
						.DeepCopyMaker
						.makeDeepCopy(
					possibleQuerySatisfied);
			t.timeStamp = timeStamp;

		} catch (Exception e) {
			System.out.println(e.toString());
			e.printStackTrace();
		}
		return t;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/17/2003 9:51:15 PM)
	 * @return juggler.stream.ExtPredicateBitSet
	 */
	public ExtPredicateBitSet getPredicates() {
		return predicates;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/1/2003 1:08:49 AM)
	 * @return java.util.ArrayList
	 */
	public java.util.ArrayList getQuerySatisfied() {
		return possibleQuerySatisfied;
	}
	/**
	 * Returns streamIDs of the tuple.
	 * Creation date: (1/12/2003 9:32:04 PM)
	 * @return ArrayList
	 */
	public ArrayList getStreamIDs() {
		return streamIDs;
	}
	/**
	 * Returns the stream names of the tuple.
	 * Creation date: (1/12/2003 9:33:06 PM)
	 * @return ArrayList
	 */
	public ArrayList getStreamNames() {

		return streamNames;
	}
	/**
	 * Returns the timestamp of this tuple (latest timestamp)
	 * Creation date: (1/12/2003 9:33:24 PM)
	 * @return long
	 */
	public long getJugglerTimeStamp() {

		try {
			return this.getTimeStamp().getMaxTimeStamp();
		} catch (XATTimeStampException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return 0;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/15/2003 12:50:51 PM)
	 * @return boolean
	 */
	public boolean isFirstHalfJoinedTupleMarker() {
		return firstHalfJoinedTupleMarker;
	}
	/**
	 * The first n values of the tuple correspond to the tuple's streamTimestamps.
	 * Creation date: (2/17/2003 6:32:42 PM)
	 * @return juggler.stream.Tuple
	 * @param tuple juggler.stream.Tuple
	 */
	public JugglerTuple joinTuple(JugglerTuple tuple) {
		/*
		//make sure the timestamps are kept distinct
		KeyInterface tTimestamp = (KeyInterface) tuple.getCell(0);
		tuple.getValues().remove(0);
		
		//add this stream's timestamp
		this.getValues().add(tTimestamp);
		
		//append the tuple's streamNames
		this.appendStreamNames(tuple.getStreamNames());
		//append the tuple's streamIDs
		this.appendStreamIDs(tuple.getStreamIDs());
		
		//updates the timestamp to be the the max of all the streams
		this.updateTimestamp();
		
		this.union(tuple);
		*/

		return null;
	}
	/**
	 * Determine if we are later than t
	 * Creation date: (1/24/2003 7:43:02 PM)
	 * @return boolean
	 * @param t edu.wpi.cs.heineman.structure.Tuple
	 */
	public boolean later(JugglerTuple t) {
		if (t == null)
			return false;
		long thisTS = this.getJugglerTimeStamp();
		long tTS = t.getJugglerTimeStamp();
		return (thisTS >= tTS);
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (4/15/2003 12:50:51 PM)
	 * @param newFirstHalfJoinedTupleMarker boolean
	 */
	public void setFirstHalfJoinedTupleMarker(boolean newFirstHalfJoinedTupleMarker) {
		firstHalfJoinedTupleMarker = newFirstHalfJoinedTupleMarker;
	}
	/**
	 * Sets the predicate bitset of the tuple.
	 * Creation date: (1/10/2003 12:06:02 AM)
	 * @param newPredicates juggler.stream.PredicateBitSet
	 */
	public void setPredicates(ExtPredicateBitSet newPredicates) {
		predicates = newPredicates;
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (5/1/2003 1:08:49 AM)
	 * @param newQuerySatisfied java.util.ArrayList
	 */
	public void setQuerySatisfied(java.util.ArrayList newQuerySatisfied) {
		possibleQuerySatisfied = newQuerySatisfied;
	}
	/**
	 * Sets the streamIDs of the tuple
	 * Creation date: (1/12/2003 9:32:04 PM)
	 * @param newStreamIDs int[]
	 */
	public void setStreamIDs(ArrayList newStreamIDs) {
		streamIDs = newStreamIDs;
	}
	/**
	 * Sets the stream names of the tuple
	 * Creation date: (1/12/2003 9:33:06 PM)
	 * @param newStreamNames java.lang.String[]
	 */
	public void setStreamNames(ArrayList newStreamNames) {
		streamNames = newStreamNames;
	}
	/**
	 * Sets the timestamp of the tuple.
	 * Creation date: (1/12/2003 9:33:24 PM)
	 * @param newTimeStamp long
	 */
	public void setTimeStamp(long newTimeStamp) {
		try {
			timeStamp.setTimeStamp(newTimeStamp, this);
		} catch (XATTimeStampException e) {
			e.printStackTrace();
		}
	}
	/**
	 * Returns a String that represents the value of this object.
	 * @return a string representation of the receiver
	 */
	public String toString() {
		// Insert code to print the receiver here.
		// This implementation forwards the message to super. You may replace or supplement this.
		return super.toString();
	}
	/**
	 * Insert the method's description here.
	 * Creation date: (2/17/2003 7:31:55 PM)
	 */
	public void updateTimestamp() {
		int size = this.getStreamIDs().size();

		//if there is only one stream
		if (size + 1 == 1) {
			KeyLong OneTS = (KeyLong) this.getCell(0);
			this.setTimeStamp(OneTS.getKey());

		}

		long tempMaxTS = 0;

		//if there is more than one stream
		for (int i = 0; i < size - 1; i++) {
			long tempTS1 = ((KeyLong) this.getCell(i)).getKey();
			long tempTS2 = ((KeyLong) this.getCell(i + 1)).getKey();
			tempMaxTS = Math.max(tempTS1, tempTS2);
		}

		this.setTimeStamp(tempMaxTS);

	}

	/**
				 * Sets the predicate bitset of the tuple.
				 * Creation date: (1/10/2003 12:06:02 AM)
				 * @param newPredicates juggler.stream.PredicateBitSet
				 */
	public Vector getValues() {
		Vector ourValues = new Vector();
		XATDataValue[] dataValues = this.getArrayData();
		for (int i = 0; i < dataValues.length; i++) {
			XATDataValue value = dataValues[i];
			ourValues.add(value);
		}
		return ourValues;
	}

	/**
			 * Insert the method's description here.
			 * Creation date: (1/27/2003 11:08:47 PM)
			 * @param newTuple juggler.stream.Tuple
			 */
	public boolean setTupleReference_XATTuple(JugglerTuple newTuple) {
		if (newTuple != null) {
			this.firstHalfJoinedTupleMarker =
				newTuple.firstHalfJoinedTupleMarker;
			this.setValues(newTuple.getValues());
			this.possibleQuerySatisfied = newTuple.possibleQuerySatisfied;
			this.predicates = newTuple.predicates;
			this.streamIDs = newTuple.streamIDs;
			this.streamNames = newTuple.streamNames;
			this.timeStamp = newTuple.timeStamp;
			return true;
		} else {
			Enumeration e = getValues().elements();
			while (e.hasMoreElements()) {
				XATDataValue element = (XATDataValue) e.nextElement();
				element = null;
			}
			this.arrayCell = null;
			this.possibleQuerySatisfied = null;
			this.predicates = null;
			this.streamIDs = null;
			this.streamNames = null;
			return false;
		}
	}

	/**
			 * Insert the method's description here.
			 * Creation date: (1/27/2003 11:08:47 PM)
			 * @param newTuple juggler.stream.Tuple
			 */
	public boolean setTupleReference(JugglerTuple newTuple) {
		if (newTuple != null) {
			this.firstHalfJoinedTupleMarker =
				newTuple.firstHalfJoinedTupleMarker;
			this.setValues(newTuple.getValues());
			this.possibleQuerySatisfied = newTuple.possibleQuerySatisfied;
			this.predicates = newTuple.predicates;
			this.streamIDs = newTuple.streamIDs;
			this.streamNames = newTuple.streamNames;
			this.timeStamp = newTuple.timeStamp;
			return true;
		} else {
			Enumeration e = getValues().elements();
			while (e.hasMoreElements()) {
				KeyDouble element = (KeyDouble) e.nextElement();
				element = null;
			}
			this.arrayCell = null;
			this.possibleQuerySatisfied = null;
			this.predicates = null;
			this.streamIDs = null;
			this.streamNames = null;
			return false;
		}
	}

	/**
			 * @param b
			 */
	public boolean equals_WithPredicates(JugglerTuple n) {
		boolean isEqual = false;

		if (predicates != null) {
			if (predicates.equals(n.predicates)) {
				isEqual = true;
			} else {
				return false;
			}
		}
		if (!timeStamp.equals(n.timeStamp))
			return false;

		if (streamIDs != null) {
			if (streamIDs.equals(n.streamIDs)) {
				isEqual = true;
			} else {
				return false;
			}
		}

		if (streamNames != null) {
			if (streamNames.equals(n.streamNames)) {
				isEqual = true;
			} else {
				return false;
			}
		}
		return isEqual;

	}

	/**
			 * @param b
			 */
	public boolean equals(JugglerTuple n) {
		boolean isEqual = false;
		/*
			if(predicates != null){
				if(predicates.equals(n.predicates)){
				isEqual = true;
				}
				else{ return false;
				}
			}*/

		if (!timeStamp.equals(n.timeStamp))
			return false;

		if (streamIDs != null) {
			if (streamIDs.equals(n.streamIDs)) {
				isEqual = true;
			} else {
				return false;
			}
		}

		if (streamNames != null) {
			if (streamNames.equals(n.streamNames)) {
				isEqual = true;
			} else {
				return false;
			}
		}
		return isEqual;

	}

	public KeyInterface getColumnValue(int colIndex) {
		String tupleValStr =
			((XATDataValue) this.getCell(colIndex)).convertToString();
		double tupleValdouble = -1;
		try {
			tupleValdouble = (new Double(tupleValStr)).doubleValue();
		} catch (Exception e) {
			e.printStackTrace();
			System.err.println("This tuple cell is not a number.");
		}
		KeyInterface tupleVal = (KeyInterface) (new KeyDouble(tupleValdouble));
		return tupleVal;
	}
	/**
	 * @param compareTuple
	 * @param colInt
	 * @return
	 */
	public boolean later(JugglerTuple t, int colInt) {
		long tTs = -1;
		if (t == null)
			return false;
		long thisTS = -1;
		try {
			thisTS = this.getTimeStamp().getTimeStamp(colInt);
			tTs = t.getTimeStamp().getTimeStamp(colInt);
		} catch (XATTimeStampException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return (thisTS >= tTs);
	}
}
