package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicateBitRepresentation;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.NoSuchElementException;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists.BitPosition;
/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 11:39:06 PM)
 * @author: Administrator
 */
public class ExtPredicateBitSet extends ExtGeneralTypeBitSet implements Serializable{
//ArrayList of PredicateTypeNames
protected java.util.ArrayList predicateTypes;
/* ArrayList of ExtGeneralTypeBitSet for the predicate type*/	
protected java.util.ArrayList predicateTypeBS;
/**
 * PredicateBitSet constructor comment.
 */
public ExtPredicateBitSet() {
	super();
	predicateTypeBS = new ArrayList();
	predicateTypes = new ArrayList();
	predicateTypes.add("attribute");
	predicateTypes.add("join");
	predicateTypes.add("window");
	ExtGeneralTypeBitSet attribute = new ExtGeneralTypeBitSet("attribute");
	ExtGeneralTypeBitSet join = new ExtGeneralTypeBitSet ("join");
	ExtGeneralTypeBitSet window = new ExtGeneralTypeBitSet ("window");
	predicateTypeBS.add(attribute);
	predicateTypeBS.add(join);
	predicateTypeBS.add(window);
	
	
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:47:11 PM)
 * @param predicateTypes java.util.ArrayList
 */
public ExtPredicateBitSet(ArrayList predicateTypesNames) {
	predicateTypes = predicateTypesNames;
	predicateTypeBS = new ArrayList();
	for (int i = 0; i < predicateTypes.size(); i++) {
		String predicateName = (String) predicateTypes.get(i);
		ExtGeneralTypeBitSet gps = new ExtGeneralTypeBitSet(predicateName);
		this.predicateTypeBS.add(gps);
	}
	
	}
/**
 * Insert the method's description here.
 * Creation date: (4/14/2003 6:58:27 PM)
 * @param param juggler.stream.PredicateBitSet
 */
public void combineBitSets(ExtPredicateBitSet param) {
	for (int i = 0; i < predicateTypes.size(); i++){
		ExtGeneralTypeBitSet egBS = (ExtGeneralTypeBitSet) predicateTypeBS.get(i);
		egBS.combineBitSets((ExtGeneralTypeBitSet)param.getTypeBS().get(i));
	}
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:12:30 PM)
 * @return juggler.stream.GeneralPredicateBitSet
 * @param predName java.lang.String
 */
public GeneralPredicateBitSet getAppropriatePredicateTypeBitSet(String predName) throws NoSuchElementException{
	try {
		int index = this.getPredicateTypes().indexOf(predName);
		ExtGeneralTypeBitSet gbs = (ExtGeneralTypeBitSet) predicateTypeBS.get(index);
	return  gbs.getPredBSList();
	}catch (NoSuchElementException e) {
		e.printStackTrace();
	}
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:12:30 PM)
 * @return juggler.stream.GeneralPredicateBitSet
 * @param predName java.lang.String
 */
public ExtGeneralTypeBitSet getAppropriatePredicateTypeExt(String predName) throws NoSuchElementException{
	try {
	int index = predicateTypes.indexOf(predName);
	return ((ExtGeneralTypeBitSet)predicateTypeBS.get(index));
	}catch (NoSuchElementException e) {
		e.printStackTrace();
	}
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (3/10/2003 1:11:30 PM)
 * @return java.lang.Object
 */
public Object getClone() {
	ExtPredicateBitSet extpbs = new ExtPredicateBitSet();
	//set the predicate types to null
	extpbs.predicateTypeBS = new ArrayList();
	try {
		extpbs.predicateTypes = (ArrayList) edu.wpi.cs.dsrg.xmldb.xat.raindrop.utils.DeepCopyMaker.makeDeepCopy(predicateTypes);
		for (int i = 0; i < predicateTypes.size(); i++) {
			ExtGeneralTypeBitSet gbs = (ExtGeneralTypeBitSet) predicateTypeBS.get(i);
			extpbs.predicateTypeBS.add((ExtGeneralTypeBitSet) gbs.getClone());
		}
	}
	catch (Exception e) {
        System.out.println(e.toString());
        e.printStackTrace();
	}
	
  
    return extpbs;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 2:12:30 PM)
 * @return juggler.stream.GeneralPredicateBitSet
 * @param predName java.lang.String
 */
public GeneralPredicateBitSet getIsEvaluated_Relevant(String predName) throws NoSuchElementException{
	try {
	int index = predicateTypes.indexOf(predName);
	return (((ExtGeneralTypeBitSet)predicateTypeBS.get(index)).getIsEvaluated_Relevant());
	}catch (NoSuchElementException e) {
		e.printStackTrace();
	}
	return null;
}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 3:09:29 PM)
 * @return java.util.ArrayList
 */
public java.util.ArrayList getPredicateTypes() {
	return predicateTypes;
}
/**
 * List Index is one greater than its position in the arrayList
 * Creation date: (3/8/2003 9:09:09 PM)
 * @return java.lang.String
 */
public String getSetBitstoString() {

    String predBSstring = "";


     for (int i = 0; i < predicateTypes.size(); i++) {
        ExtGeneralTypeBitSet predTypeBitSet =
            (ExtGeneralTypeBitSet) predicateTypeBS.get(i);
       predBSstring += predTypeBitSet.toString();
       predBSstring += "\n";
    }

    return predBSstring;
}
/**
 * Insert the method's description here.
 * Creation date: (5/6/2003 7:43:18 PM)
 * @return java.util.ArrayList
 */
public java.util.ArrayList getTypeBS() {
	return predicateTypeBS;
}
/**
 * Returns true if the Predicatebitset is a superset of this predicateBitSet.
 * Creation date: (1/9/2003 11:48:46 PM)
 * @return boolean
 * @param param PredicateBitSet
 */
public boolean isSuperset(BitSet[] paramBS, BitSet[] isRel, String predName)
{

        ExtGeneralTypeBitSet pbs = this.getAppropriatePredicateTypeExt(predName);

        
        if (pbs.isSuperset(paramBS, isRel))
           return true;
        else
            return false;

}
/**
 * Returns true if the Predicatebitset is a superset of this predicateBitSet.
 * Creation date: (1/9/2003 11:48:46 PM)
 * @return boolean
 * @param param PredicateBitSet
 */
public boolean isSuperset(ExtPredicateBitSet param)
 {
    for (int i = 0; i < predicateTypes.size(); i++) {
        ExtGeneralTypeBitSet paramPredTypeBitSet =
            (ExtGeneralTypeBitSet) param.predicateTypeBS.get(i);
        ExtGeneralTypeBitSet predTypeBitSet =
            (ExtGeneralTypeBitSet) predicateTypeBS.get(i);
        if (predTypeBitSet
            .isSuperset(paramPredTypeBitSet))
            continue;
        else
            return false;
    }

    return true;

}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 8:03:45 PM)
 * @param bp juggler.predicatestructure.BitPosition
 */
public void setBitPosition(BitPosition bp, String predName) {

	ExtGeneralTypeBitSet gbs = this.getAppropriatePredicateTypeExt(predName);

	gbs.isEvaluated_Relevant.setBitPosition(bp);

	gbs.getPredBSList().setBitPosition(bp);

}
/**
 * Insert the method's description here.
 * Creation date: (5/5/2003 3:09:29 PM)
 * @param newPredicateTypes java.util.ArrayList
 */
public void setPredicateTypes(java.util.ArrayList newPredicateTypes) {
	predicateTypes = newPredicateTypes;
}
/**
 * Insert the method's description here.
 * Creation date: (5/6/2003 7:43:18 PM)
 * @param newTypeBS java.util.ArrayList
 */
public void setTypeBS(java.util.ArrayList newTypeBS) {
	predicateTypeBS = newTypeBS;
}
/**
 * List Index is one greater than its position in the arrayList
 * Creation date: (3/8/2003 9:09:09 PM)
 * @return java.lang.String
 */
public String toString() {
  String extPBS = "";
  for (int i = 0; i < predicateTypes.size(); i++) {
	  extPBS += (String)predicateTypes.get(i) + "\n";
	  extPBS += "Predicates \n";
	  ExtGeneralTypeBitSet extgbs = (ExtGeneralTypeBitSet) predicateTypeBS.get(i);
	  extPBS += extgbs.toString();
	  extPBS += "\n";
  }
  return  extPBS;

}
}
