package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.common.dag.XATTimeStampException;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.ComparableTupleValues.KeyInterface;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleListIterator;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;
/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 8:33:12 PM)
 * @author: Administrator
 */
public class JWPredOrderList extends OrderList implements Serializable{
	protected ArrayList streamName2;
	protected java.lang.String column2;
	protected int columnInt2;
/**
 * JWPredOrderList constructor comment.
 */
public JWPredOrderList() {
	super();
}
/**
 * Insert the method's description here.
 * Creation date: (2/26/2003 8:23:48 PM)
 * @param predListName java.lang.String
 */
public JWPredOrderList(String predListName) {
	super();
	this.setListName(predListName);
	
	}
/**
 * Insert the method's description here.
 * Creation date: (2/17/2003 8:49:45 PM)
 * @return int
 * @param tupleList1 org.omg.CORBA.Object
 * @param tupleList2 org.omg.CORBA.Object
 */
public int compareTo(Object tuple1, Object tuple2) {

	JugglerTuple tTuple1 = (JugglerTuple) tuple1;
	JugglerTuple tTuple2 = (JugglerTuple) tuple2;

	
	return 0;
}
/**
 * Compares two objects for equality. Returns a boolean that indicates
 * whether this object is equivalent to the specified object. This method
 * is used when an object is stored in a hashtable.
 * @param obj the Object to compare with
 * @return true if these Objects are equal; false otherwise.
 * @see java.util.Hashtable
 */
public boolean equals(Object obj) {
	// Insert code to compare the receiver and obj here.
	// This implementation forwards the message to super.  You may replace or supplement this.
	// NOTE: obj might be an instance of any class
	//return super.equals(obj);
	JWPredOrderList o = (JWPredOrderList) obj;

	if (o.getColumn1() == this.getColumn1()
		&& o.getOp().equals(this.getOp())
		&& o.getStreamName1() == this.getStreamName1()
		&& o.getColumn2() == this.getColumn2()
		&& o.getColumnInt1() == this.getColumnInt1()
		&& o.getColumnInt2() == this.getColumnInt2()
		&& o.getStreamName2().equals(this.getStreamName2()))
		return true;
	else
		return false;
}
/**
 * Returns the second stream's column.
 * Creation date: (1/9/2003 8:35:48 PM)
 * @return java.lang.String
 */
public java.lang.String getColumn2() {
	return column2;
}
/**
 * Insert the method's description here.
 * Creation date: (4/13/2003 7:28:11 PM)
 * @return int
 */
public int getColumnInt2() {
	return columnInt2;
}
/**
 * Returns the second stream name.
 * Creation date: (1/9/2003 8:34:39 PM)
 * @return ArrayList
 */
public ArrayList getStreamName2() {
	return streamName2;
}
/**
 * Sets the second stream's column name.
 * Creation date: (1/9/2003 8:35:48 PM)
 * @param newColumn2 java.lang.String
 */
public void setColumn2(java.lang.String newColumn2) {
	column2 = newColumn2;
}
/**
 * Insert the method's description here.
 * Creation date: (4/13/2003 7:28:11 PM)
 * @param newInt2 int
 */
public void setColumnInt2(int newInt2) {
	columnInt2 = newInt2;
}
/**
 * Sets second stream name.
 * Creation date: (1/9/2003 8:34:39 PM)
 * @param newStreamName2 ArrayList
 */
public void setStreamName2(ArrayList newStreamName2) {
	streamName2 = newStreamName2;
}
/**
 * Returns a String that represents the value of this object.
 * @return a string representation of the receiver
 */
public String toString() {
	// Insert code to print the receiver here.
	// This implementation forwards the message to super. You may replace or supplement this.
	//return super.toString();

	String predListStr = "";
	
	Iterator it = this.getList().iterator();
	while (it.hasNext()) {
		Predicate p = (Predicate) it.next();
		predListStr += p.toString() + "\n";
	}

	return predListStr;
}

/**
 * Insert the method's description here.
 * Creation date: (4/15/2003 2:26:44 PM)
 * @return ArrayList
 * @param tupleList juggler.stream.TupleList
 * @param tuple juggler.stream.JugglerTuple
 */
public ArrayList findMosCoveringPredicates(
	JugglerTupleList tupleList,
	JugglerTupleList tupleList2) {
	ArrayList indexes = new ArrayList();
	JugglerTupleListIterator tuplesIt = new JugglerTupleListIterator(tupleList);
	JugglerTupleListIterator tuplesIt2 = new JugglerTupleListIterator(tupleList2);
	//make sure this works with multiple tuples!!!!!!!!
	while (tuplesIt.hasNext()) {
		JugglerTuple nextTuple = (JugglerTuple) tuplesIt.next();
		if (!nextTuple.getStreamNames().equals((ArrayList) streamName1))
			continue;
		while (tuplesIt2.hasNext()) {
			JugglerTuple tuple = (JugglerTuple) tuplesIt2.next();
			if (!tuple.getStreamNames().equals((ArrayList)streamName2))
				continue;
			int index = findMostCovering2(nextTuple, tuple);   
			if (index >= 0)
				indexes.add(new Integer(index));
		}
	}
	return indexes;
}

/**
 * Finds the most covering predicate for the specified tuple.
 * Assumes the tuple has been normalized
 * Creation date: (1/9/2003 8:12:57 PM)
 * @param tuple juggler.stream.Tuple
 * @return int
 */
public int findMostCovering(JugglerTuple tuple) {
	return -100;
	}

/**
 * Finds the most covering predicate for the specified tuple.
 * Assumes the tuple has been normalized.
 * Compares tuple 1 to tuple 2.
 * Finds one predicate that is satisfied by doing a binary search.
 * But once a predicate is found, it traverses one by one until the most covering is found.
 * Creation date: (1/9/2003 8:12:57 PM)
 * @param tuple1 juggler.stream.Tuple
 * @param tuple2 juggler.stream.Tuple
 * @return int
 */
public int findMostCovering(JugglerTuple tuple1, JugglerTuple tuple2) {
	KeyInterface compareToValue;

	java.util.LinkedList llist = this.getList();
	Predicate pTemp = null;

	while (!llist.isEmpty()) {
		int index = llist.size()/2;

		Predicate p = (Predicate) llist.get(index);  

		int predResult = p.evaluate(tuple1, tuple2);   

		//if the predicate is equal, then try to find the one that is the most covering predicate
		if (predResult == 0) {
			java.util.Iterator subListIt = llist.iterator();
			while (subListIt.hasNext()) {
				p = (Predicate) subListIt.next();
				predResult = p.evaluate(tuple1, tuple2) ;
				if (predResult == 0)
					pTemp = p;
					//found the most covering
				else
					return this.getList().indexOf(pTemp);
					//pTemp = (Predicate) llist.get(index);
					//llist = new java.util.LinkedList (this.getList().subList(index, llist.size()));
			}
			//if the last one in the llist also satisfies
			return this.getList().indexOf(pTemp);
		}
		//if the predicate is greater, then find the predicate in the lower part of the list
		if (predResult == -1) {
			//if htis is the last predicate to be tested and to avoid looping
			if (index == 0) {
				return -1;
			}
			llist =new java.util.LinkedList (this.getList().subList(0, index));
		}
		//if the predicate is lesser, then find the predicate in the higher part of the list
		if (predResult ==1) {
			//if htis is the last predicate to be tested and to avoid looping
			if (index == llist.size()-1) {
				pTemp = (Predicate) llist.get(index);
				return this.getList().indexOf(pTemp);
			}
			llist =  new java.util.LinkedList(this.getList().subList(index+1, this.getList().size()));
		}
		
		
	}
	//returns the index of hte most covering predicate
	return this.getList().indexOf(pTemp);

	
	}

/**
 * Finds the most covering predicate for the specified tuple.
 * Assumes the tuple has been normalized.
 * Finds the most covering predicate by doing a binary search algorithm.
 * Compares tuple 1 to tuple 2.
 * Creation date: (1/9/2003 8:12:57 PM)
 * @param tuple1 juggler.stream.Tuple
 * @param tuple2 juggler.stream.Tuple
 * @return int
 */
public int findMostCovering2(JugglerTuple tuple1, JugglerTuple tuple2) {
	KeyInterface compareToValue;

	java.util.LinkedList llist = this.getList();
	Predicate pTemp = null;

	while (!llist.isEmpty()) {
		int index = llist.size()/2;

		Predicate p = (Predicate) llist.get(index);  

		int predResult = p.evaluate(tuple1, tuple2);
			

		//if the predicate is equal, then try to find the one that is the most covering predicate
		if (predResult == 0) {
			pTemp = (Predicate) llist.get(index);
			llist = new java.util.LinkedList (this.getList().subList(index+1, llist.size()));
		}
		//if the predicate is greater, then find the predicate in the lower part of the list
		if (predResult == -1) {
			//if htis is the last predicate to be tested and to avoid looping
			if (index == 0) {
				return -1;
			}
			llist =new java.util.LinkedList (this.getList().subList(0, index));
		}
		//if the predicate is lesser, then find the predicate in the higher part of the list
		if (predResult ==1) {
			//if htis is the last predicate to be tested and to avoid looping
			if (index == /*llist.size()-1*/ 0) {
				//pTemp = (Predicate) llist.get(index); -------------
				
				//if its an equal operator, do not accept any predResult except 0
					//if (p.getOp().toString() == "=") ----------------
						return -1;
				//return this.getList().indexOf(pTemp); ---------------
			}
			llist =  new java.util.LinkedList(this.getList().subList(index+1, this.getList().size()));
		}
		
		
	}
	//returns the index of hte most covering predicate
	return this.getList().indexOf(pTemp);

	
	}
/**
 * @param tupleForFirstStream
 * @param tupleForSecondStream
 * @return
 */
public ArrayList findMosCoveringPredicates_XATTuple(JugglerTupleList tupleList, JugglerTupleList tupleList2) throws XATTimeStampException {
	
	ArrayList indexes = new ArrayList();
	JugglerTupleListIterator tuplesIt = new JugglerTupleListIterator(tupleList);
	JugglerTupleListIterator tuplesIt2 = new JugglerTupleListIterator(tupleList2);
	//make sure this works with multiple tuples!!!!!!!!
	while (tuplesIt.hasNext()) {
		JugglerTuple nextTuple = (JugglerTuple) tuplesIt.next();
		ArrayList tupleStreamNames = nextTuple.getStreamNames();
		if (!tupleStreamNames.containsAll(streamName1))
			continue;
		while (tuplesIt2.hasNext()) {
			JugglerTuple tuple = (JugglerTuple) tuplesIt2.next();
			if (!tuple.getStreamNames().containsAll(streamName2))
				continue;
			int index = findMostCovering2_XATTuple(nextTuple, tuple);   
			if (index >= 0)
				indexes.add(new Integer(index));
		}
	}
	return indexes;
	

}
/**
 * @param nextTuple
 * @param tuple
 * @return
 */
private int findMostCovering2_XATTuple(JugglerTuple tuple1, JugglerTuple tuple2) throws XATTimeStampException {
	KeyInterface compareToValue;

	java.util.LinkedList llist = this.getList();
	Predicate pTemp = null;

	while (!llist.isEmpty()) {
		int index = llist.size()/2;

		Predicate p = (Predicate) llist.get(index);  

		int predResult = p.evaluate_XATTuple(tuple1, tuple2);
			

		//if the predicate is equal, then try to find the one that is the most covering predicate
		if (predResult == 0) {
			pTemp = (Predicate) llist.get(index);
			llist = new java.util.LinkedList (this.getList().subList(index+1, llist.size()));
		}
		//if the predicate is greater, then find the predicate in the lower part of the list
		if (predResult == -1) {
			//if htis is the last predicate to be tested and to avoid looping
			if (index == 0) {
				return -1;
			}
			llist =new java.util.LinkedList (this.getList().subList(0, index));
		}
		//if the predicate is lesser, then find the predicate in the higher part of the list
		if (predResult ==1) {
			//if htis is the last predicate to be tested and to avoid looping
			if (index == /*llist.size()-1*/ 0) {
				//pTemp = (Predicate) llist.get(index); -------------
				
				//if its an equal operator, do not accept any predResult except 0
					//if (p.getOp().toString() == "=") ----------------
						return -1;
				//return this.getList().indexOf(pTemp); ---------------
			}
			llist =  new java.util.LinkedList(this.getList().subList(index+1, this.getList().size()));
		}
		
		
	}
	//returns the index of hte most covering predicate
	return this.getList().indexOf(pTemp);

}
}
