package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatelists;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTuple;
import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatestructure.Predicate;


/**
 * Insert the type's description here.
 * Creation date: (1/9/2003 8:39:25 PM)
 * @author: Administrator
 */
public class PredOrderListS extends OrderListS implements Serializable{
	protected ArrayList PredOrderLists;
/**
 * PredOrderListS constructor comment.
 */
public PredOrderListS() {
	super();
}
/**
 * Deletes a predicate order list.
 * Creation date: (1/9/2003 8:43:57 PM)
 * @param predOrderList juggler.predicatelists.OrderList
 */
public void deletePredOrderList(OrderList predOrderList) {

	this.PredOrderLists.remove(predOrderList);
	
	}
/**
 * Inserts the predicate order list in the array of order lists.
 * Creation date: (1/9/2003 8:42:32 PM)
 * @param predOrderList juggler.predicatelists.OrderList
 */
public void insertPredOrderList(OrderList predOrderList) {

    this.PredOrderLists.add(predOrderList);
}
/**
 * Sets the array of predicate order lists.
 * Creation date: (1/9/2003 8:41:19 PM)
 * @param newPredOrderLists juggler.predicatelists.OrderList[]
 */
public void setPredOrderLists(ArrayList newPredOrderLists) {
	PredOrderLists = newPredOrderLists;
}

/**
 * Find most covering predicates for each predicate list in PredOrderLists.
 * ArrayList of BitPositions
 * Creation date: (1/9/2003 8:50:54 PM)
 * @param tuple juggler.stream.Tuple
 * @return ArrayList
 */
public ArrayList findMostCovering(JugglerTuple tuple) {
    ArrayList coveringBitPositions = new ArrayList();

    Iterator it = this.PredOrderLists.iterator();

    int setListIndex = 0;
    int setIndex = 0;

    while (it.hasNext()) {
        AttrPredOrderList olist = (AttrPredOrderList) it.next();
        setListIndex = olist.getListIndex();
        setIndex = olist.findMostCovering(tuple);
        if (setIndex >= 0) {
			BitPosition bp =
                new BitPosition(setListIndex, setIndex);
            coveringBitPositions.add(bp);
        }
    }

    return coveringBitPositions;
}

/**
 * Sets the predicate bits of the tuple.
 * Creation date: (1/9/2003 8:45:20 PM)
 * @param tuple juggler.stream.Tuple
 * @param ArrayList bitPositions
 */
public void setPredicates(JugglerTuple tuple, ArrayList bitPositions) {

	Iterator it = bitPositions.iterator();

	while (it.hasNext()) {
		BitPosition bp = (BitPosition) it.next();
			
	}
}
}
