package edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.predicatemanagers;

import java.util.Iterator;

import edu.wpi.cs.dsrg.xmldb.xat.component.operator.Juggler.JugglerTuple.JugglerTupleList;

/**
 * Insert the type's description here.
 * Creation date: (1/13/2003 11:05:28 AM)
 * @author: Administrator
 */
public interface IPredicateManager {

/**
 * Returns the selectivity of all of the predicate types (selectivity of the node)
 * Creation date: (1/13/2003 11:07:53 AM)
 * @return long
 */
double getSelectivity();

/**
 * Applies the predicates to the tuple.
 * Creation date: (1/13/2003 11:06:02 AM)
 * @param tuple juggler.stream.Tuple
 */
Iterator applyPredicates(JugglerTupleList tuples, Iterator setOfTuples);
}
