package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.client;

import java.io.IOException;

/**
 * @author
 * This class is just used to test the stream generator
 *
 */
public class StreamTester implements Listener{
	
/**
 * @param fileName
 */
public StreamTester(String fileName)
{
	try {
		XATStreamController mc = new StreamClient(fileName);
		mc.addListener(this);
		mc.startGeneratingStreams();
		mc.join();		
		
		} catch (InterruptedException e) {				
			e.printStackTrace();
		} catch (CannotServeStreamException e) {				
			e.printStackTrace();
		} catch (IOException e) {				
			e.printStackTrace();
		} catch (ServerNotFoundException e) {
			System.out.println("One or more servers could not be found.");
		}						

}

/**
 * 
 * @param args
 */
public static void main(String[] args) {
	if(args.length != 1)
	{
		System.out.println("Usage: MainClient <clientconfig.xml>");
	}
	StreamTester st = new StreamTester(args[0]);					
}

/**
 * @see edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.client.Listener#endOfStream()
 */
public void endOfStream() {
	System.out.println("-----End of Streams------");
}

}