package edu.wpi.cs.dsrg.xmldb.xat.component.streamgenerators.server;
/**
 * @author Administrator
 *
 * This interface is use to add clients to the Client pool 
 * and check for valid streams
 */
public interface PacketAdder {
	/**
	 * This method adds the clients to the stream Table
	 * @param s
	 * @param streamName
	 * @throws StreamNotFoundException
	 */
	public abstract void addClient(Client c, String streamName)
		throws StreamNotFoundException;
	
	/**
	 * This method returns a boolean value indicating whether
	 * the stream exists or not used by the acceptor
	 * @param streamName
	 */
	public abstract boolean isStream(String streamName);
			
		
}