package edu.wpi.cs.dsrg.xmldb.xat.testfiles;

/////////////////////////// COPYRIGHT /////////////////////////////////////
//
//  Rainbow 1.0 - XQuery Processing.
//
//  Copyright 2003, All Rights Reserved.
//
//  Permission to use, copy, modify and distribute this software and
//  its documentation for educational, research and non-profit
//  purposes, without fee, and without a written agreement is hereby
//  granted, provided that this copyright notice appear in all copies.
//
//  Permission to incorporate this software into commercial products
//  may be obtained directly from the authors.
//
//  This software is provided "as is" without express or implied warranty.
//  In no event will the authors be held liable for any damages arising
//  from the use of this software.
//
//  Authors:
//  Steffen Christ, Katica Dimitrova, Luping Ding, Michal A. Dobos,
//  Maged El-Sayed, Geoff Greene, Huzefa Hakimi, Justin Lutz, Guy D. Mann,
//  Mukesh Mulchandani, Brian Murphy, Bradford Pielech, Alex Proschitsky,
//  Elke A. Rundensteiner, Ling Wang, Song Wang, and Xin Zhang
//
//      Computer Science Department
//      Worcester Polytechnic Institute
//      Worcester, MA 01609 USA
//
//      http://davis.wpi.edu/~dsrg/rainbow/index.htm
//
//  Send bug reports, bug fixes, enhancements, requests, or comments to
//  the Rainbow Development Team: <rainbow@WPI.EDU>.
//
/////////////////////////// COPYRIGHT /////////////////////////////////////

/**
 * This Class is used to test.
 * @author  Rainbow Group, DSRG, WPI
 * @version RainbowCore 1.0
 * @since   1.0
 */

public class TestStrip {

/**
 * Insert the method's description here.
 * Creation date: (4/7/2003 2:58:24 PM)
 * @param args java.lang.String[]
 */
public static void main(String[] args) {
    String input =
        "SELECT DISTINCT \"s117010\".EDGES AS \"$col117011\", \"$songMap\".NAME AS \"$col117016\", \"s117017\".EDGES AS \"$col117018\", \"$playMap\".NAME AS \"$col117021\", \"$playMap\".TARGET AS \"$col117014\", \"$songMap\".SOURCE AS \"$col117013\", \"$songMap\".TARGET AS \"$col116003\", \"$songMap\".POSITION AS \"$col117007\"";

    String output = new String();
    String head = input.substring(0, input.indexOf("\""));
    String body = input.substring(input.indexOf("\""), input.length());
    try {
        while (body.length() > 0) {
            org.apache.regexp.RE reg =
                new org.apache.regexp.RE(
                    "(\"\\$?[$a-zA-Z0-9]*\".[a-zA-Z0-9]*) AS \"\\$[a-zA-Z0-9]*\"");
            boolean matched = reg.match(body);
            if (matched) {
	            String wholeMatch = reg.getParen(0);
                String column = reg.getParen(1);
                if((body.length() - wholeMatch.length())<= 0){
	                body ="";
                }else{
	            	body = body.substring(wholeMatch.length()+2, body.length());
                }
                output += column + ", ";
            }
        }
    } catch (Exception e) {
        e.printStackTrace();
    }
    if (!output.equals("")) {
        //remove the last ','
        output = output.substring(0, output.length() - 2);
    }

    output = head + output;

    System.out.println(output);
}
}
