/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */



/**
 * NodeTest.java
 *
 *
 * Created: Sun Jul 16 21:27:33 2000
 *
 * The interface is used to the bridge between packages quilt and xmltree.
 * xmltree does not have to be aware of quilt.
 *
 * @author Arnaud Sahuguet
 * @version
 */

package xacute.common;

public interface NodeTest

{
    /**
     * Tests if a <code>NodeTest</code>
     * is verified.
     * @param n    the node to test
     * @param axis a constant representing
     *             the axis-specifier (this
     *             constant is needed for
     *             a nametest, to distinguish between elements and attributes)
     */

    public boolean isTrue(Node n, int axis); 
    
} // NodeTest






