package xacute.quilt;

import xacute.common.Constants;
import xacute.common.Node;
import xacute.common.QuiltException;


/**
 * This class implements <i>Quilt</i>'s
 * <code>position()</code> primitive.
 * This is one of the few class that uses the <code>EvalContext</code>.
 */
public class FunCOLUMN
    extends FunPrimitive
{
   FunCOLUMN() {}
    Value eval(EvalContext con)
	throws QuiltException
    {
	if (con.getNode() == null)
	throw new QuiltSyntaxException("Function " + this.getName() + " called with no context");
	else
	    return new ValueNum(con.getPos() + 1);
    }
}
