/* Kweelt - a framework to query XML documents
 * Copyright (C) 2000,  Arnaud Sahuguet (Arnaud.Sahuguet@polytechnique.org)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


package xacute.quilt;


import xacute.common.Constants;
import xacute.common.QuiltException;

public class FunSUBST
    extends FunStringTemplate
{

    FunSUBST() { super(); }

    public String[] exec(String args[])
    throws QuiltException
    {
	if (args.length != 3)
	    throw new QuiltWrongArgNumberException(this.getName());
	char oldChar = args[0].charAt(0);
	char newChar = args[1].charAt(0);
	String str = args[2];
	String[] result = new String[1];
	result[0] = str.replace( oldChar, newChar);
	return result;
    }
}


